=== modified file '.bzrignore'
--- .bzrignore	2013-07-09 03:51:13 +0000
+++ .bzrignore	2013-07-23 02:24:45 +0000
@@ -27,8 +27,10 @@
 ./missing
 ./mkinstalldirs
 ./omf.make
+./test-driver
 ./xmldocs.make
 data/apparmor/lightdm-guest-session
+data/lightdm-guest-session
 doc/html
 doc/lightdm-gobject-*.*
 doc/*.stamp

=== modified file 'NEWS'
--- NEWS	2013-07-01 03:35:36 +0000
+++ NEWS	2013-07-22 23:04:21 +0000
@@ -1,3 +1,26 @@
+Overview of changes in lightdm 1.7.7
+
+    * Fix uninitialized pointer introduced in 1.7.3
+    * Enable compile warnings and fix code generating warnings
+
+Overview of changes in lightdm 1.7.6
+
+    * Restore greeter hints that were regressed in 1.7.5.
+    * Don't run greeters through session wrapper - regression in 1.7.5
+
+Overview of changes in lightdm 1.7.5
+
+    * Quit Plymouth correctly when using the unity seat type
+    * Release the VT when the system compositor fails to start
+    * Load sessions and greeters from /usr/share/lightdm/sessions and
+      /usr/share/lightdm/greeters. The existing directories are checked
+      if the sessions are not in these directories.
+    * Refactor the Display class so that it merges with the Seat class
+    * Support running the greeter and session in different display servers
+      instead of re-using the same one during a login.
+    * Add more regression tests
+    * Documentation fixes
+
 Overview of changes in lightdm 1.7.4
 
     * Set XDG_SEAT and XDG_VTNR environment variables.

=== modified file 'configure.ac'
--- configure.ac	2013-07-01 03:35:36 +0000
+++ configure.ac	2013-07-22 23:04:21 +0000
@@ -1,6 +1,6 @@
 dnl Process this file with autoconf to produce a configure script.
 
-AC_INIT(lightdm, 1.7.4)
+AC_INIT(lightdm, 1.7.7)
 AC_CONFIG_MACRO_DIR(m4)
 AC_CONFIG_HEADER(config.h)
 AM_INIT_AUTOMAKE([1.11 no-dist-gzip dist-xz foreign])
@@ -11,6 +11,21 @@
 AC_PROG_LIBTOOL
 AM_MAINTAINER_MODE
 
+dnl Enable compile warnings (only supporting GCC)
+if test "x$GCC" == xyes; then
+    WARN_CFLAGS="-Wall \
+                 -Wstrict-prototypes \
+                 -Wnested-externs \
+                 -Werror=missing-prototypes \
+                 -Werror=implicit-function-declaration \
+                 -Werror=pointer-arith \
+                 -Werror=init-self \
+                 -Werror=format-security \
+                 -Werror=format=2 \
+                 -Werror=missing-include-dirs"
+fi
+AC_SUBST(WARN_CFLAGS)
+
 GOBJECT_INTROSPECTION_CHECK(0.9.5)
 
 dnl ###########################################################################
@@ -22,7 +37,7 @@
 AC_CHECK_FUNCS(setresgid setresuid clearenv)
 
 PKG_CHECK_MODULES(LIGHTDM, [
-    glib-2.0 >= 2.24
+    glib-2.0 >= 2.30
     gio-2.0 >= 2.26
     gio-unix-2.0
     xdmcp
@@ -132,8 +147,6 @@
         [], [enable_tests="yes"])
 AM_CONDITIONAL(COMPILE_TESTS, test x"$enable_tests" != "xno")
 
-AC_PATH_PROG(GLIB_GENMARSHAL, glib-genmarshal)
-
 dnl ###########################################################################
 dnl Configurable values
 dnl ###########################################################################

=== modified file 'data/lightdm-set-defaults.1'
--- data/lightdm-set-defaults.1	2012-11-06 21:34:21 +0000
+++ data/lightdm-set-defaults.1	2013-07-16 23:26:21 +0000
@@ -49,7 +49,6 @@
 .TP
 .B /etc/lightdm/lightdm.conf
 Configuration
-.TP
 
 .sp
 .LP

=== modified file 'data/lightdm.conf'
--- data/lightdm.conf	2013-07-09 04:07:14 +0000
+++ data/lightdm.conf	2013-07-11 02:20:58 +0000
@@ -11,9 +11,9 @@
 # log-directory = Directory to log information to
 # run-directory = Directory to put running state in
 # cache-directory = Directory to cache to
-# xsessions-directory = Directory to find X sessions
+# sessions-directory = Directory to find sessions
 # remote-sessions-directory = Directory to find remote sessions
-# xgreeters-directory = Directory to find X greeters
+# greeters-directory = Directory to find greeters
 # disable-guest-wrapper = Disable using guest session wrapper (temporary? required to make tests work without installing)
 #
 [LightDM]
@@ -27,9 +27,9 @@
 #log-directory=/var/log/lightdm
 #run-directory=/var/run/lightdm
 #cache-directory=/var/cache/lightdm
-#xsessions-directory=/usr/share/xsessions
+#sessions-directory=/usr/share/lightdm/sessions:/usr/share/xsessions
 #remote-sessions-directory=/usr/share/lightdm/remote-sessions
-#xgreeters-directory=/usr/share/xgreeters
+#greeters-directory=/usr/share/lightdm/greeters:/usr/share/xgreeters
 #disable-guest-wrapper=false
 
 #

=== modified file 'doc/lightdm-gobject-1-sections.txt'
--- doc/lightdm-gobject-1-sections.txt	2013-07-09 05:32:31 +0000
+++ doc/lightdm-gobject-1-sections.txt	2013-07-23 02:24:45 +0000
@@ -62,6 +62,7 @@
 <SECTION>
 <FILE>session</FILE>
 <TITLE>Sessions</TITLE>
+lightdm_get_remote_sessions
 lightdm_get_sessions
 lightdm_session_get_key
 lightdm_session_get_session_type
@@ -82,11 +83,14 @@
 <FILE>user</FILE>
 <TITLE>User Accounts</TITLE>
 changed
+lightdm_user_get_background
 lightdm_user_get_display_name
+lightdm_user_get_has_messages
 lightdm_user_get_home_directory
 lightdm_user_get_image
 lightdm_user_get_language
 lightdm_user_get_layout
+lightdm_user_get_layouts
 lightdm_user_get_logged_in
 lightdm_user_get_name
 lightdm_user_get_real_name
@@ -129,16 +133,22 @@
 lightdm_greeter_connect_sync
 lightdm_greeter_get_default_session_hint
 lightdm_greeter_get_hint
+lightdm_greeter_get_lock_hint
 lightdm_greeter_get_has_guest_account_hint
 lightdm_greeter_get_hide_users_hint
+lightdm_greeter_get_show_manual_login_hint
+lightdm_greeter_get_show_remote_login_hint
 lightdm_greeter_get_select_user_hint
 lightdm_greeter_get_select_guest_hint
 lightdm_greeter_get_autologin_user_hint
 lightdm_greeter_get_autologin_guest_hint
 lightdm_greeter_get_autologin_timeout_hint
+lightdm_greeter_set_language
 lightdm_greeter_cancel_autologin
 lightdm_greeter_authenticate
 lightdm_greeter_authenticate_as_guest
+lightdm_greeter_authenticate_autologin
+lightdm_greeter_authenticate_remote
 lightdm_greeter_respond
 lightdm_greeter_cancel_authentication
 lightdm_greeter_get_in_authentication

=== modified file 'doc/tmpl/greeter.sgml'
--- doc/tmpl/greeter.sgml	2011-07-24 00:51:08 +0000
+++ doc/tmpl/greeter.sgml	2013-07-02 03:35:40 +0000
@@ -159,6 +159,15 @@
 @Returns: 
 
 
+<!-- ##### FUNCTION lightdm_greeter_get_lock_hint ##### -->
+<para>
+
+</para>
+
+@greeter: 
+@Returns: 
+
+
 <!-- ##### FUNCTION lightdm_greeter_get_has_guest_account_hint ##### -->
 <para>
 
@@ -177,6 +186,24 @@
 @Returns: 
 
 
+<!-- ##### FUNCTION lightdm_greeter_get_show_manual_login_hint ##### -->
+<para>
+
+</para>
+
+@greeter: 
+@Returns: 
+
+
+<!-- ##### FUNCTION lightdm_greeter_get_show_remote_login_hint ##### -->
+<para>
+
+</para>
+
+@greeter: 
+@Returns: 
+
+
 <!-- ##### FUNCTION lightdm_greeter_get_select_user_hint ##### -->
 <para>
 
@@ -222,6 +249,15 @@
 @Returns: 
 
 
+<!-- ##### FUNCTION lightdm_greeter_set_language ##### -->
+<para>
+
+</para>
+
+@greeter: 
+@language: 
+
+
 <!-- ##### FUNCTION lightdm_greeter_cancel_autologin ##### -->
 <para>
 
@@ -247,6 +283,24 @@
 @greeter: 
 
 
+<!-- ##### FUNCTION lightdm_greeter_authenticate_autologin ##### -->
+<para>
+
+</para>
+
+@greeter: 
+
+
+<!-- ##### FUNCTION lightdm_greeter_authenticate_remote ##### -->
+<para>
+
+</para>
+
+@greeter: 
+@session: 
+@username: 
+
+
 <!-- ##### FUNCTION lightdm_greeter_respond ##### -->
 <para>
 

=== modified file 'doc/tmpl/language.sgml'
--- doc/tmpl/language.sgml	2011-08-04 14:51:10 +0000
+++ doc/tmpl/language.sgml	2013-07-02 03:35:40 +0000
@@ -2,7 +2,7 @@
 Languages
 
 <!-- ##### SECTION Short_Description ##### -->
-Get information on available languges
+Get information on available languages
 
 <!-- ##### SECTION Long_Description ##### -->
 <para>

=== modified file 'doc/tmpl/session.sgml'
--- doc/tmpl/session.sgml	2013-07-09 05:32:31 +0000
+++ doc/tmpl/session.sgml	2013-07-23 02:24:45 +0000
@@ -20,6 +20,15 @@
 <!-- ##### SECTION Image ##### -->
 
 
+<!-- ##### FUNCTION lightdm_get_remote_sessions ##### -->
+<para>
+
+</para>
+
+@void: 
+@Returns: 
+
+
 <!-- ##### FUNCTION lightdm_get_sessions ##### -->
 <para>
 

=== modified file 'doc/tmpl/user.sgml'
--- doc/tmpl/user.sgml	2011-07-19 06:40:33 +0000
+++ doc/tmpl/user.sgml	2013-07-02 03:35:40 +0000
@@ -44,6 +44,15 @@
 @user: 
 
 
+<!-- ##### FUNCTION lightdm_user_get_background ##### -->
+<para>
+
+</para>
+
+@user: 
+@Returns: 
+
+
 <!-- ##### FUNCTION lightdm_user_get_display_name ##### -->
 <para>
 
@@ -53,6 +62,15 @@
 @Returns: 
 
 
+<!-- ##### FUNCTION lightdm_user_get_has_messages ##### -->
+<para>
+
+</para>
+
+@user: 
+@Returns: 
+
+
 <!-- ##### FUNCTION lightdm_user_get_home_directory ##### -->
 <para>
 
@@ -89,6 +107,15 @@
 @Returns: 
 
 
+<!-- ##### FUNCTION lightdm_user_get_layouts ##### -->
+<para>
+
+</para>
+
+@user: 
+@Returns: 
+
+
 <!-- ##### FUNCTION lightdm_user_get_logged_in ##### -->
 <para>
 

=== modified file 'liblightdm-gobject/Makefile.am'
--- liblightdm-gobject/Makefile.am	2013-07-09 05:32:31 +0000
+++ liblightdm-gobject/Makefile.am	2013-07-23 02:24:45 +0000
@@ -5,7 +5,7 @@
 liblightdm_gobject_1_la_CFLAGS = $(LIBLIGHTDM_GOBJECT_CFLAGS) \
 	$(WARN_CFLAGS) \
 	-DCONFIG_DIR=\"$(sysconfdir)/lightdm\" \
-	-DXSESSIONS_DIR=\"$(datadir)/xsessions\" \
+	-DSESSIONS_DIR=\"$(pkgdatadir)/sessions:$(datadir)/xsessions\" \
 	-DREMOTE_SESSIONS_DIR=\"$(pkgdatadir)/remote-sessions\"
 
 mainheader_HEADERS = lightdm.h

=== modified file 'liblightdm-gobject/greeter.c'
--- liblightdm-gobject/greeter.c	2013-07-09 05:32:31 +0000
+++ liblightdm-gobject/greeter.c	2013-07-23 02:24:45 +0000
@@ -1184,42 +1184,6 @@
 }
 
 static void
-marshal_VOID__STRING_INT (GClosure     *closure,
-                          GValue       *return_value G_GNUC_UNUSED,
-                          guint         n_param_values,
-                          const GValue *param_values,
-                          gpointer      invocation_hint G_GNUC_UNUSED,
-                          gpointer      marshal_data)
-{
-    typedef void (*GMarshalFunc_VOID__STRING_INT) (gpointer     data1,
-                                                   gpointer     arg_1,
-                                                   gint         arg_2,
-                                                   gpointer     data2);
-    register GMarshalFunc_VOID__STRING_INT callback;
-    register GCClosure *cc = (GCClosure*) closure;
-    register gpointer data1, data2;
-
-    g_return_if_fail (n_param_values == 3);
-
-    if (G_CCLOSURE_SWAP_DATA (closure))
-    {
-        data1 = closure->data;
-        data2 = g_value_peek_pointer (param_values + 0);
-    }
-    else
-    {
-        data1 = g_value_peek_pointer (param_values + 0);
-        data2 = closure->data;
-    }
-    callback = (GMarshalFunc_VOID__STRING_INT) (marshal_data ? marshal_data : cc->callback);
-
-    callback (data1,
-              (param_values + 1)->data[0].v_pointer,
-              (param_values + 2)->data[0].v_int,
-              data2);
-}
-
-static void
 lightdm_greeter_finalize (GObject *object)
 {
     LightDMGreeter *self = LIGHTDM_GREETER (object);
@@ -1375,7 +1339,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (LightDMGreeterClass, show_prompt),
                       NULL, NULL,
-                      marshal_VOID__STRING_INT,
+                      NULL,
                       G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_INT);
 
     /**
@@ -1393,7 +1357,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (LightDMGreeterClass, show_message),
                       NULL, NULL,
-                      marshal_VOID__STRING_INT,
+                      NULL,
                       G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_INT);
 
     /**
@@ -1412,7 +1376,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (LightDMGreeterClass, authentication_complete),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 
     /**
@@ -1428,6 +1392,6 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (LightDMGreeterClass, autologin_timer_expired),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 }

=== modified file 'liblightdm-gobject/lightdm/greeter.h'
--- liblightdm-gobject/lightdm/greeter.h	2013-07-09 05:32:31 +0000
+++ liblightdm-gobject/lightdm/greeter.h	2013-07-23 02:24:45 +0000
@@ -58,13 +58,13 @@
     void (*authentication_complete)(LightDMGreeter *greeter);
     void (*autologin_timer_expired)(LightDMGreeter *greeter);
 
-	/* Reserved */
-	void (*reserved1) (void);
-	void (*reserved2) (void);
-	void (*reserved3) (void);
-	void (*reserved4) (void);
-	void (*reserved5) (void);
-	void (*reserved6) (void);
+    /* Reserved */
+    void (*reserved1) (void);
+    void (*reserved2) (void);
+    void (*reserved3) (void);
+    void (*reserved4) (void);
+    void (*reserved5) (void);
+    void (*reserved6) (void);
 } LightDMGreeterClass;
 
 GType lightdm_greeter_get_type (void);

=== modified file 'liblightdm-gobject/lightdm/language.h'
--- liblightdm-gobject/lightdm/language.h	2013-04-23 03:07:03 +0000
+++ liblightdm-gobject/lightdm/language.h	2013-07-02 03:35:20 +0000
@@ -31,13 +31,13 @@
 {
     GObjectClass parent_class;
 
-	/* Reserved */
-	void (*reserved1) (void);
-	void (*reserved2) (void);
-	void (*reserved3) (void);
-	void (*reserved4) (void);
-	void (*reserved5) (void);
-	void (*reserved6) (void);
+    /* Reserved */
+    void (*reserved1) (void);
+    void (*reserved2) (void);
+    void (*reserved3) (void);
+    void (*reserved4) (void);
+    void (*reserved5) (void);
+    void (*reserved6) (void);
 } LightDMLanguageClass;
 
 GType lightdm_language_get_type (void);

=== modified file 'liblightdm-gobject/lightdm/layout.h'
--- liblightdm-gobject/lightdm/layout.h	2013-04-23 03:07:03 +0000
+++ liblightdm-gobject/lightdm/layout.h	2013-07-02 03:35:20 +0000
@@ -31,13 +31,13 @@
 {
     GObjectClass parent_class;
 
-	/* Reserved */
-	void (*reserved1) (void);
-	void (*reserved2) (void);
-	void (*reserved3) (void);
-	void (*reserved4) (void);
-	void (*reserved5) (void);
-	void (*reserved6) (void);
+    /* Reserved */
+    void (*reserved1) (void);
+    void (*reserved2) (void);
+    void (*reserved3) (void);
+    void (*reserved4) (void);
+    void (*reserved5) (void);
+    void (*reserved6) (void);
 } LightDMLayoutClass;
 
 GType lightdm_layout_get_type (void);

=== modified file 'liblightdm-gobject/lightdm/session.h'
--- liblightdm-gobject/lightdm/session.h	2013-07-09 05:32:31 +0000
+++ liblightdm-gobject/lightdm/session.h	2013-07-23 02:24:45 +0000
@@ -31,13 +31,13 @@
 {
     GObjectClass parent_class;
 
-	/* Reserved */
-	void (*reserved1) (void);
-	void (*reserved2) (void);
-	void (*reserved3) (void);
-	void (*reserved4) (void);
-	void (*reserved5) (void);
-	void (*reserved6) (void);
+    /* Reserved */
+    void (*reserved1) (void);
+    void (*reserved2) (void);
+    void (*reserved3) (void);
+    void (*reserved4) (void);
+    void (*reserved5) (void);
+    void (*reserved6) (void);
 } LightDMSessionClass;
 
 GType lightdm_session_get_type (void);

=== modified file 'liblightdm-gobject/lightdm/user.h'
--- liblightdm-gobject/lightdm/user.h	2013-04-23 03:07:03 +0000
+++ liblightdm-gobject/lightdm/user.h	2013-07-02 03:35:20 +0000
@@ -39,13 +39,13 @@
     GObjectClass parent_class;
     void (*changed)(LightDMUser *user);
 
-	/* Reserved */
-	void (*reserved1) (void);
-	void (*reserved2) (void);
-	void (*reserved3) (void);
-	void (*reserved4) (void);
-	void (*reserved5) (void);
-	void (*reserved6) (void);
+    /* Reserved */
+    void (*reserved1) (void);
+    void (*reserved2) (void);
+    void (*reserved3) (void);
+    void (*reserved4) (void);
+    void (*reserved5) (void);
+    void (*reserved6) (void);
 } LightDMUserClass;
 
 typedef struct
@@ -61,13 +61,13 @@
     void (*user_changed)(LightDMUserList *user_list, LightDMUser *user);
     void (*user_removed)(LightDMUserList *user_list, LightDMUser *user);
 
-	/* Reserved */
-	void (*reserved1) (void);
-	void (*reserved2) (void);
-	void (*reserved3) (void);
-	void (*reserved4) (void);
-	void (*reserved5) (void);
-	void (*reserved6) (void);
+    /* Reserved */
+    void (*reserved1) (void);
+    void (*reserved2) (void);
+    void (*reserved3) (void);
+    void (*reserved4) (void);
+    void (*reserved5) (void);
+    void (*reserved6) (void);
 } LightDMUserListClass;
 
 GType lightdm_user_list_get_type (void);

=== modified file 'liblightdm-gobject/session.c'
--- liblightdm-gobject/session.c	2013-07-09 05:32:31 +0000
+++ liblightdm-gobject/session.c	2013-07-23 02:24:45 +0000
@@ -114,10 +114,9 @@
 }
 
 static GList *
-load_sessions (const gchar *sessions_dir)
+load_sessions_dir (GList *sessions, const gchar *sessions_dir)
 {
     GDir *directory;
-    GList *sessions = NULL;
     GError *error = NULL;
 
     directory = g_dir_open (sessions_dir, 0, &error);
@@ -125,7 +124,7 @@
         g_warning ("Failed to open sessions directory: %s", error->message);
     g_clear_error (&error);
     if (!directory)
-        return NULL;
+        return sessions;
 
     while (TRUE)
     {
@@ -175,12 +174,27 @@
     return sessions;
 }
 
+static GList *
+load_sessions (const gchar *sessions_dir)
+{
+    GList *sessions = NULL;
+    gchar **dirs;
+    int i;
+
+    dirs = g_strsplit (sessions_dir, ":", -1);
+    for (i = 0; dirs[i]; i++)
+        sessions = load_sessions_dir (sessions, dirs[i]);
+    g_strfreev (dirs);
+  
+    return sessions;
+}
+
 static void
 update_sessions (void)
 {
     GKeyFile *config_key_file = NULL;
     gchar *config_path = NULL;
-    gchar *xsessions_dir;
+    gchar *sessions_dir;
     gchar *remote_sessions_dir;
     gchar *mir_sessions_dir;
     gboolean result;
@@ -189,7 +203,7 @@
     if (have_sessions)
         return;
 
-    xsessions_dir = g_strdup (XSESSIONS_DIR);
+    sessions_dir = g_strdup (SESSIONS_DIR);
     remote_sessions_dir = g_strdup (REMOTE_SESSIONS_DIR);
 
     /* Use session directory from configuration */
@@ -204,11 +218,11 @@
     {
         gchar *value;
       
-        value = g_key_file_get_string (config_key_file, "LightDM", "xsessions-directory", NULL);
+        value = g_key_file_get_string (config_key_file, "LightDM", "sessions-directory", NULL);
         if (value)
         {
-            g_free (xsessions_dir);
-            xsessions_dir = value;
+            g_free (sessions_dir);
+            sessions_dir = value;
         }
 
         value = g_key_file_get_string (config_key_file, "LightDM", "remote-sessions-directory", NULL);
@@ -221,10 +235,10 @@
     g_key_file_free (config_key_file);
     g_free (config_path);
 
-    local_sessions = load_sessions (xsessions_dir);
+    local_sessions = load_sessions (sessions_dir);
     remote_sessions = load_sessions (remote_sessions_dir);
 
-    g_free (xsessions_dir);
+    g_free (sessions_dir);
     g_free (remote_sessions_dir);
 
     have_sessions = TRUE;

=== modified file 'liblightdm-gobject/user.c'
--- liblightdm-gobject/user.c	2013-04-24 06:18:24 +0000
+++ liblightdm-gobject/user.c	2013-07-20 08:49:28 +0000
@@ -979,7 +979,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (LightDMUserListClass, user_added),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
+                      NULL,
                       G_TYPE_NONE, 1, LIGHTDM_TYPE_USER);
 
     /**
@@ -995,7 +995,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (LightDMUserListClass, user_changed),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
+                      NULL,
                       G_TYPE_NONE, 1, LIGHTDM_TYPE_USER);
 
     /**
@@ -1011,7 +1011,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (LightDMUserListClass, user_removed),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
+                      NULL,
                       G_TYPE_NONE, 1, LIGHTDM_TYPE_USER);
 }
 
@@ -1614,7 +1614,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (LightDMUserClass, changed),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 }
 

=== modified file 'po/af.po'
--- po/af.po	2013-07-02 05:18:49 +0000
+++ po/af.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/an.po'
--- po/an.po	2013-07-02 05:18:49 +0000
+++ po/an.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ar.po'
--- po/ar.po	2013-07-02 05:18:49 +0000
+++ po/ar.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ast.po'
--- po/ast.po	2013-07-02 05:18:49 +0000
+++ po/ast.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/az.po'
--- po/az.po	2013-07-02 05:18:49 +0000
+++ po/az.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/be.po'
--- po/be.po	2013-07-02 05:18:49 +0000
+++ po/be.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/bg.po'
--- po/bg.po	2013-07-02 05:18:49 +0000
+++ po/bg.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/bn.po'
--- po/bn.po	2013-07-02 05:18:49 +0000
+++ po/bn.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/bo.po'
--- po/bo.po	2013-07-02 05:18:49 +0000
+++ po/bo.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/br.po'
--- po/br.po	2013-07-02 05:18:49 +0000
+++ po/br.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/bs.po'
--- po/bs.po	2013-07-02 05:18:49 +0000
+++ po/bs.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ca.po'
--- po/ca.po	2013-07-02 05:18:49 +0000
+++ po/ca.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ca@valencia.po'
--- po/ca@valencia.po	2013-07-02 05:18:49 +0000
+++ po/ca@valencia.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ckb.po'
--- po/ckb.po	2013-07-02 05:18:49 +0000
+++ po/ckb.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/cs.po'
--- po/cs.po	2013-07-02 05:18:49 +0000
+++ po/cs.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/da.po'
--- po/da.po	2013-07-02 05:18:49 +0000
+++ po/da.po	2013-07-17 06:43:54 +0000
@@ -15,8 +15,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/de.po'
--- po/de.po	2013-07-02 05:18:49 +0000
+++ po/de.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/el.po'
--- po/el.po	2013-07-02 05:18:49 +0000
+++ po/el.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/en_AU.po'
--- po/en_AU.po	2013-07-02 05:18:49 +0000
+++ po/en_AU.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/en_CA.po'
--- po/en_CA.po	2013-07-02 05:18:49 +0000
+++ po/en_CA.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/en_GB.po'
--- po/en_GB.po	2013-07-02 05:18:49 +0000
+++ po/en_GB.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/eo.po'
--- po/eo.po	2013-07-02 05:18:49 +0000
+++ po/eo.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/es.po'
--- po/es.po	2013-07-02 05:18:49 +0000
+++ po/es.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/et.po'
--- po/et.po	2013-07-02 05:18:49 +0000
+++ po/et.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/eu.po'
--- po/eu.po	2013-07-02 05:18:49 +0000
+++ po/eu.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/fa.po'
--- po/fa.po	2013-07-02 05:18:49 +0000
+++ po/fa.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/fi.po'
--- po/fi.po	2013-07-02 05:18:49 +0000
+++ po/fi.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/fo.po'
--- po/fo.po	2013-07-02 05:18:49 +0000
+++ po/fo.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/fr.po'
--- po/fr.po	2013-07-02 05:18:49 +0000
+++ po/fr.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/fy.po'
--- po/fy.po	2013-07-02 05:18:49 +0000
+++ po/fy.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/gd.po'
--- po/gd.po	2013-07-02 05:18:49 +0000
+++ po/gd.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/gl.po'
--- po/gl.po	2013-07-02 05:18:49 +0000
+++ po/gl.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/gu.po'
--- po/gu.po	2013-07-02 05:18:49 +0000
+++ po/gu.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/he.po'
--- po/he.po	2013-07-02 05:18:49 +0000
+++ po/he.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/hi.po'
--- po/hi.po	2013-07-02 05:18:49 +0000
+++ po/hi.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/hr.po'
--- po/hr.po	2013-07-02 05:18:49 +0000
+++ po/hr.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/hu.po'
--- po/hu.po	2013-07-02 05:18:49 +0000
+++ po/hu.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ia.po'
--- po/ia.po	2013-07-02 05:18:49 +0000
+++ po/ia.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/id.po'
--- po/id.po	2013-07-02 05:18:49 +0000
+++ po/id.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/is.po'
--- po/is.po	2013-07-02 05:18:49 +0000
+++ po/is.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/it.po'
--- po/it.po	2013-07-02 05:18:49 +0000
+++ po/it.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ja.po'
--- po/ja.po	2013-07-02 05:18:49 +0000
+++ po/ja.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/kk.po'
--- po/kk.po	2013-07-02 05:18:49 +0000
+++ po/kk.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/km.po'
--- po/km.po	2013-07-02 05:18:49 +0000
+++ po/km.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/kn.po'
--- po/kn.po	2013-07-02 05:18:49 +0000
+++ po/kn.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ko.po'
--- po/ko.po	2013-07-02 05:18:49 +0000
+++ po/ko.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ku.po'
--- po/ku.po	2013-07-02 05:18:49 +0000
+++ po/ku.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/lb.po'
--- po/lb.po	2013-07-02 05:18:49 +0000
+++ po/lb.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/lt.po'
--- po/lt.po	2013-07-02 05:18:49 +0000
+++ po/lt.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/lv.po'
--- po/lv.po	2013-07-02 05:18:49 +0000
+++ po/lv.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/mhr.po'
--- po/mhr.po	2013-07-02 05:18:49 +0000
+++ po/mhr.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/mi.po'
--- po/mi.po	2013-07-02 05:18:49 +0000
+++ po/mi.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ml.po'
--- po/ml.po	2013-07-02 05:18:49 +0000
+++ po/ml.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/mr.po'
--- po/mr.po	2013-07-02 05:18:49 +0000
+++ po/mr.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ms.po'
--- po/ms.po	2013-07-02 05:18:49 +0000
+++ po/ms.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/my.po'
--- po/my.po	2013-07-02 05:18:49 +0000
+++ po/my.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/nb.po'
--- po/nb.po	2013-07-02 05:18:49 +0000
+++ po/nb.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/nl.po'
--- po/nl.po	2013-07-02 05:18:49 +0000
+++ po/nl.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/nn.po'
--- po/nn.po	2013-07-02 05:18:49 +0000
+++ po/nn.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/oc.po'
--- po/oc.po	2013-07-02 05:18:49 +0000
+++ po/oc.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/pa.po'
--- po/pa.po	2013-07-02 05:18:49 +0000
+++ po/pa.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/pl.po'
--- po/pl.po	2013-07-02 05:18:49 +0000
+++ po/pl.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/pt.po'
--- po/pt.po	2013-07-02 05:18:49 +0000
+++ po/pt.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/pt_BR.po'
--- po/pt_BR.po	2013-07-02 05:18:49 +0000
+++ po/pt_BR.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ro.po'
--- po/ro.po	2013-07-02 05:18:49 +0000
+++ po/ro.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ru.po'
--- po/ru.po	2013-07-02 05:18:49 +0000
+++ po/ru.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/sc.po'
--- po/sc.po	2013-07-02 05:18:49 +0000
+++ po/sc.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/sd.po'
--- po/sd.po	2013-07-02 05:18:49 +0000
+++ po/sd.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/shn.po'
--- po/shn.po	2013-07-02 05:18:49 +0000
+++ po/shn.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/si.po'
--- po/si.po	2013-07-02 05:18:49 +0000
+++ po/si.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/sk.po'
--- po/sk.po	2013-07-02 05:18:49 +0000
+++ po/sk.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/sl.po'
--- po/sl.po	2013-07-02 05:18:49 +0000
+++ po/sl.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/sq.po'
--- po/sq.po	2013-07-02 05:18:49 +0000
+++ po/sq.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/sr.po'
--- po/sr.po	2013-07-02 05:18:49 +0000
+++ po/sr.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 "Language: sr\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409

=== modified file 'po/sv.po'
--- po/sv.po	2013-07-02 05:18:49 +0000
+++ po/sv.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ta.po'
--- po/ta.po	2013-07-02 05:18:49 +0000
+++ po/ta.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/te.po'
--- po/te.po	2013-07-02 05:18:49 +0000
+++ po/te.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/tg.po'
--- po/tg.po	2013-07-02 05:18:49 +0000
+++ po/tg.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/th.po'
--- po/th.po	2013-07-02 05:18:49 +0000
+++ po/th.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/tl.po'
--- po/tl.po	2013-07-02 05:18:49 +0000
+++ po/tl.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/tr.po'
--- po/tr.po	2013-07-02 05:18:49 +0000
+++ po/tr.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/ug.po'
--- po/ug.po	2013-07-02 05:18:49 +0000
+++ po/ug.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/uk.po'
--- po/uk.po	2013-07-02 05:18:49 +0000
+++ po/uk.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/uz.po'
--- po/uz.po	2013-07-02 05:18:49 +0000
+++ po/uz.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/vi.po'
--- po/vi.po	2013-07-02 05:18:49 +0000
+++ po/vi.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/wae.po'
--- po/wae.po	2013-07-02 05:18:49 +0000
+++ po/wae.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/zh_CN.po'
--- po/zh_CN.po	2013-07-02 05:18:49 +0000
+++ po/zh_CN.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/zh_HK.po'
--- po/zh_HK.po	2013-07-02 05:18:49 +0000
+++ po/zh_HK.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'po/zh_TW.po'
--- po/zh_TW.po	2013-07-02 05:18:49 +0000
+++ po/zh_TW.po	2013-07-17 06:43:54 +0000
@@ -14,8 +14,8 @@
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 05:18+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-17 06:43+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: ../greeters/gtk/lightdm-gtk-greeter.c:409
 msgid "Are you sure you want to close all programs and restart the computer?"

=== modified file 'src/Makefile.am'
--- src/Makefile.am	2013-07-09 03:15:42 +0000
+++ src/Makefile.am	2013-07-23 02:24:45 +0000
@@ -1,11 +1,5 @@
 sbin_PROGRAMS = lightdm
 
-ldm-marshal.c: ldm-marshal.list
-	@GLIB_GENMARSHAL@ --prefix=ldm_marshal $(srcdir)/ldm-marshal.list --header --body > ldm-marshal.c
-
-ldm-marshal.h: ldm-marshal.list
-	@GLIB_GENMARSHAL@ --prefix=ldm_marshal $(srcdir)/ldm-marshal.list --header > ldm-marshal.h
-
 lightdm_SOURCES = \
 	accounts.c \
 	accounts.h \
@@ -13,8 +7,6 @@
 	configuration.h \
 	console-kit.c \
 	console-kit.h \
-	display.c \
-	display.h \
 	display-manager.c \
 	display-manager.h \
 	display-server.c \
@@ -26,8 +18,6 @@
 	guest-account.c \
 	guest-account.h \
 	lightdm.c \
-	ldm-marshal.c \
-	ldm-marshal.h \
 	login1.c \
 	login1.h \
 	mir-server.c \
@@ -69,6 +59,8 @@
 	xdmcp-session.c \
 	xdmcp-session.h \
 	xdmcp-session-private.h \
+	xgreeter.c \
+	xgreeter.h \
 	xserver-local.c \
 	xserver-local.h \
 	xserver-remote.c \
@@ -80,10 +72,6 @@
 	xsession.c \
 	xsession.h
 
-BUILT_SOURCES = \
-	ldm-marshal.c \
-	ldm-marshal.h
-
 lightdm_CFLAGS = \
 	$(LIGHTDM_CFLAGS) \
 	$(WARN_CFLAGS) \
@@ -93,9 +81,9 @@
 	-DLOG_DIR=\"$(localstatedir)/log/lightdm\" \
 	-DRUN_DIR=\"$(localstatedir)/run/lightdm\" \
 	-DCACHE_DIR=\"$(localstatedir)/cache/lightdm\" \
-	-DXSESSIONS_DIR=\"$(datadir)/xsessions\" \
+	-DSESSIONS_DIR=\"$(pkgdatadir)/sessions:$(datadir)/xsessions\" \
 	-DREMOTE_SESSIONS_DIR=\"$(pkgdatadir)/remote-sessions\" \
-	-DXGREETERS_DIR=\"$(datadir)/xgreeters\"
+	-DGREETERS_DIR=\"$(pkgdatadir)/greeters:$(datadir)/xgreeters\"
 
 lightdm_LDADD = \
 	$(LIGHTDM_LIBS) \
@@ -110,11 +98,8 @@
 	$(LIGHTDM_CFLAGS) \
 	$(WARN_CFLAGS)
 
-EXTRA_DIST = ldm-marshal.list \
+EXTRA_DIST = \
 	display-manager.xml
 
-CLEANFILES = \
-	$(BUILT_SOURCES)
-
 DISTCLEANFILES = \
 	Makefile.in

=== modified file 'src/display-manager.c'
--- src/display-manager.c	2013-06-21 03:23:11 +0000
+++ src/display-manager.c	2013-07-20 23:39:11 +0000
@@ -17,7 +17,6 @@
 
 #include "display-manager.h"
 #include "configuration.h"
-#include "display.h"
 #include "seat-xlocal.h"
 #include "seat-xremote.h"
 #include "seat-unity.h"
@@ -185,7 +184,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (DisplayManagerClass, seat_added),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
+                      NULL,
                       G_TYPE_NONE, 1, SEAT_TYPE);
     signals[SEAT_REMOVED] =
         g_signal_new ("seat-removed",
@@ -193,7 +192,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (DisplayManagerClass, seat_removed),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
+                      NULL,
                       G_TYPE_NONE, 1, SEAT_TYPE);
     signals[STOPPED] =
         g_signal_new ("stopped",
@@ -201,6 +200,6 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (DisplayManagerClass, stopped),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 }

=== modified file 'src/display-server.c'
--- src/display-server.c	2013-03-26 00:09:26 +0000
+++ src/display-server.c	2013-07-22 22:12:10 +0000
@@ -52,6 +52,18 @@
     return server->priv->name;
 }
 
+gint
+display_server_get_vt (DisplayServer *server)
+{
+    return DISPLAY_SERVER_GET_CLASS (server)->get_vt (server);
+}
+
+static gint
+display_server_real_get_vt (DisplayServer *server)
+{
+    return -1;
+}
+
 void
 display_server_set_start_local_sessions (DisplayServer *server, gboolean start_local_sessions)
 {
@@ -93,25 +105,18 @@
 }
 
 gboolean
-display_server_get_is_stopped (DisplayServer *server)
+display_server_get_is_stopping (DisplayServer *server)
 {
-    g_return_val_if_fail (server != NULL, TRUE);
-    return server->priv->stopped;
+    g_return_val_if_fail (server != NULL, FALSE);
+    return server->priv->stopping;
 }
 
 static void
 display_server_real_stop (DisplayServer *server)
 {
-    server->priv->stopped = TRUE;
     g_signal_emit (server, signals[STOPPED], 0);
 }
 
-static gboolean
-display_server_real_get_is_stopped (DisplayServer *server)
-{
-    return server->priv->stopped;
-}
-
 static void
 display_server_init (DisplayServer *server)
 {
@@ -122,6 +127,7 @@
 static void
 display_server_class_init (DisplayServerClass *klass)
 {
+    klass->get_vt = display_server_real_get_vt;
     klass->start = display_server_real_start;
     klass->stop = display_server_real_stop;
 
@@ -133,7 +139,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (DisplayServerClass, ready),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
     signals[STOPPED] =
         g_signal_new ("stopped",
@@ -141,6 +147,6 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (DisplayServerClass, stopped),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 }

=== modified file 'src/display-server.h'
--- src/display-server.h	2013-04-23 03:07:03 +0000
+++ src/display-server.h	2013-07-17 22:23:31 +0000
@@ -36,6 +36,7 @@
     void (*ready)(DisplayServer *server);
     void (*stopped)(DisplayServer *server);
 
+    gint (*get_vt)(DisplayServer *server);
     gboolean (*start)(DisplayServer *server);
     void (*stop)(DisplayServer *server);
 } DisplayServerClass;
@@ -46,6 +47,8 @@
 
 const gchar *display_server_get_name (DisplayServer *server);
 
+gint display_server_get_vt (DisplayServer *server);
+
 void display_server_set_start_local_sessions (DisplayServer *server, gboolean start_local_sessions);
 
 gboolean display_server_get_start_local_sessions (DisplayServer *server);
@@ -54,7 +57,7 @@
 
 void display_server_stop (DisplayServer *server);
 
-gboolean display_server_get_is_stopped (DisplayServer *server);
+gboolean display_server_get_is_stopping (DisplayServer *server);
 
 G_END_DECLS
 

=== removed file 'src/display.c'
--- src/display.c	2013-07-09 04:07:14 +0000
+++ src/display.c	1970-01-01 00:00:00 +0000
@@ -1,1128 +0,0 @@
-/* -*- Mode: C; indent-tabs-mode: nil; tab-width: 4 -*-
- *
- * Copyright (C) 2010-2011 Robert Ancell.
- * Author: Robert Ancell <robert.ancell@canonical.com>
- *
- * This program is free software: you can redistribute it and/or modify it under
- * the terms of the GNU General Public License as published by the Free Software
- * Foundation, either version 3 of the License, or (at your option) any later
- * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
- * license.
- */
-
-#include <config.h>
-#include <stdlib.h>
-#include <string.h>
-#include <gio/gdesktopappinfo.h>
-
-#include "display.h"
-#include "configuration.h"
-#include "ldm-marshal.h"
-#include "greeter.h"
-
-enum
-{
-    CREATE_SESSION,
-    READY,
-    SWITCH_TO_USER,
-    SWITCH_TO_GUEST,
-    GET_GUEST_USERNAME,
-    DISPLAY_SERVER_READY,
-    START_GREETER,
-    START_SESSION,
-    CREATE_DISPLAY,
-    STOPPED,
-    LAST_SIGNAL
-};
-static guint signals[LAST_SIGNAL] = { 0 };
-
-struct DisplayPrivate
-{
-    /* Display server */
-    DisplayServer *display_server;
-
-    /* TRUE if the session can run on the same display server as the greeter */
-    gboolean share_display_server;
-
-    /* Greeter session */
-    gchar *greeter_session;
-
-    /* TRUE if the user list should be shown */
-    gboolean greeter_hide_users;
-
-    /* TRUE if a manual login option should be shown */
-    gboolean greeter_show_manual_login;
-
-    /* TRUE if a remote login option should be shown */
-    gboolean greeter_show_remote_login;
-
-    /* TRUE if the greeter is a lock screen */
-    gboolean greeter_is_lock;
-
-    /* Session requested to log into */
-    SessionType user_session_type;
-    gchar *user_session;
-
-    /* Program to run sessions through */
-    gchar *session_wrapper;
-
-    /* Program to run greeter sessions through */
-    gchar *greeter_wrapper;
-
-    /* TRUE if in a user session */
-    gboolean in_user_session;
-
-    /* TRUE if have got an X server / started a greeter */
-    gboolean is_ready;
-
-    /* Session process */
-    Session *session;
-
-    /* Communication link to greeter */
-    Greeter *greeter;
-
-    /* User that should be automatically logged in */
-    gchar *autologin_user;
-    gboolean autologin_guest;
-    gint autologin_timeout;
-
-    /* TRUE if start greeter if fail to login */
-    gboolean start_greeter_if_fail;
-
-    /* Hint to select user in greeter */
-    gchar *select_user_hint;
-    gboolean select_guest_hint;
-    gboolean select_user_attempt_login;
-
-    /* TRUE if allowed to log into guest account */
-    gboolean allow_guest;
-
-    /* TRUE if greeter is to show the guest account */
-    gboolean greeter_allow_guest;
-
-    /* TRUE if stopping the display (waiting for dispaly server, greeter and session to stop) */
-    gboolean stopping;
-
-    /* TRUE if stopped */
-    gboolean stopped;
-};
-
-/* PAM services to use */
-#define GREETER_SERVICE   "lightdm-greeter"
-#define USER_SERVICE      "lightdm"
-#define AUTOLOGIN_SERVICE "lightdm-autologin"
-
-G_DEFINE_TYPE (Display, display, G_TYPE_OBJECT);
-
-static void greeter_session_stopped_cb (Session *session, Display *display);
-static void user_session_stopped_cb (Session *session, Display *display);
-
-Display *
-display_new (DisplayServer *display_server)
-{
-    Display *display;
-
-    g_return_val_if_fail (display_server != NULL, NULL);
-  
-    display = g_object_new (DISPLAY_TYPE, NULL);
-    display->priv->display_server = g_object_ref (display_server);
-
-    return display;
-}
-
-DisplayServer *
-display_get_display_server (Display *display)
-{
-    g_return_val_if_fail (display != NULL, NULL);
-    return display->priv->display_server;
-}
-
-void
-display_set_share_display_server (Display *display, gboolean share_display_server)
-{
-    g_return_if_fail (display != NULL);
-    display->priv->share_display_server = share_display_server;
-}
-
-const gchar *
-display_get_username (Display *display)
-{
-    g_return_val_if_fail (display != NULL, NULL);
-
-    if (!display->priv->session || !display->priv->in_user_session)
-        return NULL;
-
-    return session_get_username (display->priv->session);
-}
-
-Session *
-display_get_session (Display *display)
-{
-    g_return_val_if_fail (display != NULL, NULL);
-    return display->priv->session;
-}
-
-void
-display_set_greeter_session (Display *display, const gchar *greeter_session)
-{
-    g_return_if_fail (display != NULL);
-    g_free (display->priv->greeter_session);
-    display->priv->greeter_session = g_strdup (greeter_session);
-}
-
-void
-display_set_session_wrapper (Display *display, const gchar *session_wrapper)
-{
-    g_return_if_fail (display != NULL);
-    g_free (display->priv->session_wrapper);
-    display->priv->session_wrapper = g_strdup (session_wrapper);
-}
-
-void
-display_set_greeter_wrapper (Display *display, const gchar *greeter_wrapper)
-{
-    g_return_if_fail (display != NULL);
-    g_free (display->priv->greeter_wrapper);
-    display->priv->greeter_wrapper = g_strdup (greeter_wrapper);
-}
-
-void
-display_set_allow_guest (Display *display, gboolean allow_guest)
-{
-    g_return_if_fail (display != NULL);
-    display->priv->allow_guest = allow_guest;
-}
-
-void
-display_set_greeter_allow_guest (Display *display, gboolean greeter_allow_guest)
-{
-    g_return_if_fail (display != NULL);
-    display->priv->greeter_allow_guest = greeter_allow_guest;
-}
-
-void
-display_set_autologin_user (Display *display, const gchar *username, gboolean is_guest, gint timeout)
-{
-    g_return_if_fail (display != NULL);
-    g_free (display->priv->autologin_user);
-    display->priv->autologin_user = g_strdup (username);
-    display->priv->autologin_guest = is_guest;
-    display->priv->autologin_timeout = timeout;
-}
-
-void
-display_set_select_user_hint (Display *display, const gchar *username, gboolean is_guest, gboolean attempt_login)
-{
-    g_return_if_fail (display != NULL);
-    g_free (display->priv->select_user_hint);
-    display->priv->select_user_hint = g_strdup (username);
-    display->priv->select_guest_hint = is_guest;
-    display->priv->select_user_attempt_login = attempt_login;
-}
-
-void
-display_set_hide_users_hint (Display *display, gboolean hide_users)
-{
-    g_return_if_fail (display != NULL);
-    display->priv->greeter_hide_users = hide_users;
-}
-
-void
-display_set_show_manual_login_hint (Display *display, gboolean show_manual_login)
-{
-    g_return_if_fail (display != NULL);
-    display->priv->greeter_show_manual_login = show_manual_login;
-}
-
-void
-display_set_show_remote_login_hint (Display *display, gboolean show_remote_login)
-{
-    g_return_if_fail (display != NULL);
-    display->priv->greeter_show_remote_login = show_remote_login;
-}
-
-void
-display_set_lock_hint (Display *display, gboolean is_lock)
-{
-    g_return_if_fail (display != NULL);
-    display->priv->greeter_is_lock = is_lock;
-}
-
-void
-display_set_user_session (Display *display, SessionType type, const gchar *session_name)
-{
-    g_return_if_fail (display != NULL);
-    g_free (display->priv->user_session);
-    display->priv->user_session_type = type;
-    display->priv->user_session = g_strdup (session_name);
-}
-
-static void
-display_set_is_ready (Display *display)
-{
-    if (display->priv->is_ready)
-        return;
-
-    display->priv->is_ready = TRUE;
-    g_signal_emit (display, signals[READY], 0);
-}
-
-static gboolean
-switch_to_user (Display *display, User *user)
-{
-    gboolean result;
-    g_signal_emit (display, signals[SWITCH_TO_USER], 0, user, &result);
-    return result;
-}
-
-static gboolean
-switch_to_guest (Display *display)
-{
-    gboolean result;
-    g_signal_emit (display, signals[SWITCH_TO_GUEST], 0, &result);
-    return result;
-}
-
-static gchar *
-get_guest_username (Display *display)
-{
-    gchar *username;
-    g_signal_emit (display, signals[GET_GUEST_USERNAME], 0, &username);
-    return username;
-}
-
-static Session *
-create_session (Display *display)
-{
-    Session *session;
-
-    g_signal_emit (display, signals[CREATE_SESSION], 0, &session);
-    if (!session)
-        return NULL;
-    session_set_display_server (session, display->priv->display_server);
-
-    /* Connect using the session bus */
-    if (getuid () != 0)
-    {
-        if (g_getenv ("DBUS_SESSION_BUS_ADDRESS"))
-            session_set_env (session, "DBUS_SESSION_BUS_ADDRESS", g_getenv ("DBUS_SESSION_BUS_ADDRESS"));
-        session_set_env (session, "LDM_BUS", "SESSION");
-        if (g_getenv ("LD_PRELOAD"))
-            session_set_env (session, "LD_PRELOAD", g_getenv ("LD_PRELOAD"));
-        if (g_getenv ("LD_LIBRARY_PATH"))
-            session_set_env (session, "LD_LIBRARY_PATH", g_getenv ("LD_LIBRARY_PATH"));
-        if (g_getenv ("PATH"))
-            session_set_env (session, "PATH", g_getenv ("PATH"));
-    }
-
-    /* Variables required for regression tests */
-    if (g_getenv ("LIGHTDM_TEST_ROOT"))
-    {
-        session_set_env (session, "LIGHTDM_TEST_ROOT", g_getenv ("LIGHTDM_TEST_ROOT"));
-        session_set_env (session, "DBUS_SYSTEM_BUS_ADDRESS", g_getenv ("DBUS_SYSTEM_BUS_ADDRESS"));
-        session_set_env (session, "DBUS_SESSION_BUS_ADDRESS", g_getenv ("DBUS_SESSION_BUS_ADDRESS"));
-        session_set_env (session, "LD_PRELOAD", g_getenv ("LD_PRELOAD"));
-        session_set_env (session, "LD_LIBRARY_PATH", g_getenv ("LD_LIBRARY_PATH"));
-        session_set_env (session, "GI_TYPELIB_PATH", g_getenv ("GI_TYPELIB_PATH"));
-    }
-
-    return session;
-}
-
-static void
-destroy_session (Display *display)
-{
-    if (!display->priv->session)
-        return;
-
-    g_signal_handlers_disconnect_matched (display->priv->session, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, display);
-    session_stop (display->priv->session);
-    g_object_unref (display->priv->session);
-    display->priv->session = NULL;
-}
-
-static void
-greeter_authentication_complete_cb (Session *session, Display *display)
-{
-    gboolean result = FALSE;
-
-    if (display->priv->stopping)
-        return;
-
-    if (session_get_is_authenticated (session))
-    {
-        g_debug ("Greeter authorized");
-        g_signal_emit (display, signals[START_GREETER], 0, &result);
-        result = !result;
-    }
-    else
-        g_debug ("Greeter failed authentication");
-
-    if (!result)
-    {
-        g_debug ("Greeter failed to start");
-        display_stop (display);
-    }
-}
-
-static void
-greeter_connected_cb (Greeter *greeter, Display *display)
-{
-    // FIXME: Should wait for greeter to signal completely ready if it supports it
-    g_debug ("Greeter connected, display is ready");
-    display_set_is_ready (display);
-}
-
-static Session *
-greeter_start_authentication_cb (Greeter *greeter, const gchar *username, Display *display)
-{
-    return create_session (display);
-}
-
-static Display *
-create_display (Display *display, Session *session)
-{
-    Display *d;
-
-    g_signal_emit (display, signals[CREATE_DISPLAY], 0, session, &d);
-
-    return d;
-}
-
-static gboolean
-greeter_start_session_cb (Greeter *greeter, SessionType type, const gchar *session_name, Display *display)
-{
-    /* If no session requested, use the previous one */
-    if (!session_name && !greeter_get_guest_authenticated (greeter))
-    {
-        User *user;
-
-        user = session_get_user (greeter_get_authentication_session (greeter));
-        type = SESSION_TYPE_LOCAL;
-        session_name = user_get_xsession (user);
-    }
-
-    /* If a session was requested, override the default */
-    if (session_name)
-    {
-        g_debug ("Using session %s", session_name);
-        display_set_user_session (display, type, session_name);
-    }
-
-    /* Stop this display if that session already exists and can switch to it */
-    if (greeter_get_guest_authenticated (greeter))
-    {
-        if (switch_to_guest (display))
-            return TRUE;
-
-        /* Set to login as guest */
-        display_set_autologin_user (display, NULL, TRUE, 0);
-    }
-    else
-    {
-        if (switch_to_user (display, session_get_user (greeter_get_authentication_session (display->priv->greeter))))
-            return TRUE;
-    }
-
-    /* If we can re-use this display server, then stop the greeter and start the session when it is done */
-    if (display->priv->share_display_server)
-    {
-        g_debug ("Stopping greeter");
-        session_stop (display->priv->session);
-    }
-    else
-        create_display (display, greeter_get_authentication_session (greeter));
-
-    return TRUE;
-}
-
-static gboolean
-start_greeter (Display *display)
-{
-    gchar *greeter_user;
-    gboolean result;
-
-    destroy_session (display);
-    display->priv->session = create_session (display);
-    session_set_class (display->priv->session, XDG_SESSION_CLASS_GREETER);
-    g_signal_connect (display->priv->session, "authentication-complete", G_CALLBACK (greeter_authentication_complete_cb), display);
-
-    /* Make communication link to greeter that will run on this session */
-    display->priv->greeter = greeter_new (display->priv->session, USER_SERVICE, AUTOLOGIN_SERVICE);
-    g_signal_connect (G_OBJECT (display->priv->greeter), "connected", G_CALLBACK (greeter_connected_cb), display);
-    g_signal_connect (G_OBJECT (display->priv->greeter), "start-authentication", G_CALLBACK (greeter_start_authentication_cb), display);
-    g_signal_connect (G_OBJECT (display->priv->greeter), "start-session", G_CALLBACK (greeter_start_session_cb), display);
-    if (display->priv->autologin_timeout)
-    {
-        gchar *value = g_strdup_printf ("%d", display->priv->autologin_timeout);
-        greeter_set_hint (display->priv->greeter, "autologin-timeout", value);
-        g_free (value);
-        if (display->priv->autologin_user)
-            greeter_set_hint (display->priv->greeter, "autologin-user", display->priv->autologin_user);
-        else if (display->priv->autologin_guest)
-            greeter_set_hint (display->priv->greeter, "autologin-guest", "true");
-    }
-    if (display->priv->select_user_hint)
-        greeter_set_hint (display->priv->greeter, "select-user", display->priv->select_user_hint);
-    else if (display->priv->select_guest_hint)
-        greeter_set_hint (display->priv->greeter, "select-guest", "true");
-    greeter_set_hint (display->priv->greeter, "default-session", display->priv->user_session);
-    greeter_set_allow_guest (display->priv->greeter, display->priv->allow_guest);
-    greeter_set_hint (display->priv->greeter, "has-guest-account", (display->priv->allow_guest && display->priv->greeter_allow_guest) ? "true" : "false");
-    greeter_set_hint (display->priv->greeter, "hide-users", display->priv->greeter_hide_users ? "true" : "false");
-    greeter_set_hint (display->priv->greeter, "show-manual-login", display->priv->greeter_show_manual_login ? "true" : "false");
-    greeter_set_hint (display->priv->greeter, "show-remote-login", display->priv->greeter_show_remote_login ? "true" : "false");
-    if (display->priv->greeter_is_lock)
-        greeter_set_hint (display->priv->greeter, "lock-screen", "true");
-
-    /* Run greeter as unprivileged user */
-    if (getuid () != 0)
-    {
-        User *user;
-        user = accounts_get_current_user ();
-        greeter_user = g_strdup (user_get_name (user));
-        g_object_unref (user);
-    }
-    else
-    {
-        greeter_user = config_get_string (config_get_instance (), "LightDM", "greeter-user");
-        if (!greeter_user)
-        {
-            g_warning ("Greeter must not be run as root");
-            display_stop (display);
-            return FALSE;
-        }
-    }
-
-    g_signal_connect_after (display->priv->session, "stopped", G_CALLBACK (greeter_session_stopped_cb), display);
-    result = greeter_start (display->priv->greeter, GREETER_SERVICE, greeter_user);
-    g_free (greeter_user);
-
-    if (!result)
-        display_stop (display);
-
-    return result;
-}
-
-static void
-autologin_authentication_complete_cb (Session *session, Display *display)
-{
-    gboolean result = FALSE;
-
-    if (display->priv->stopping)
-        return;
-
-    if (session_get_is_authenticated (session))
-    {
-        const gchar *session_name;
-
-        g_debug ("Autologin user %s authorized", session_get_username (session));
-
-        session_name = user_get_xsession (session_get_user (session));
-        if (session_name)
-        {
-            g_debug ("Autologin using session %s", session_name);
-            display_set_user_session (display, SESSION_TYPE_LOCAL, session_name);
-        }
-
-        g_signal_emit (display, signals[START_SESSION], 0, &result);
-        result = !result;
-    }
-    else
-        g_debug ("Autologin failed authentication");
-
-    if (!result)
-    {
-        if (display->priv->start_greeter_if_fail)
-            start_greeter (display);
-        else
-            display_stop (display);
-    }
-}
-
-static gboolean
-autologin (Display *display, const gchar *username, const gchar *service, gboolean start_greeter_if_fail, gboolean is_guest)
-{
-    display->priv->start_greeter_if_fail = start_greeter_if_fail;
-
-    display->priv->in_user_session = TRUE;
-    destroy_session (display);
-    display->priv->session = create_session (display);
-    g_signal_connect (display->priv->session, "authentication-complete", G_CALLBACK (autologin_authentication_complete_cb), display);
-    g_signal_connect_after (display->priv->session, "stopped", G_CALLBACK (user_session_stopped_cb), display);
-    return session_start (display->priv->session, service, username, TRUE, FALSE, is_guest);
-}
-
-static gboolean
-autologin_guest (Display *display, const gchar *service, gboolean start_greeter_if_fail)
-{
-    gchar *username;
-    gboolean result;
-
-    username = get_guest_username (display);
-    if (!username)
-    {
-        g_debug ("Can't autologin guest, no guest account");
-        return FALSE;
-    }
-
-    result = autologin (display, username, service, start_greeter_if_fail, TRUE);
-    g_free (username);
-
-    return result;
-}
-
-static gchar **
-get_session_command (const gchar *filename, const gchar *session_wrapper)
-{
-    GKeyFile *session_desktop_file;
-    gboolean result;
-    int argc;
-    gchar *command = NULL, **argv, *path;
-    GError *error = NULL;
-
-    /* Read the command from the .desktop file */
-    session_desktop_file = g_key_file_new ();
-    result = g_key_file_load_from_file (session_desktop_file, filename, G_KEY_FILE_NONE, &error);
-    if (error)
-        g_debug ("Failed to load session file %s: %s", filename, error->message);
-    g_clear_error (&error);
-    if (result)
-    {
-        command = g_key_file_get_string (session_desktop_file, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_EXEC, NULL);
-        if (!command)
-            g_debug ("No command in session file %s", filename);
-    }
-    g_key_file_free (session_desktop_file);
-
-    if (!command)
-        return NULL;
-
-    /* If configured, run sessions through a wrapper */
-    if (session_wrapper)
-    {
-        argv = g_malloc (sizeof (gchar *) * 3);
-        path = g_find_program_in_path (session_wrapper);
-        argv[0] = path ? path : g_strdup (session_wrapper);
-        argv[1] = command;
-        argv[2] = NULL;
-        return argv;
-    }
-
-    /* Split command into an array listing and make command absolute */
-    result = g_shell_parse_argv (command, &argc, &argv, &error);
-    if (error)
-        g_debug ("Invalid session command '%s': %s", command, error->message);
-    g_clear_error (&error);
-    g_free (command);
-    if (!result)
-        return NULL;
-    path = g_find_program_in_path (argv[0]);
-    if (path)
-    {
-        g_free (argv[0]);
-        argv[0] = path;
-    }
-  
-    return argv;
-}
-
-static void
-prepend_argv (gchar ***argv, const gchar *value)
-{
-    gchar **old_argv, **new_argv;
-    gint i;
-
-    old_argv = *argv;
-    new_argv = g_malloc (sizeof (gchar *) * (g_strv_length (*argv) + 2));
-    new_argv[0] = g_strdup (value);
-    for (i = 0; old_argv[i]; i++)
-        new_argv[i + 1] = old_argv[i];
-    new_argv[i + 1] = NULL;
-
-    g_free (*argv);
-    *argv = new_argv;
-}
-
-static void
-greeter_session_stopped_cb (Session *session, Display *display)
-{
-    gboolean result = FALSE;
-
-    g_debug ("Greeter quit");
-
-    destroy_session (display);
-
-    if (display->priv->stopping)
-    {
-        display_stop (display);
-        return;
-    }
-
-    if (display_server_get_is_stopped (display->priv->display_server))
-        return;
-
-    /* Start the session for the authenticated user */
-    if (greeter_get_start_session (display->priv->greeter))
-    {
-        /* If guest, then start a new autologin guest session (so can setup account) */
-        if (greeter_get_guest_authenticated (display->priv->greeter))
-            result = autologin_guest (display, AUTOLOGIN_SERVICE, FALSE);
-        /* Otherwise, use the session the greeter has authenticated */
-        else
-        {
-            destroy_session (display);
-            display->priv->session = g_object_ref (greeter_get_authentication_session (display->priv->greeter));
-            g_signal_connect_after (display->priv->session, "stopped", G_CALLBACK (user_session_stopped_cb), display);
-            display->priv->in_user_session = TRUE;
-            g_signal_emit (display, signals[START_SESSION], 0, &result);
-            result = !result;
-        }
-    }
-
-    /* Destroy the greeter */
-    g_signal_handlers_disconnect_matched (display->priv->greeter, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, display);
-    g_object_unref (display->priv->greeter);
-    display->priv->greeter = NULL;
-
-    if (!result)
-    {
-        g_debug ("Failed to start greeter");
-        display_stop (display);
-    }
-}
-
-static gboolean
-display_start_greeter (Display *display)
-{
-    gchar *log_dir, *filename, *log_filename, *sessions_dir, *path, *wrapper;
-    gchar **argv;
-
-    /* Log the output of the greeter to a system location */
-    log_dir = config_get_string (config_get_instance (), "LightDM", "log-directory");
-    filename = g_strdup_printf ("%s-greeter.log", display_server_get_name (display->priv->display_server));
-    log_filename = g_build_filename (log_dir, filename, NULL);
-    g_free (log_dir);
-    g_free (filename);
-    g_debug ("Logging to %s", log_filename);
-    session_set_log_file (display->priv->session, log_filename);
-    g_free (log_filename);
-
-    /* Load the greeter session information */
-    sessions_dir = config_get_string (config_get_instance (), "LightDM", "xgreeters-directory");
-    filename = g_strdup_printf ("%s.desktop", display->priv->greeter_session);
-    path = g_build_filename (sessions_dir, filename, NULL);
-    g_free (sessions_dir);
-    g_free (filename);
-    argv = get_session_command (path, NULL);
-    g_free (path);
-    if (!argv)
-        return TRUE;
-
-    if (display->priv->greeter_wrapper)
-    {
-        gchar *path;
-        path = g_find_program_in_path (display->priv->greeter_wrapper);
-        prepend_argv (&argv, path ? path : display->priv->greeter_wrapper);
-        g_free (path);
-    }
-
-    session_run (display->priv->session, argv);
-
-    return FALSE;
-}
-
-static void
-user_session_stopped_cb (Session *session, Display *display)
-{
-    g_debug ("User session quit");
-
-    destroy_session (display);
-
-    /* This display has ended */
-    display_stop (display);
-}
-
-static gboolean
-display_start_session (Display *display)
-{
-    User *user;
-    gchar *filename, *sessions_dir, *path;
-    const gchar *language;
-    gchar **argv;
-    gboolean disable_guest_wrapper;
-
-    user = session_get_user (display->priv->session);
-
-    /* Find the command to run for the selected session */
-    if (display->priv->user_session_type == SESSION_TYPE_LOCAL)
-    {
-        sessions_dir = config_get_string (config_get_instance (), "LightDM", "xsessions-directory");
-
-        /* Store this session name so we automatically use it next time */
-        user_set_xsession (user, display->priv->user_session);
-    }
-    else
-        sessions_dir = config_get_string (config_get_instance (), "LightDM", "remote-sessions-directory");
-    filename = g_strdup_printf ("%s.desktop", display->priv->user_session);
-    path = g_build_filename (sessions_dir, filename, NULL);
-    g_free (sessions_dir);
-    g_free (filename);
-    argv = get_session_command (path, display->priv->session_wrapper);
-    g_free (path);
-    if (!argv)
-        return TRUE;
-  
-    /* Retrieve language setting */
-    language = user_get_language (user);
-    if (language != NULL && language != '\0')
-    {
-        session_set_env (display->priv->session, "LANG", language);
-        session_set_env (display->priv->session, "GDM_LANG", language);
-    }
-
-    session_set_env (display->priv->session, "DESKTOP_SESSION", display->priv->user_session); // FIXME: Apparently deprecated?
-    session_set_env (display->priv->session, "GDMSESSION", display->priv->user_session); // FIXME: Not cross-desktop
-
-    /* Run a guest session through the wrapper covered by MAC */
-    disable_guest_wrapper = config_get_boolean (config_get_instance (), "LightDM", "disable-guest-wrapper");
-    if (display->priv->autologin_guest && !disable_guest_wrapper)
-    {
-        gchar *wrapper = g_build_filename (PKGLIBEXEC_DIR, "lightdm-guest-session-wrapper", NULL);
-        g_debug ("Running guest session through wrapper: %s", wrapper);
-        prepend_argv (&argv, wrapper);
-        g_free (wrapper);
-    }
-
-    g_debug ("Starting session %s as user %s", display->priv->user_session, session_get_username (display->priv->session));
-
-    session_run (display->priv->session, argv);
-    g_strfreev (argv);
-
-    // FIXME: Wait for session to indicate it is ready (maybe)
-    display_set_is_ready (display);
-
-    return FALSE;
-}
-
-static void
-display_server_stopped_cb (DisplayServer *server, Display *display)
-{
-    g_debug ("Display server stopped");
-
-    /* Stop this display, it will be restarted by the seat if necessary */
-    display_stop (display);
-}
-
-static void
-display_server_ready_cb (DisplayServer *display_server, Display *display)
-{
-    gboolean result = FALSE;
-
-    g_signal_emit (display, signals[DISPLAY_SERVER_READY], 0, &result);
-    if (!result)
-    {
-        display_stop (display);
-        return;
-    }
-
-    /* If already have a session, run it */
-    if (display->priv->session != NULL)
-    {
-        if (display_start_session (display))
-            display_stop (display);
-        return;
-    }
-
-    /* Don't run any sessions on local terminals */
-    if (!display_server_get_start_local_sessions (display_server))
-        return;
-
-    /* Automatically start requested user session */
-    result = FALSE;
-    if (display->priv->autologin_timeout == 0 && display->priv->autologin_guest)
-    {
-        g_debug ("Automatically logging in as guest");
-        result = autologin_guest (display, AUTOLOGIN_SERVICE, TRUE);
-    }
-    else if (display->priv->autologin_timeout == 0 && display->priv->autologin_user)
-    {
-        g_debug ("Automatically logging in user %s", display->priv->autologin_user);
-        result = autologin (display, display->priv->autologin_user, AUTOLOGIN_SERVICE, TRUE, FALSE);
-    }
-    else if (display->priv->select_user_hint && display->priv->select_user_attempt_login)
-    {
-        g_debug ("Logging in user %s", display->priv->select_user_hint);
-        result = autologin (display, display->priv->select_user_hint, USER_SERVICE, TRUE, FALSE);
-    }
-
-    /* If no session started, start a greeter */
-    if (!result)
-    {
-        g_debug ("Starting greeter");      
-        result = start_greeter (display);
-    }
-
-    /* If nothing started, then the display can't work */
-    if (!result)
-        display_stop (display);
-}
-
-gboolean
-display_start (Display *display)
-{
-    g_return_val_if_fail (display != NULL, FALSE);
-
-    g_signal_connect (G_OBJECT (display->priv->display_server), "ready", G_CALLBACK (display_server_ready_cb), display);
-    g_signal_connect (G_OBJECT (display->priv->display_server), "stopped", G_CALLBACK (display_server_stopped_cb), display);
-
-    if (!display_server_start (display->priv->display_server))
-        return FALSE;
-
-    return TRUE;
-}
-
-gboolean
-display_start_with_session (Display *display, Session *session)
-{
-    g_return_val_if_fail (display != NULL, FALSE);
-    g_return_val_if_fail (session != NULL, FALSE);
-
-    display->priv->session = g_object_ref (session);
-    g_signal_connect_after (display->priv->session, "stopped", G_CALLBACK (user_session_stopped_cb), display);
-    session_set_display_server (session, display->priv->display_server);
-
-    return display_start (display);
-}
-
-gboolean
-display_get_is_ready (Display *display)
-{
-    g_return_val_if_fail (display != NULL, FALSE);
-
-    return display->priv->is_ready;
-}
-
-void
-display_lock (Display *display)
-{
-    g_return_if_fail (display != NULL);
-
-    if (!display->priv->session)
-        return;
-
-    g_debug ("Locking display");
-
-    session_lock (display->priv->session);
-}
-
-void
-display_unlock (Display *display)
-{
-    g_return_if_fail (display != NULL);
-
-    if (!display->priv->session)
-        return;
-
-    g_debug ("Unlocking display");
-
-    session_unlock (display->priv->session);
-}
-
-void
-display_stop (Display *display)
-{
-    g_return_if_fail (display != NULL);
-
-    if (display->priv->stopped)
-        return;
-
-    if (!display->priv->stopping)
-    {
-        g_debug ("Stopping display");
-        display->priv->stopping = TRUE;
-    }
-
-    /* Stop the session first */
-    if (display->priv->session)
-    {
-        session_stop (display->priv->session);
-        return;
-    }
-
-    /* Stop the display server after that */
-    if (!display_server_get_is_stopped (display->priv->display_server))
-    {
-        display_server_stop (display->priv->display_server);
-        return;
-    }
-
-    display->priv->stopped = TRUE;
-    g_signal_emit (display, signals[STOPPED], 0);
-}
-
-gboolean
-display_get_is_stopped (Display *display)
-{
-    g_return_val_if_fail (display != NULL, FALSE);
-    return display->priv->stopped;
-}
-
-static gboolean
-display_real_switch_to_user (Display *display, User *user)
-{
-    return FALSE;
-}
-
-static gboolean
-display_real_switch_to_guest (Display *display)
-{
-    return FALSE;
-}
-
-static gchar *
-display_real_get_guest_username (Display *display)
-{
-    return NULL;
-}
-
-static Display *
-display_real_create_display (Display *display, Session *session)
-{
-    return NULL;
-}
-
-static void
-display_init (Display *display)
-{
-    display->priv = G_TYPE_INSTANCE_GET_PRIVATE (display, DISPLAY_TYPE, DisplayPrivate);
-}
-
-static void
-display_finalize (GObject *object)
-{
-    Display *self;
-
-    self = DISPLAY (object);
-
-    g_signal_handlers_disconnect_matched (self->priv->display_server, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, self);
-    g_object_unref (self->priv->display_server);
-    g_free (self->priv->greeter_session);
-    if (self->priv->greeter)
-    {
-        g_signal_handlers_disconnect_matched (self->priv->greeter, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, self);
-        g_object_unref (self->priv->greeter);
-    }
-    g_free (self->priv->session_wrapper);
-    g_free (self->priv->greeter_wrapper);
-    if (self->priv->session)
-    {
-        g_signal_handlers_disconnect_matched (self->priv->session, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, self);      
-        g_object_unref (self->priv->session);
-    }
-    g_free (self->priv->autologin_user);
-    g_free (self->priv->select_user_hint);
-    g_free (self->priv->user_session);
-
-    G_OBJECT_CLASS (display_parent_class)->finalize (object);
-}
-
-static void
-display_class_init (DisplayClass *klass)
-{
-    GObjectClass *object_class = G_OBJECT_CLASS (klass);
-
-    klass->switch_to_user = display_real_switch_to_user;
-    klass->switch_to_guest = display_real_switch_to_guest;
-    klass->get_guest_username = display_real_get_guest_username;
-    klass->start_greeter = display_start_greeter;
-    klass->start_session = display_start_session;
-    klass->create_display = display_real_create_display;
-    object_class->finalize = display_finalize;
-
-    g_type_class_add_private (klass, sizeof (DisplayPrivate));
-
-    signals[CREATE_SESSION] =
-        g_signal_new ("create-session",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, create_session),
-                      NULL, NULL,
-                      ldm_marshal_OBJECT__VOID,
-                      SESSION_TYPE, 0);
-    signals[READY] =
-        g_signal_new ("ready",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, ready),
-                      NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
-                      G_TYPE_NONE, 0);
-    signals[SWITCH_TO_USER] =
-        g_signal_new ("switch-to-user",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, switch_to_user),
-                      g_signal_accumulator_true_handled,
-                      NULL,
-                      ldm_marshal_BOOLEAN__OBJECT,
-                      G_TYPE_BOOLEAN, 1, USER_TYPE);
-    signals[SWITCH_TO_GUEST] =
-        g_signal_new ("switch-to-guest",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, switch_to_guest),
-                      g_signal_accumulator_true_handled,
-                      NULL,
-                      ldm_marshal_BOOLEAN__VOID,
-                      G_TYPE_BOOLEAN, 0);
-    signals[GET_GUEST_USERNAME] =
-        g_signal_new ("get-guest-username",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, get_guest_username),
-                      g_signal_accumulator_first_wins,
-                      NULL,
-                      ldm_marshal_STRING__VOID,
-                      G_TYPE_STRING, 0);
-    signals[DISPLAY_SERVER_READY] =
-        g_signal_new ("display-server-ready",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, display_server_ready),
-                      NULL, NULL,
-                      ldm_marshal_BOOLEAN__VOID,
-                      G_TYPE_BOOLEAN, 0);
-    signals[START_GREETER] =
-        g_signal_new ("start-greeter",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, start_greeter),
-                      g_signal_accumulator_true_handled, NULL,
-                      ldm_marshal_BOOLEAN__VOID,
-                      G_TYPE_BOOLEAN, 0);
-    signals[START_SESSION] =
-        g_signal_new ("start-session",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, start_session),
-                      g_signal_accumulator_true_handled, NULL,
-                      ldm_marshal_BOOLEAN__VOID,
-                      G_TYPE_BOOLEAN, 0);
-    signals[CREATE_DISPLAY] =
-        g_signal_new ("create-display",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, create_display),
-                      NULL, NULL,
-                      ldm_marshal_OBJECT__OBJECT,
-                      DISPLAY_TYPE, 1, SESSION_TYPE);
-    signals[STOPPED] =
-        g_signal_new ("stopped",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (DisplayClass, stopped),
-                      NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
-                      G_TYPE_NONE, 0);
-}

=== removed file 'src/display.h'
--- src/display.h	2013-06-30 07:53:18 +0000
+++ src/display.h	1970-01-01 00:00:00 +0000
@@ -1,104 +0,0 @@
-/*
- * Copyright (C) 2010-2011 Robert Ancell.
- * Author: Robert Ancell <robert.ancell@canonical.com>
- * 
- * This program is free software: you can redistribute it and/or modify it under
- * the terms of the GNU General Public License as published by the Free Software
- * Foundation, either version 3 of the License, or (at your option) any later
- * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
- * license.
- */
-
-#ifndef DISPLAY_H_
-#define DISPLAY_H_
-
-#include <glib-object.h>
-
-#include "display-server.h"
-#include "session.h"
-#include "accounts.h"
-
-G_BEGIN_DECLS
-
-#define DISPLAY_TYPE           (display_get_type())
-#define DISPLAY(obj)           (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE, Display))
-#define DISPLAY_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE, DisplayClass))
-#define DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE, DisplayClass))
-
-typedef struct DisplayPrivate DisplayPrivate;
-
-typedef struct
-{
-    GObject         parent_instance;
-    DisplayPrivate *priv;
-} Display;
-
-typedef struct
-{
-    GObjectClass parent_class;
-
-    gboolean (*display_server_ready)(Display *display);
-    gboolean (*start_greeter)(Display *display);
-    gboolean (*start_session)(Display *display);
-    Session *(*create_session) (Display *display);
-    void (*ready)(Display *display);
-    gboolean (*switch_to_user)(Display *display, User *user);
-    gboolean (*switch_to_guest)(Display *display);
-    Display *(*create_display)(Display *display, Session *session);
-    gchar *(*get_guest_username)(Display *display);
-    void (*stopped)(Display *display);
-} DisplayClass;
-
-GType display_get_type (void);
-
-Display *display_new (DisplayServer *display_server);
-
-DisplayServer *display_get_display_server (Display *display);
-
-void display_set_share_display_server (Display *display, gboolean share_display_server);
-
-const gchar *display_get_username (Display *display);
-
-Session *display_get_session (Display *display);
-
-void display_set_greeter_session (Display *display, const gchar *greeter_session);
-
-void display_set_session_wrapper (Display *display, const gchar *session_wrapper);
-
-void display_set_greeter_wrapper (Display *display, const gchar *greeter_wrapper);
-
-void display_set_allow_guest (Display *display, gboolean allow_guest);
-
-void display_set_greeter_allow_guest (Display *display, gboolean greeter_allow_guest);
-
-void display_set_autologin_user (Display *display, const gchar *username, gboolean is_guest, gint timeout);
-
-void display_set_select_user_hint (Display *display, const gchar *username, gboolean is_guest, gboolean attempt_login);
-
-void display_set_hide_users_hint (Display *display, gboolean hide_users);
-
-void display_set_show_manual_login_hint (Display *display, gboolean show_manual);
-
-void display_set_show_remote_login_hint (Display *display, gboolean show_remote);
-
-void display_set_lock_hint (Display *display, gboolean is_lock);
-
-void display_set_user_session (Display *display, SessionType type, const gchar *session_name);
-
-gboolean display_start (Display *display);
-
-gboolean display_start_with_session (Display *display, Session *session);
-
-gboolean display_get_is_ready (Display *display);
-
-void display_lock (Display *display);
-
-void display_unlock (Display *display);
-
-void display_stop (Display *display);
-
-gboolean display_get_is_stopped (Display *display);
-
-G_END_DECLS
-
-#endif /* DISPLAY_H_ */

=== modified file 'src/greeter.c'
--- src/greeter.c	2013-07-09 05:32:31 +0000
+++ src/greeter.c	2013-07-23 02:24:45 +0000
@@ -18,12 +18,11 @@
 #include <gcrypt.h>
 
 #include "greeter.h"
-#include "ldm-marshal.h"
 #include "configuration.h"
 
 enum {
     CONNECTED,
-    START_AUTHENTICATION,
+    CREATE_SESSION,
     START_SESSION,
     LAST_SIGNAL
 };
@@ -31,9 +30,6 @@
 
 struct GreeterPrivate
 {
-    /* Session running on */
-    Session *session;
-
     /* PAM service to authenticate with */
     gchar *pam_service;
     gchar *autologin_pam_service;
@@ -72,7 +68,7 @@
     GIOChannel *from_greeter_channel;
 };
 
-G_DEFINE_TYPE (Greeter, greeter, G_TYPE_OBJECT);
+G_DEFINE_TYPE (Greeter, greeter, SESSION_TYPE);
 
 /* Messages from the greeter to the server */
 typedef enum
@@ -98,18 +94,13 @@
 
 static gboolean read_cb (GIOChannel *source, GIOCondition condition, gpointer data);
 
-Greeter *
-greeter_new (Session *session, const gchar *pam_service, const gchar *autologin_pam_service)
+void
+greeter_set_pam_services (Greeter *greeter, const gchar *pam_service, const gchar *autologin_pam_service)
 {
-    Greeter *greeter;
-
-    greeter = g_object_new (GREETER_TYPE, NULL);
-    greeter->priv->session = g_object_ref (session);
+    g_free (greeter->priv->pam_service);
     greeter->priv->pam_service = g_strdup (pam_service);
+    g_free (greeter->priv->autologin_pam_service);
     greeter->priv->autologin_pam_service = g_strdup (autologin_pam_service);
-    greeter->priv->use_secure_memory = config_get_boolean (config_get_instance (), "LightDM", "lock-memory");
-
-    return greeter;
 }
 
 void
@@ -361,7 +352,7 @@
     reset_session (greeter);
 
     greeter->priv->authentication_sequence_number = sequence_number;
-    g_signal_emit (greeter, signals[START_AUTHENTICATION], 0, username, &greeter->priv->authentication_session);
+    g_signal_emit (greeter, signals[CREATE_SESSION], 0, &greeter->priv->authentication_session);
     if (!greeter->priv->authentication_session)
     {
         send_end_authentication (greeter, sequence_number, "", PAM_USER_UNKNOWN);
@@ -385,7 +376,11 @@
     }
 
     /* Run the session process */
-    session_start (greeter->priv->authentication_session, service, username, TRUE, is_interactive, FALSE);
+    session_set_pam_service (greeter->priv->authentication_session, service);
+    session_set_username (greeter->priv->authentication_session, username);
+    session_set_do_authenticate (greeter->priv->authentication_session, TRUE);
+    session_set_is_interactive (greeter->priv->authentication_session, is_interactive);
+    session_start (greeter->priv->authentication_session);
 }
 
 static void
@@ -465,14 +460,19 @@
 
     greeter->priv->authentication_sequence_number = sequence_number;
     greeter->priv->remote_session = g_strdup (session_name);
-    g_signal_emit (greeter, signals[START_AUTHENTICATION], 0, username, &greeter->priv->authentication_session);
+    g_signal_emit (greeter, signals[CREATE_SESSION], 0, &greeter->priv->authentication_session);
     if (greeter->priv->authentication_session)
     {
         g_signal_connect (G_OBJECT (greeter->priv->authentication_session), "got-messages", G_CALLBACK (pam_messages_cb), greeter);
         g_signal_connect (G_OBJECT (greeter->priv->authentication_session), "authentication-complete", G_CALLBACK (authentication_complete_cb), greeter);
 
         /* Run the session process */
-        session_start (greeter->priv->authentication_session, service, username, TRUE, TRUE, TRUE);
+        session_set_pam_service (greeter->priv->authentication_session, service);
+        session_set_username (greeter->priv->authentication_session, username);
+        session_set_do_authenticate (greeter->priv->authentication_session, TRUE);
+        session_set_is_interactive (greeter->priv->authentication_session, TRUE);
+        session_set_is_guest (greeter->priv->authentication_session, TRUE);
+        session_start (greeter->priv->authentication_session);
     }
 
     g_free (service);
@@ -816,9 +816,10 @@
     return greeter->priv->start_session;
 }
 
-gboolean
-greeter_start (Greeter *greeter, const gchar *service, const gchar *username)
+static gboolean
+greeter_start (Session *session)
 {
+    Greeter *greeter = GREETER (session);
     int to_greeter_pipe[2], from_greeter_pipe[2];
     gboolean result = FALSE;
     gchar *value;
@@ -838,17 +839,17 @@
 
     /* Let the greeter session know how to communicate with the daemon */
     value = g_strdup_printf ("%d", from_greeter_pipe[1]);
-    session_set_env (greeter->priv->session, "LIGHTDM_TO_SERVER_FD", value);
+    session_set_env (SESSION (greeter), "LIGHTDM_TO_SERVER_FD", value);
     g_free (value);
     value = g_strdup_printf ("%d", to_greeter_pipe[0]);
-    session_set_env (greeter->priv->session, "LIGHTDM_FROM_SERVER_FD", value);
+    session_set_env (SESSION (greeter), "LIGHTDM_FROM_SERVER_FD", value);
     g_free (value);
 
     /* Don't allow the daemon end of the pipes to be accessed in child processes */
     fcntl (to_greeter_pipe[1], F_SETFD, FD_CLOEXEC);
     fcntl (from_greeter_pipe[0], F_SETFD, FD_CLOEXEC);
 
-    result = session_start (greeter->priv->session, service, username, FALSE, FALSE, FALSE);
+    result = SESSION_CLASS (greeter_parent_class)->start (session);
 
     /* Close the session ends of the pipe */
     close (to_greeter_pipe[0]);
@@ -858,7 +859,7 @@
 }
 
 static Session *
-greeter_real_start_authentication (Greeter *greeter, const gchar *username)
+greeter_real_create_session (Greeter *greeter)
 {
     return NULL;
 }
@@ -870,11 +871,24 @@
 }
 
 static void
+greeter_stop (Session *session)
+{
+    Greeter *greeter = GREETER (session);
+
+    /* Stop any events occurring after we've stopped */
+    if (greeter->priv->authentication_session)
+        g_signal_handlers_disconnect_matched (greeter->priv->authentication_session, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, greeter);
+
+    SESSION_CLASS (greeter_parent_class)->stop (session);
+}
+
+static void
 greeter_init (Greeter *greeter)
 {
     greeter->priv = G_TYPE_INSTANCE_GET_PRIVATE (greeter, GREETER_TYPE, GreeterPrivate);
     greeter->priv->read_buffer = secure_malloc (greeter, HEADER_SIZE);
     greeter->priv->hints = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
+    greeter->priv->use_secure_memory = config_get_boolean (config_get_instance (), "LightDM", "lock-memory");
 }
 
 static void
@@ -884,8 +898,6 @@
 
     self = GREETER (object);
 
-    g_signal_handlers_disconnect_matched (self->priv->session, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, self);    
-    g_object_unref (self->priv->session);
     g_free (self->priv->pam_service);
     g_free (self->priv->autologin_pam_service);
     secure_free (self, self->priv->read_buffer);
@@ -907,10 +919,13 @@
 static void
 greeter_class_init (GreeterClass *klass)
 {
+    SessionClass *session_class = SESSION_CLASS (klass);
     GObjectClass *object_class = G_OBJECT_CLASS (klass);
 
-    klass->start_authentication = greeter_real_start_authentication;
+    klass->create_session = greeter_real_create_session;
     klass->start_session = greeter_real_start_session;
+    session_class->start = greeter_start;
+    session_class->stop = greeter_stop;
     object_class->finalize = greeter_finalize;
 
     signals[CONNECTED] =
@@ -919,18 +934,18 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (GreeterClass, connected),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 
-    signals[START_AUTHENTICATION] =
-        g_signal_new ("start-authentication",
+    signals[CREATE_SESSION] =
+        g_signal_new ("create-session",
                       G_TYPE_FROM_CLASS (klass),
                       G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (GreeterClass, start_authentication),
+                      G_STRUCT_OFFSET (GreeterClass, create_session),
                       g_signal_accumulator_first_wins,
                       NULL,
-                      ldm_marshal_OBJECT__STRING,
-                      SESSION_TYPE, 1, G_TYPE_STRING);
+                      NULL,
+                      SESSION_TYPE, 0);
 
     signals[START_SESSION] =
         g_signal_new ("start-session",
@@ -939,7 +954,7 @@
                       G_STRUCT_OFFSET (GreeterClass, start_session),
                       g_signal_accumulator_true_handled,
                       NULL,
-                      ldm_marshal_BOOLEAN__INT_STRING,
+                      NULL,
                       G_TYPE_BOOLEAN, 2, G_TYPE_INT, G_TYPE_STRING);
 
     g_type_class_add_private (klass, sizeof (GreeterPrivate));

=== modified file 'src/greeter.h'
--- src/greeter.h	2013-04-23 03:07:03 +0000
+++ src/greeter.h	2013-07-16 05:35:54 +0000
@@ -16,28 +16,31 @@
 
 G_BEGIN_DECLS
 
-#define GREETER_TYPE (greeter_get_type())
-#define GREETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE, Greeter))
+#define GREETER_TYPE           (greeter_get_type())
+#define GREETER(obj)           (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE, Greeter))
+#define GREETER_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_TYPE, GreeterClass))
+#define GREETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_TYPE, GreeterClass))
+#define IS_GREETER(obj)        (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_TYPE))
 
 typedef struct GreeterPrivate GreeterPrivate;
 
 typedef struct
 {
-    GObject         parent_instance;
+    Session         parent_instance;
     GreeterPrivate *priv;
 } Greeter;
 
 typedef struct
 {
-    GObjectClass parent_class;
+    SessionClass parent_class;
     void (*connected)(Greeter *greeter);
-    Session *(*start_authentication)(Greeter *greeter, const gchar *username);
+    Session *(*create_session)(Greeter *greeter);
     gboolean (*start_session)(Greeter *greeter, SessionType type, const gchar *session);
 } GreeterClass;
 
 GType greeter_get_type (void);
 
-Greeter *greeter_new (Session *session, const gchar *pam_service, const gchar *autologin_pam_service);
+void greeter_set_pam_services (Greeter *greeter, const gchar *pam_service, const gchar *autologin_pam_service);
 
 void greeter_set_allow_guest (Greeter *greeter, gboolean allow_guest);
 
@@ -49,8 +52,6 @@
 
 gboolean greeter_get_start_session (Greeter *greeter);
 
-gboolean greeter_start (Greeter *greeter, const gchar *service, const gchar *username);
-
 G_END_DECLS
 
 #endif /* GREETER_H_ */

=== removed file 'src/ldm-marshal.list'
--- src/ldm-marshal.list	2013-06-28 09:18:31 +0000
+++ src/ldm-marshal.list	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-VOID:INT,POINTER
-BOOLEAN:VOID
-BOOLEAN:INT,STRING
-BOOLEAN:OBJECT
-STRING:VOID
-OBJECT:VOID
-OBJECT:STRING
-OBJECT:OBJECT

=== modified file 'src/lightdm.c'
--- src/lightdm.c	2013-07-09 04:07:14 +0000
+++ src/lightdm.c	2013-07-22 22:12:10 +0000
@@ -349,11 +349,11 @@
         GList *link;
 
         builder = g_variant_builder_new (G_VARIANT_TYPE ("ao"));
-        for (link = seat_get_displays (seat); link; link = link->next)
+        for (link = seat_get_sessions (seat); link; link = link->next)
         {
-            Display *display = link->data;
+            Session *session = link->data;
             BusEntry *entry;
-            entry = g_hash_table_lookup (session_bus_entries, display_get_session (display));
+            entry = g_hash_table_lookup (session_bus_entries, session);
             if (entry)
                 g_variant_builder_add_value (builder, g_variant_new_object_path (entry->path));
         }
@@ -428,13 +428,13 @@
     for (seat_link = display_manager_get_seats (display_manager); seat_link; seat_link = seat_link->next)
     {
         Seat *seat = seat_link->data;
-        GList *display_link;
+        GList *session_link;
 
-        for (display_link = seat_get_displays (seat); display_link; display_link = display_link->next)
+        for (session_link = seat_get_sessions (seat); session_link; session_link = session_link->next)
         {
-            Display *display = display_link->data;
+            Session *s = session_link->data;
 
-            if (display_get_session (display) == session)
+            if (s == session)
                 return seat;
         }
     }
@@ -520,15 +520,17 @@
     g_free (entry);
 }
 
-static gboolean
-start_session_cb (Display *display, Seat *seat)
+static void
+running_user_session_cb (Seat *seat, Session *session)
 {
-    Session *session;
-    BusEntry *seat_entry;
+    static const GDBusInterfaceVTable session_vtable =
+    {
+        handle_session_call,
+        handle_session_get_property
+    };
+    BusEntry *seat_entry, *entry;
     gchar *path;
 
-    session = display_get_session (display);
-
     /* Set environment variables when session runs */
     seat_entry = g_hash_table_lookup (seat_bus_entries, seat);
     session_set_env (session, "XDG_SEAT_PATH", seat_entry->path);
@@ -537,31 +539,6 @@
     session_set_env (session, "XDG_SESSION_PATH", path);
     g_object_set_data_full (G_OBJECT (session), "XDG_SESSION_PATH", path, g_free);
 
-    return FALSE;
-}
-
-static void
-session_stopped_cb (Session *session, Seat *seat)
-{
-    g_signal_handlers_disconnect_matched (session, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, seat);
-    g_hash_table_remove (session_bus_entries, session);
-}
-
-static gboolean
-session_started_cb (Display *display, Seat *seat)
-{
-    static const GDBusInterfaceVTable session_vtable =
-    {
-        handle_session_call,
-        handle_session_get_property
-    };
-    Session *session;
-    BusEntry *seat_entry, *entry;
-
-    session = display_get_session (display);
-
-    g_signal_connect (session, "stopped", G_CALLBACK (session_stopped_cb), seat);
-
     seat_entry = g_hash_table_lookup (seat_bus_entries, seat);
     entry = bus_entry_new (g_object_get_data (G_OBJECT (session), "XDG_SESSION_PATH"), seat_entry ? seat_entry->path : NULL, "SessionRemoved");
     g_hash_table_insert (session_bus_entries, g_object_ref (session), entry);
@@ -581,15 +558,13 @@
                                    "SessionAdded",
                                    g_variant_new ("(o)", entry->path),
                                    NULL);
-
-    return FALSE;
 }
 
 static void
-display_added_cb (Seat *seat, Display *display)
+session_removed_cb (Session *session, Seat *seat)
 {
-    g_signal_connect (display, "start-session", G_CALLBACK (start_session_cb), seat);
-    g_signal_connect_after (display, "start-session", G_CALLBACK (session_started_cb), seat);
+    g_signal_handlers_disconnect_matched (session, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, seat);
+    g_hash_table_remove (session_bus_entries, session);
 }
 
 static void
@@ -600,14 +575,9 @@
         handle_seat_call,
         handle_seat_get_property
     };
-    GList *link;
     gchar *path;
     BusEntry *entry;
 
-    g_signal_connect (seat, "display-added", G_CALLBACK (display_added_cb), NULL);
-    for (link = seat_get_displays (seat); link; link = link->next)
-        display_added_cb (seat, (Display *) link->data);
-
     path = g_strdup_printf ("/org/freedesktop/DisplayManager/Seat%d", seat_index);
     seat_index++;
 
@@ -630,6 +600,9 @@
                                    "SeatAdded",
                                    g_variant_new ("(o)", entry->path),
                                    NULL);
+
+    g_signal_connect (seat, "running-user-session", G_CALLBACK (running_user_session_cb), NULL);
+    g_signal_connect (seat, "session-removed", G_CALLBACK (session_removed_cb), NULL);
 }
 
 static void
@@ -638,6 +611,31 @@
     g_hash_table_remove (seat_bus_entries, seat);
 }
 
+static gboolean
+xdmcp_session_cb (XDMCPServer *server, XDMCPSession *session)
+{
+    SeatXDMCPSession *seat;
+    gboolean result;
+
+    seat = seat_xdmcp_session_new (session);
+    set_seat_properties (SEAT (seat), NULL);
+    result = display_manager_add_seat (display_manager, SEAT (seat));
+    g_object_unref (seat);
+
+    return result;
+}
+
+static void
+vnc_connection_cb (VNCServer *server, GSocket *connection)
+{
+    SeatXVNC *seat;
+
+    seat = seat_xvnc_new (connection);
+    set_seat_properties (SEAT (seat), NULL);
+    display_manager_add_seat (display_manager, SEAT (seat));
+    g_object_unref (seat);
+}
+
 static void
 bus_acquired_cb (GDBusConnection *connection,
                  const gchar     *name,
@@ -730,6 +728,87 @@
     g_signal_connect (display_manager, "seat-removed", G_CALLBACK (seat_removed_cb), NULL);
     for (link = display_manager_get_seats (display_manager); link; link = link->next)
         seat_added_cb (display_manager, (Seat *) link->data);
+
+    display_manager_start (display_manager);
+
+    /* Start the XDMCP server */
+    if (config_get_boolean (config_get_instance (), "XDMCPServer", "enabled"))
+    {
+        gchar *key_name, *key = NULL;
+
+        xdmcp_server = xdmcp_server_new ();
+        if (config_has_key (config_get_instance (), "XDMCPServer", "port"))
+        {
+            gint port;
+            port = config_get_integer (config_get_instance (), "XDMCPServer", "port");
+            if (port > 0)
+                xdmcp_server_set_port (xdmcp_server, port);
+        }
+        g_signal_connect (xdmcp_server, "new-session", G_CALLBACK (xdmcp_session_cb), NULL);
+
+        key_name = config_get_string (config_get_instance (), "XDMCPServer", "key");
+        if (key_name)
+        {
+            gchar *dir, *path;
+            GKeyFile *keys;
+            gboolean result;
+            GError *error = NULL;
+
+            dir = config_get_string (config_get_instance (), "LightDM", "config-directory");
+            path = g_build_filename (dir, "keys.conf", NULL);
+            g_free (dir);
+
+            keys = g_key_file_new ();
+            result = g_key_file_load_from_file (keys, path, G_KEY_FILE_NONE, &error);
+            if (error)
+                g_debug ("Error getting key %s", error->message);
+            g_clear_error (&error);
+
+            if (result)
+            {
+                if (g_key_file_has_key (keys, "keyring", key_name, NULL))
+                    key = g_key_file_get_string (keys, "keyring", key_name, NULL);
+                else
+                    g_debug ("Key %s not defined", key_name);
+            }
+            g_free (path);
+            g_key_file_free (keys);
+        }
+        if (key)
+            xdmcp_server_set_key (xdmcp_server, key);
+        g_free (key_name);
+        g_free (key);
+
+        g_debug ("Starting XDMCP server on UDP/IP port %d", xdmcp_server_get_port (xdmcp_server));
+        xdmcp_server_start (xdmcp_server);
+    }
+
+    /* Start the VNC server */
+    if (config_get_boolean (config_get_instance (), "VNCServer", "enabled"))
+    {
+        gchar *path;
+
+        path = g_find_program_in_path ("Xvnc");
+        if (path)
+        {
+            vnc_server = vnc_server_new ();
+            if (config_has_key (config_get_instance (), "VNCServer", "port"))
+            {
+                gint port;
+                port = config_get_integer (config_get_instance (), "VNCServer", "port");
+                if (port > 0)
+                    vnc_server_set_port (vnc_server, port);
+            }
+            g_signal_connect (vnc_server, "new-connection", G_CALLBACK (vnc_connection_cb), NULL);
+
+            g_debug ("Starting VNC server on TCP/IP port %d", vnc_server_get_port (vnc_server));
+            vnc_server_start (vnc_server);
+
+            g_free (path);
+        }
+        else
+            g_warning ("Can't start VNC server, Xvn is not in the path");
+    }
 }
 
 static void
@@ -763,31 +842,6 @@
     return abs_path;
 }
 
-static gboolean
-xdmcp_session_cb (XDMCPServer *server, XDMCPSession *session)
-{
-    SeatXDMCPSession *seat;
-    gboolean result;
-
-    seat = seat_xdmcp_session_new (session);
-    set_seat_properties (SEAT (seat), NULL);
-    result = display_manager_add_seat (display_manager, SEAT (seat));
-    g_object_unref (seat);
-
-    return result;
-}
-
-static void
-vnc_connection_cb (VNCServer *server, GSocket *connection)
-{
-    SeatXVNC *seat;
-
-    seat = seat_xvnc_new (connection);
-    set_seat_properties (SEAT (seat), NULL);
-    display_manager_add_seat (display_manager, SEAT (seat));
-    g_object_unref (seat);
-}
-
 static int
 compare_strings (gconstpointer a, gconstpointer b)
 {
@@ -805,9 +859,6 @@
     gboolean explicit_config = FALSE;
     gboolean test_mode = FALSE;
     gchar *pid_path = "/var/run/lightdm.pid";
-    gchar *xsessions_dir = NULL;
-    gchar *remote_sessions_dir = NULL;
-    gchar *xgreeters_dir = NULL;
     gchar *config_dir, *config_d_dir = NULL;
     gchar *log_dir = NULL;
     gchar *run_dir = NULL;
@@ -831,15 +882,6 @@
         { "pid-file", 0, 0, G_OPTION_ARG_STRING, &pid_path,
           /* Help string for command line --pid-file flag */
           N_("File to write PID into"), "FILE" },
-        { "xsessions-dir", 0, 0, G_OPTION_ARG_STRING, &xsessions_dir,
-          /* Help string for command line --xsessions-dir flag */
-          N_("Directory to load X sessions from"), "DIRECTORY" },
-        { "remote-sessions-dir", 0, 0, G_OPTION_ARG_STRING, &remote_sessions_dir,
-          /* Help string for command line --remote-sessions-dir flag */
-          N_("Directory to load remote sessions from"), "DIRECTORY" },
-        { "xgreeters-dir", 0, 0, G_OPTION_ARG_STRING, &xgreeters_dir,
-          /* Help string for command line --xgreeters-dir flag */
-          N_("Directory to load X greeters from"), "DIRECTORY" },
         { "log-dir", 0, 0, G_OPTION_ARG_STRING, &log_dir,
           /* Help string for command line --log-dir flag */
           N_("Directory to write logs to"), "DIRECTORY" },
@@ -949,11 +991,6 @@
         fclose (pid_file);
     }
 
-    /* Always use absolute directories as child processes may run from different locations */
-    xsessions_dir = path_make_absolute (xsessions_dir);
-    remote_sessions_dir = path_make_absolute (remote_sessions_dir);
-    xgreeters_dir = path_make_absolute (xgreeters_dir);
-
     /* If not running as root write output to directories we control */
     if (getuid () != 0)
     {
@@ -985,8 +1022,7 @@
     if (config_d_dir)
     {
         GDir *dir;
-        GList *files, *link;
-        GKeyFile *f;
+        GList *files = NULL, *link;
 
         /* Find configuration files */
         dir = g_dir_open (config_d_dir, 0, &error);
@@ -1067,12 +1103,12 @@
     if (!config_has_key (config_get_instance (), "LightDM", "cache-directory"))
         config_set_string (config_get_instance (), "LightDM", "cache-directory", default_cache_dir);
     g_free (default_cache_dir);
-    if (!config_has_key (config_get_instance (), "LightDM", "xsessions-directory"))
-        config_set_string (config_get_instance (), "LightDM", "xsessions-directory", XSESSIONS_DIR);
+    if (!config_has_key (config_get_instance (), "LightDM", "sessions-directory"))
+        config_set_string (config_get_instance (), "LightDM", "sessions-directory", SESSIONS_DIR);
     if (!config_has_key (config_get_instance (), "LightDM", "remote-sessions-directory"))
         config_set_string (config_get_instance (), "LightDM", "remote-sessions-directory", REMOTE_SESSIONS_DIR);
-    if (!config_has_key (config_get_instance (), "LightDM", "xgreeters-directory"))
-        config_set_string (config_get_instance (), "LightDM", "xgreeters-directory", XGREETERS_DIR);
+    if (!config_has_key (config_get_instance (), "LightDM", "greeters-directory"))
+        config_set_string (config_get_instance (), "LightDM", "greeters-directory", GREETERS_DIR);
 
     /* Override defaults */
     if (log_dir)
@@ -1084,15 +1120,6 @@
     if (cache_dir)
         config_set_string (config_get_instance (), "LightDM", "cache-directory", cache_dir);
     g_free (cache_dir);
-    if (xsessions_dir)
-        config_set_string (config_get_instance (), "LightDM", "xsessions-directory", xsessions_dir);
-    g_free (xsessions_dir);
-    if (remote_sessions_dir)
-        config_set_string (config_get_instance (), "LightDM", "remote-sessions-directory", remote_sessions_dir);
-    g_free (remote_sessions_dir);
-    if (xgreeters_dir)
-        config_set_string (config_get_instance (), "LightDM", "xgreeters-directory", xgreeters_dir);
-    g_free (xgreeters_dir);
 
     /* Create run and cache directories */
     dir = config_get_string (config_get_instance (), "LightDM", "log-directory");
@@ -1112,7 +1139,7 @@
 
     /* Show queued messages once logging is complete */
     for (link = messages; link; link = link->next)
-        g_debug ("%s", link->data);
+        g_debug ("%s", (gchar *)link->data);
     g_list_free_full (messages, g_free);
 
     g_debug ("Using D-Bus name %s", LIGHTDM_BUS_NAME);
@@ -1178,7 +1205,8 @@
         {
             set_seat_properties (seat, NULL);
             seat_set_property (seat, "exit-on-failure", "true");
-            display_manager_add_seat (display_manager, seat);
+            if (!display_manager_add_seat (display_manager, seat))
+                return EXIT_FAILURE;
             g_object_unref (seat);
         }
         else
@@ -1188,87 +1216,6 @@
         }
     }
 
-    display_manager_start (display_manager);
-
-    /* Start the XDMCP server */
-    if (config_get_boolean (config_get_instance (), "XDMCPServer", "enabled"))
-    {
-        gchar *key_name, *key = NULL;
-
-        xdmcp_server = xdmcp_server_new ();
-        if (config_has_key (config_get_instance (), "XDMCPServer", "port"))
-        {
-            gint port;
-            port = config_get_integer (config_get_instance (), "XDMCPServer", "port");
-            if (port > 0)
-                xdmcp_server_set_port (xdmcp_server, port);
-        }
-        g_signal_connect (xdmcp_server, "new-session", G_CALLBACK (xdmcp_session_cb), NULL);
-
-        key_name = config_get_string (config_get_instance (), "XDMCPServer", "key");
-        if (key_name)
-        {
-            gchar *dir, *path;
-            GKeyFile *keys;
-            gboolean result;
-            GError *error = NULL;
-
-            dir = config_get_string (config_get_instance (), "LightDM", "config-directory");
-            path = g_build_filename (dir, "keys.conf", NULL);
-            g_free (dir);
-
-            keys = g_key_file_new ();
-            result = g_key_file_load_from_file (keys, path, G_KEY_FILE_NONE, &error);
-            if (error)
-                g_debug ("Error getting key %s", error->message);
-            g_clear_error (&error);
-
-            if (result)
-            {
-                if (g_key_file_has_key (keys, "keyring", key_name, NULL))
-                    key = g_key_file_get_string (keys, "keyring", key_name, NULL);
-                else
-                    g_debug ("Key %s not defined", key_name);
-            }
-            g_free (path);
-            g_key_file_free (keys);
-        }
-        if (key)
-            xdmcp_server_set_key (xdmcp_server, key);
-        g_free (key_name);
-        g_free (key);
-
-        g_debug ("Starting XDMCP server on UDP/IP port %d", xdmcp_server_get_port (xdmcp_server));
-        xdmcp_server_start (xdmcp_server);
-    }
-
-    /* Start the VNC server */
-    if (config_get_boolean (config_get_instance (), "VNCServer", "enabled"))
-    {
-        gchar *path;
-
-        path = g_find_program_in_path ("Xvnc");
-        if (path)
-        {
-            vnc_server = vnc_server_new ();
-            if (config_has_key (config_get_instance (), "VNCServer", "port"))
-            {
-                gint port;
-                port = config_get_integer (config_get_instance (), "VNCServer", "port");
-                if (port > 0)
-                    vnc_server_set_port (vnc_server, port);
-            }
-            g_signal_connect (vnc_server, "new-connection", G_CALLBACK (vnc_connection_cb), NULL);
-
-            g_debug ("Starting VNC server on TCP/IP port %d", vnc_server_get_port (vnc_server));
-            vnc_server_start (vnc_server);
-
-            g_free (path);
-        }
-        else
-            g_warning ("Can't start VNC server, Xvn is not in the path");
-    }
-
     g_main_loop_run (loop);
 
     /* Clean up display manager */

=== modified file 'src/mir-session.c'
--- src/mir-session.c	2013-07-09 05:17:25 +0000
+++ src/mir-session.c	2013-07-23 02:24:45 +0000
@@ -26,16 +26,6 @@
 }
 
 static void
-mir_session_set_display_server (Session *session, DisplayServer *display_server)
-{
-    MirServer *mir_server;
-
-    mir_server = MIR_SERVER (display_server);
-
-    SESSION_CLASS (mir_session_parent_class)->set_display_server (session, display_server);
-}
-
-static void
 mir_session_init (MirSession *session)
 {
 }
@@ -43,7 +33,4 @@
 static void
 mir_session_class_init (MirSessionClass *klass)
 {
-    SessionClass *session_class = SESSION_CLASS (klass);
-
-    session_class->set_display_server = mir_session_set_display_server;
 }

=== modified file 'src/process.c'
--- src/process.c	2013-03-06 21:50:54 +0000
+++ src/process.c	2013-07-20 08:49:28 +0000
@@ -358,7 +358,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (ProcessClass, run),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0); 
     signals[GOT_DATA] =
         g_signal_new ("got-data",
@@ -366,7 +366,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (ProcessClass, got_data),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0); 
     signals[GOT_SIGNAL] =
         g_signal_new ("got-signal",
@@ -374,7 +374,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (ProcessClass, got_signal),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__INT,
+                      NULL,
                       G_TYPE_NONE, 1, G_TYPE_INT);
     signals[STOPPED] =
         g_signal_new ("stopped",
@@ -382,7 +382,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (ProcessClass, stopped),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 
     /* Catch signals and feed them to the main loop via a pipe */

=== modified file 'src/seat-unity.c'
--- src/seat-unity.c	2013-07-23 02:10:40 +0000
+++ src/seat-unity.c	2013-07-23 02:24:45 +0000
@@ -12,10 +12,12 @@
 #include <string.h>
 #include <fcntl.h>
 #include <errno.h>
+#include <glib/gstdio.h>
 
 #include "seat-unity.h"
 #include "configuration.h"
 #include "xserver-local.h"
+#include "xgreeter.h"
 #include "xsession.h"
 #include "mir-server.h"
 #include "vt.h"
@@ -71,8 +73,9 @@
     /* TRUE if using VT switching fallback */
     gboolean use_vt_switching;
 
-    /* The currently visible display */
-    Display *active_display;
+    /* The currently visible session */
+    Session *active_session;
+    DisplayServer *active_display_server;
 };
 
 G_DEFINE_TYPE (SeatUnity, seat_unity, SEAT_TYPE);
@@ -91,6 +94,10 @@
         g_source_remove (seat->priv->compositor_timeout);
     seat->priv->compositor_timeout = 0;
 
+    /* Finished with the VT */
+    vt_unref (seat->priv->vt);
+    seat->priv->vt = -1;
+
     if (seat_get_is_stopping (SEAT (seat)))
     {
         SEAT_CLASS (seat_unity_parent_class)->stop (SEAT (seat));
@@ -143,6 +150,12 @@
              close (fd);
          }
     }
+
+    if (seat->priv->stopping_plymouth)
+    {      
+        seat->priv->stopping_plymouth = FALSE;
+        plymouth_quit (TRUE);
+    }  
 }
 
 static void
@@ -169,7 +182,7 @@
     SeatUnity *seat = data;
     gsize n_to_read = 0;
     guint16 id, payload_length;
-    guint8 *payload;
+    /*guint8 *payload;*/
   
     if (condition == G_IO_HUP)
     {
@@ -198,7 +211,7 @@
             seat->priv->read_buffer = g_realloc (seat->priv->read_buffer, n_total);
 
         status = g_io_channel_read_chars (source,
-                                          seat->priv->read_buffer + seat->priv->read_buffer_n_used,
+                                          (gchar *)seat->priv->read_buffer + seat->priv->read_buffer_n_used,
                                           n_to_read,
                                           &n_read,
                                           &error);
@@ -219,7 +232,7 @@
     /* Read payload */
     if (seat->priv->read_buffer_n_used < 4 + payload_length)
         return TRUE;
-    payload = seat->priv->read_buffer + 4;
+    /*payload = seat->priv->read_buffer + 4;*/
 
     switch (id)
     {
@@ -306,6 +319,7 @@
         if (active_vt >= vt_get_min ())
         {
             g_debug ("Compositor will replace Plymouth");
+            SEAT_UNITY (seat)->priv->stopping_plymouth = TRUE;
             SEAT_UNITY (seat)->priv->vt = active_vt;
             plymouth_deactivate ();
         }
@@ -462,7 +476,7 @@
 
 static DisplayServer *
 seat_unity_create_display_server (Seat *seat, const gchar *session_type)
-{
+{  
     if (strcmp (session_type, "x") == 0)
         return create_x_server (seat);
     else if (strcmp (session_type, "mir") == 0)
@@ -474,67 +488,65 @@
     }
 }
 
+static Greeter *
+seat_unity_create_greeter_session (Seat *seat)
+{
+    XGreeter *greeter_session;
+
+    greeter_session = xgreeter_new ();
+    session_set_env (SESSION (greeter_session), "XDG_SEAT", "seat0");
+
+    return GREETER (greeter_session);
+}
+
 static Session *
-seat_unity_create_session (Seat *seat, Display *display)
+seat_unity_create_session (Seat *seat)
 {
-    XServerLocal *xserver;
     XSession *session;
-    int vt_number;
-    gchar *t;
-
-    xserver = XSERVER_LOCAL (display_get_display_server (display));
-
-    if (SEAT_UNITY (seat)->priv->use_vt_switching)
-        vt_number = xserver_local_get_vt (xserver);
-    else
-        vt_number = SEAT_UNITY (seat)->priv->vt;
 
     session = xsession_new ();
-    t = g_strdup_printf ("/dev/tty%d", vt_number);
-    session_set_tty (SESSION (session), t);
-    g_free (t);
-
-    /* Set variables for logind */
     session_set_env (SESSION (session), "XDG_SEAT", "seat0");
-    t = g_strdup_printf ("%d", vt_number);
-    session_set_env (SESSION (session), "XDG_VTNR", t);
-    g_free (t);
 
     return SESSION (session);
 }
 
 static void
-seat_unity_set_active_display (Seat *seat, Display *display)
+seat_unity_set_active_session (Seat *seat, Session *session)
 {
-    XServerLocal *xserver;
-    const gchar *id;
+    DisplayServer *display_server;
 
     /* If no compositor, have to use VT switching */
     if (SEAT_UNITY (seat)->priv->use_vt_switching)
     {
-        gint vt = xserver_local_get_vt (XSERVER_LOCAL (display_get_display_server (display)));
+        gint vt = display_server_get_vt (session_get_display_server (session));
         if (vt >= 0)
             vt_set_active (vt);
 
-        SEAT_CLASS (seat_unity_parent_class)->set_active_display (seat, display);
-        return;
-    }
-
-    if (display == SEAT_UNITY (seat)->priv->active_display)
-        return;
-    SEAT_UNITY (seat)->priv->active_display = display;
-
-    xserver = XSERVER_LOCAL (display_get_display_server (display));
-    id = xserver_local_get_mir_id (xserver);
-
-    g_debug ("Switching to Mir session %s", id);
-    write_message (SEAT_UNITY (seat), USC_MESSAGE_SET_ACTIVE_SESSION, id, strlen (id));
-
-    SEAT_CLASS (seat_unity_parent_class)->set_active_display (seat, display);
+        SEAT_CLASS (seat_unity_parent_class)->set_active_session (seat, session);
+        return;
+    }
+
+    if (session == SEAT_UNITY (seat)->priv->active_session)
+        return;
+    SEAT_UNITY (seat)->priv->active_session = g_object_ref (session);
+
+    display_server = session_get_display_server (session);
+    if (SEAT_UNITY (seat)->priv->active_display_server != display_server)
+    {
+        const gchar *id;
+
+        SEAT_UNITY (seat)->priv->active_display_server = g_object_ref (display_server);
+        id = xserver_local_get_mir_id (XSERVER_LOCAL (display_server));
+
+        g_debug ("Switching to Mir session %s", id);
+        write_message (SEAT_UNITY (seat), USC_MESSAGE_SET_ACTIVE_SESSION, (const guint8 *) id, strlen (id));
+    }
+
+    SEAT_CLASS (seat_unity_parent_class)->set_active_session (seat, session);
 }
 
-static Display *
-seat_unity_get_active_display (Seat *seat)
+static Session *
+seat_unity_get_active_session (Seat *seat)
 {
     if (SEAT_UNITY (seat)->priv->use_vt_switching)
     {
@@ -544,34 +556,31 @@
         if (vt < 0)
             return NULL;
 
-        for (link = seat_get_displays (seat); link; link = link->next)
+        for (link = seat_get_sessions (seat); link; link = link->next)
         {
-            Display *display = link->data;
-            XServerLocal *xserver;
-
-            xserver = XSERVER_LOCAL (display_get_display_server (display));
-            if (xserver_local_get_vt (xserver) == vt)
-                return display;
+            Session *session = link->data;
+            if (display_server_get_vt (session_get_display_server (session)) == vt)
+                return session;
         }
 
         return NULL;
     }
 
-    return SEAT_UNITY (seat)->priv->active_display;
+    return SEAT_UNITY (seat)->priv->active_session;
 }
 
 static void
-seat_unity_run_script (Seat *seat, Display *display, Process *script)
+seat_unity_run_script (Seat *seat, DisplayServer *display_server, Process *script)
 {
     const gchar *path;
     XServerLocal *xserver;
 
-    xserver = XSERVER_LOCAL (display_get_display_server (display));
+    xserver = XSERVER_LOCAL (display_server);
     path = xserver_local_get_authority_file_path (xserver);
     process_set_env (script, "DISPLAY", xserver_get_address (XSERVER (xserver)));
     process_set_env (script, "XAUTHORITY", path);
 
-    SEAT_CLASS (seat_unity_parent_class)->run_script (seat, display, script);
+    SEAT_CLASS (seat_unity_parent_class)->run_script (seat, display_server, script);
 }
 
 static void
@@ -588,28 +597,6 @@
 }
 
 static void
-seat_unity_display_removed (Seat *seat, Display *display)
-{
-    if (seat_get_is_stopping (seat))
-        return;
-
-    /* If this is the only display and it failed to start then stop this seat */
-    if (g_list_length (seat_get_displays (seat)) == 0 && !display_get_is_ready (display))
-    {
-        g_debug ("Stopping Unity seat, failed to start a display");
-        seat_stop (seat);
-        return;
-    }
-
-    /* Show a new greeter */
-    if (display == seat_get_active_display (seat))
-    {
-        g_debug ("Active display stopped, switching to greeter");
-        seat_switch_to_greeter (seat);
-    }
-}
-
-static void
 seat_unity_init (SeatUnity *seat)
 {
     seat->priv = G_TYPE_INSTANCE_GET_PRIVATE (seat, SEAT_UNITY_TYPE, SeatUnityPrivate);
@@ -633,6 +620,10 @@
     g_io_channel_unref (seat->priv->from_compositor_channel);
     g_free (seat->priv->read_buffer);
     g_object_unref (seat->priv->compositor_process);
+    if (seat->priv->active_session)
+        g_object_unref (seat->priv->active_session);
+    if (seat->priv->active_display_server)
+        g_object_unref (seat->priv->active_display_server);
 
     G_OBJECT_CLASS (seat_unity_parent_class)->finalize (object);
 }
@@ -647,12 +638,12 @@
     seat_class->setup = seat_unity_setup;
     seat_class->start = seat_unity_start;
     seat_class->create_display_server = seat_unity_create_display_server;
+    seat_class->create_greeter_session = seat_unity_create_greeter_session;
     seat_class->create_session = seat_unity_create_session;
-    seat_class->set_active_display = seat_unity_set_active_display;
-    seat_class->get_active_display = seat_unity_get_active_display;
+    seat_class->set_active_session = seat_unity_set_active_session;
+    seat_class->get_active_session = seat_unity_get_active_session;
     seat_class->run_script = seat_unity_run_script;
     seat_class->stop = seat_unity_stop;
-    seat_class->display_removed = seat_unity_display_removed;
 
     g_type_class_add_private (klass, sizeof (SeatUnityPrivate));
 }

=== modified file 'src/seat-xdmcp-session.c'
--- src/seat-xdmcp-session.c	2013-07-23 02:10:40 +0000
+++ src/seat-xdmcp-session.c	2013-07-23 02:24:45 +0000
@@ -13,6 +13,7 @@
 
 #include "seat-xdmcp-session.h"
 #include "xserver-remote.h"
+#include "xgreeter.h"
 #include "xsession.h"
 
 struct SeatXDMCPSessionPrivate
@@ -55,18 +56,16 @@
     return DISPLAY_SERVER (xserver);
 }
 
+static Greeter *
+seat_xdmcp_session_create_greeter_session (Seat *seat)
+{
+    return GREETER (xgreeter_new ());
+}
+
 static Session *
-seat_xdmcp_session_create_session (Seat *seat, Display *display)
+seat_xdmcp_session_create_session (Seat *seat)
 {
-    XServerRemote *xserver;
-    XSession *session;
-
-    xserver = XSERVER_REMOTE (display_get_display_server (display));
-
-    session = xsession_new ();
-    session_set_remote_host_name (SESSION (session), xserver_get_hostname (XSERVER (xserver)));
-
-    return SESSION (session);
+    return SESSION (xsession_new ());
 }
 
 static void
@@ -94,6 +93,7 @@
     GObjectClass *object_class = G_OBJECT_CLASS (klass);
 
     seat_class->create_display_server = seat_xdmcp_session_create_display_server;
+    seat_class->create_greeter_session = seat_xdmcp_session_create_greeter_session;
     seat_class->create_session = seat_xdmcp_session_create_session;
     object_class->finalize = seat_xdmcp_session_finalize;
 

=== modified file 'src/seat-xlocal.c'
--- src/seat-xlocal.c	2013-07-23 02:10:40 +0000
+++ src/seat-xlocal.c	2013-07-23 02:24:45 +0000
@@ -14,6 +14,7 @@
 #include "seat-xlocal.h"
 #include "configuration.h"
 #include "xserver-local.h"
+#include "xgreeter.h"
 #include "xsession.h"
 #include "mir-server.h"
 #include "vt.h"
@@ -107,23 +108,12 @@
 }
 
 static DisplayServer *
-create_mir_server (Seat *seat)
-{
-    MirServer *mir_server;
-
-    mir_server = mir_server_new ();
-    // FIXME: Set VT
-
-    return DISPLAY_SERVER (mir_server);
-}
-
-static DisplayServer *
 seat_xlocal_create_display_server (Seat *seat, const gchar *session_type)
-{
+{  
     if (strcmp (session_type, "x") == 0)
         return create_x_server (seat);
     else if (strcmp (session_type, "mir") == 0)
-        return create_mir_server (seat);
+        return DISPLAY_SERVER (mir_server_new ());
     else
     {
         g_warning ("Can't create unsupported display server '%s'", session_type);
@@ -131,41 +121,40 @@
     }
 }
 
+static Greeter *
+seat_xlocal_create_greeter_session (Seat *seat)
+{
+    XGreeter *greeter_session;
+
+    greeter_session = xgreeter_new ();
+    session_set_env (SESSION (greeter_session), "XDG_SEAT", "seat0");
+
+    return GREETER (greeter_session);
+}
+
 static Session *
-seat_xlocal_create_session (Seat *seat, Display *display)
+seat_xlocal_create_session (Seat *seat)
 {
-    XServerLocal *xserver;
     XSession *session;
-    gchar *t;
-
-    xserver = XSERVER_LOCAL (display_get_display_server (display));
 
     session = xsession_new ();
-    t = g_strdup_printf ("/dev/tty%d", xserver_local_get_vt (xserver));
-    session_set_tty (SESSION (session), t);
-    g_free (t);
-
-    /* Set variables for logind */
     session_set_env (SESSION (session), "XDG_SEAT", "seat0");
-    t = g_strdup_printf ("%d", xserver_local_get_vt (xserver));
-    session_set_env (SESSION (session), "XDG_VTNR", t);
-    g_free (t);
 
     return SESSION (session);
 }
 
 static void
-seat_xlocal_set_active_display (Seat *seat, Display *display)
+seat_xlocal_set_active_session (Seat *seat, Session *session)
 {
-    gint vt = xserver_local_get_vt (XSERVER_LOCAL (display_get_display_server (display)));
+    gint vt = display_server_get_vt (session_get_display_server (session));
     if (vt >= 0)
         vt_set_active (vt);
 
-    SEAT_CLASS (seat_xlocal_parent_class)->set_active_display (seat, display);
+    SEAT_CLASS (seat_xlocal_parent_class)->set_active_session (seat, session);
 }
 
-static Display *
-seat_xlocal_get_active_display (Seat *seat)
+static Session *
+seat_xlocal_get_active_session (Seat *seat)
 {
     gint vt;
     GList *link;
@@ -174,31 +163,28 @@
     if (vt < 0)
         return NULL;
 
-    for (link = seat_get_displays (seat); link; link = link->next)
+    for (link = seat_get_sessions (seat); link; link = link->next)
     {
-        Display *display = link->data;
-        XServerLocal *xserver;
-
-        xserver = XSERVER_LOCAL (display_get_display_server (display));
-        if (xserver_local_get_vt (xserver) == vt)
-            return display;
+        Session *session = link->data;
+        if (display_server_get_vt (session_get_display_server (session)) == vt)
+            return session;
     }
 
     return NULL;
 }
 
 static void
-seat_xlocal_run_script (Seat *seat, Display *display, Process *script)
+seat_xlocal_run_script (Seat *seat, DisplayServer *display_server, Process *script)
 {
     const gchar *path;
     XServerLocal *xserver;
 
-    xserver = XSERVER_LOCAL (display_get_display_server (display));
+    xserver = XSERVER_LOCAL (display_server);
     path = xserver_local_get_authority_file_path (xserver);
     process_set_env (script, "DISPLAY", xserver_get_address (XSERVER (xserver)));
     process_set_env (script, "XAUTHORITY", path);
 
-    SEAT_CLASS (seat_xlocal_parent_class)->run_script (seat, display, script);
+    SEAT_CLASS (seat_xlocal_parent_class)->run_script (seat, display_server, script);
 }
 
 static void
@@ -213,8 +199,9 @@
 
     seat_class->setup = seat_xlocal_setup;
     seat_class->create_display_server = seat_xlocal_create_display_server;
+    seat_class->create_greeter_session = seat_xlocal_create_greeter_session;
     seat_class->create_session = seat_xlocal_create_session;
-    seat_class->set_active_display = seat_xlocal_set_active_display;
-    seat_class->get_active_display = seat_xlocal_get_active_display;
+    seat_class->set_active_session = seat_xlocal_set_active_session;
+    seat_class->get_active_session = seat_xlocal_get_active_session;
     seat_class->run_script = seat_xlocal_run_script;
 }

=== modified file 'src/seat-xremote.c'
--- src/seat-xremote.c	2013-07-23 02:10:40 +0000
+++ src/seat-xremote.c	2013-07-23 02:24:45 +0000
@@ -14,6 +14,7 @@
 #include "seat-xremote.h"
 #include "configuration.h"
 #include "xserver-remote.h"
+#include "xgreeter.h"
 #include "xsession.h"
 
 G_DEFINE_TYPE (SeatXRemote, seat_xremote, SEAT_TYPE);
@@ -50,30 +51,33 @@
     return DISPLAY_SERVER (xserver);
 }
 
+static Greeter *
+seat_xremote_create_greeter_session (Seat *seat)
+{
+    XGreeter *greeter_session;
+
+    greeter_session = xgreeter_new ();
+    session_set_env (SESSION (greeter_session), "XDG_SEAT", "seat0");
+
+    return GREETER (greeter_session);
+}
+
 static Session *
-seat_xremote_create_session (Seat *seat, Display *display)
+seat_xremote_create_session (Seat *seat)
 {
-    XServerRemote *xserver;
-    XSession *session;
-
-    xserver = XSERVER_REMOTE (display_get_display_server (display));
-
-    session = xsession_new ();
-    session_set_remote_host_name (SESSION (session), xserver_get_hostname (XSERVER (xserver)));
-
-    return SESSION (session);
+    return SESSION (xsession_new ());
 }
 
 static void
-seat_xremote_run_script (Seat *seat, Display *display, Process *script)
+seat_xremote_run_script (Seat *seat, DisplayServer *display_server, Process *script)
 {
     XServerRemote *xserver;
 
-    xserver = XSERVER_REMOTE (display_get_display_server (display));
+    xserver = XSERVER_REMOTE (display_server);
     process_set_env (script, "DISPLAY", xserver_get_address (XSERVER (xserver)));  
     process_set_env (script, "REMOTE_HOST", xserver_get_hostname (XSERVER (xserver)));
 
-    SEAT_CLASS (seat_xremote_parent_class)->run_script (seat, display, script);
+    SEAT_CLASS (seat_xremote_parent_class)->run_script (seat, display_server, script);
 }
 
 static void
@@ -88,6 +92,7 @@
 
     seat_class->setup = seat_xremote_setup;
     seat_class->create_display_server = seat_xremote_create_display_server;
+    seat_class->create_greeter_session = seat_xremote_create_greeter_session;
     seat_class->create_session = seat_xremote_create_session;
     seat_class->run_script = seat_xremote_run_script;
 }

=== modified file 'src/seat-xvnc.c'
--- src/seat-xvnc.c	2013-07-23 02:10:40 +0000
+++ src/seat-xvnc.c	2013-07-23 02:24:45 +0000
@@ -9,8 +9,11 @@
  * license.
  */
 
+#include <string.h>
+
 #include "seat-xvnc.h"
 #include "xserver-xvnc.h"
+#include "xgreeter.h"
 #include "xsession.h"
 #include "configuration.h"
 
@@ -71,35 +74,27 @@
     return DISPLAY_SERVER (xserver);
 }
 
+static Greeter *
+seat_xvnc_create_greeter_session (Seat *seat)
+{
+    return GREETER (xgreeter_new ());
+}
+
 static Session *
-seat_xvnc_create_session (Seat *seat, Display *display)
+seat_xvnc_create_session (Seat *seat)
 {
-    XServerXVNC *xserver;
-    XSession *session;
-    GInetSocketAddress *address;
-    gchar *hostname;
-    gchar *t;
-
-    xserver = XSERVER_XVNC (display_get_display_server (display));
-
-    session = xsession_new ();
-    address = G_INET_SOCKET_ADDRESS (g_socket_get_remote_address (SEAT_XVNC (seat)->priv->connection, NULL));
-    hostname = g_inet_address_to_string (g_inet_socket_address_get_address (address));
-    session_set_remote_host_name (SESSION (session), hostname);
-    g_free (hostname);
-
-    return SESSION (session);
+    return SESSION (xsession_new ());
 }
 
 static void
-seat_xvnc_run_script (Seat *seat, Display *display, Process *script)
+seat_xvnc_run_script (Seat *seat, DisplayServer *display_server, Process *script)
 {
     XServerXVNC *xserver;
     GInetSocketAddress *address;
     gchar *hostname;
     const gchar *path;
 
-    xserver = XSERVER_XVNC (display_get_display_server (display));
+    xserver = XSERVER_XVNC (display_server);
 
     address = G_INET_SOCKET_ADDRESS (g_socket_get_remote_address (SEAT_XVNC (seat)->priv->connection, NULL));
     hostname = g_inet_address_to_string (g_inet_socket_address_get_address (address));
@@ -111,7 +106,7 @@
 
     g_free (hostname);
 
-    SEAT_CLASS (seat_xvnc_parent_class)->run_script (seat, display, script);
+    SEAT_CLASS (seat_xvnc_parent_class)->run_script (seat, display_server, script);
 }
 
 static void
@@ -139,6 +134,7 @@
     GObjectClass *object_class = G_OBJECT_CLASS (klass);
 
     seat_class->create_display_server = seat_xvnc_create_display_server;
+    seat_class->create_greeter_session = seat_xvnc_create_greeter_session;
     seat_class->create_session = seat_xvnc_create_session;
     seat_class->run_script = seat_xvnc_run_script;
     object_class->finalize = seat_xdmcp_session_finalize;

=== modified file 'src/seat.c'
--- src/seat.c	2013-07-23 02:10:40 +0000
+++ src/seat.c	2013-07-23 02:24:45 +0000
@@ -14,11 +14,14 @@
 #include <sys/wait.h>
 
 #include "seat.h"
+#include "configuration.h"
 #include "guest-account.h"
+#include "greeter.h"
 
 enum {
-    DISPLAY_ADDED,
-    DISPLAY_REMOVED,
+    SESSION_ADDED,
+    RUNNING_USER_SESSION,
+    SESSION_REMOVED,
     STOPPED,
     LAST_SIGNAL
 };
@@ -35,11 +38,14 @@
     /* TRUE if display server can be shared for sessions */
     gboolean share_display_server;
 
-    /* Name of guest account */
-    gchar *guest_username;
-
-    /* The displays for this seat */
-    GList *displays;
+    /* The display servers on this seat */
+    GList *display_servers;
+
+    /* The sessions on this seat */
+    GList *sessions;
+
+    /* The session to set active when it starts */
+    Session *session_to_activate;
 
     /* TRUE if stopping this seat (waiting for displays to stop) */
     gboolean stopping;
@@ -48,6 +54,11 @@
     gboolean stopped;
 };
 
+/* PAM services to use */
+#define GREETER_SERVICE   "lightdm-greeter"
+#define USER_SERVICE      "lightdm"
+#define AUTOLOGIN_SERVICE "lightdm-autologin"
+
 G_DEFINE_TYPE (Seat, seat, G_TYPE_OBJECT);
 
 typedef struct
@@ -57,7 +68,10 @@
 } SeatModule;
 static GHashTable *seat_modules = NULL;
 
-static Display *create_display (Seat *seat, const gchar *session_type);
+// FIXME: Make a get_display_server() that re-uses display servers if supported
+static DisplayServer *create_display_server (Seat *seat);
+static Greeter *create_greeter_session (Seat *seat);
+static void start_session (Seat *seat, Session *session);
 
 void
 seat_register_module (const gchar *name, GType type)
@@ -100,13 +114,6 @@
     g_hash_table_insert (seat->priv->properties, g_strdup (name), g_strdup (value));
 }
 
-gboolean
-seat_has_property (Seat *seat, const gchar *name)
-{
-    g_return_val_if_fail (seat != NULL, FALSE);
-    return g_hash_table_lookup (seat->priv->properties, name) != NULL;
-}
-
 const gchar *
 seat_get_string_property (Seat *seat, const gchar *name)
 {
@@ -155,24 +162,42 @@
 }
 
 GList *
-seat_get_displays (Seat *seat)
+seat_get_sessions (Seat *seat)
 {
     g_return_val_if_fail (seat != NULL, NULL);
-    return seat->priv->displays;
+    return seat->priv->sessions;
 }
 
 void
-seat_set_active_display (Seat *seat, Display *display)
+seat_set_active_session (Seat *seat, Session *session)
 {
+    GList *link;
+
     g_return_if_fail (seat != NULL);
-    SEAT_GET_CLASS (seat)->set_active_display (seat, display);
+
+    SEAT_GET_CLASS (seat)->set_active_session (seat, session);
+
+    /* Stop any greeters */
+    for (link = seat->priv->sessions; link; link = link->next)
+    {
+        Session *s = link->data;
+
+        if (s == session || session_get_is_stopping (s))
+            continue;
+
+        if (IS_GREETER (s))
+        {
+            g_debug ("Stopping greeter");
+            session_stop (s);
+        }
+    }
 }
 
-Display *
-seat_get_active_display (Seat *seat)
+Session *
+seat_get_active_session (Seat *seat)
 {
     g_return_val_if_fail (seat != NULL, NULL);
-    return SEAT_GET_CLASS (seat)->get_active_display (seat);
+    return SEAT_GET_CLASS (seat)->get_active_session (seat);
 }
 
 gboolean
@@ -185,75 +210,12 @@
 gboolean
 seat_get_allow_guest (Seat *seat)
 {
-    g_return_val_if_fail (seat != NULL, FALSE);  
+    g_return_val_if_fail (seat != NULL, FALSE);
     return seat_get_boolean_property (seat, "allow-guest") && guest_account_is_installed ();
 }
 
-gboolean
-seat_get_greeter_allow_guest (Seat *seat)
-{
-    g_return_val_if_fail (seat != NULL, FALSE);  
-    return seat_get_allow_guest (seat) && seat_get_boolean_property (seat, "greeter-allow-guest");
-}
-
-static gboolean
-switch_to_user (Seat *seat, const gchar *username, gboolean unlock)
-{
-    GList *link;
-
-    /* Switch to active display if it exists */
-    for (link = seat->priv->displays; link; link = link->next)
-    {
-        Display *display = link->data;
-
-        if (display_get_is_stopped (display))
-            continue;
-
-        /* If already logged in, then switch to that display */
-        if (g_strcmp0 (display_get_username (display), username) == 0)        
-        {
-            if (username)
-                g_debug ("Switching to existing session for user %s", username);
-            else
-                g_debug ("Switching to existing greeter");
-            if (unlock)
-                display_unlock (display);
-            seat_set_active_display (seat, display);
-            return TRUE;
-        }
-    }
-
-    return FALSE;
-}
-
-static gboolean
-display_switch_to_user_cb (Display *display, User *user, Seat *seat)
-{
-    return switch_to_user (seat, user_get_name (user), TRUE);
-}
-
-static gboolean
-display_switch_to_guest_cb (Display *display, Seat *seat)
-{
-    /* No guest account */
-    if (!seat->priv->guest_username)
-        return FALSE;
-
-    return switch_to_user (seat, seat->priv->guest_username, TRUE);
-}
-
-static const gchar *
-display_get_guest_username_cb (Display *display, Seat *seat)
-{
-    if (seat->priv->guest_username)
-        return seat->priv->guest_username;
-
-    seat->priv->guest_username = guest_account_setup ();
-    return g_strdup (seat->priv->guest_username);
-}
-
-static gboolean
-run_script (Seat *seat, Display *display, const gchar *script_name, User *user)
+static gboolean
+run_script (Seat *seat, DisplayServer *display_server, const gchar *script_name, User *user)
 {
     Process *script;
     gboolean result = FALSE;
@@ -286,7 +248,7 @@
     else
         process_set_env (script, "HOME", "/");
 
-    SEAT_GET_CLASS (seat)->run_script (seat, display, script);
+    SEAT_GET_CLASS (seat)->run_script (seat, display_server, script);
 
     if (process_start (script, TRUE))
     {
@@ -306,7 +268,7 @@
 }
 
 static void
-seat_real_run_script (Seat *seat, Display *display, Process *process)
+seat_real_run_script (Seat *seat, DisplayServer *display_server, Process *process)
 {  
 }
 
@@ -324,124 +286,13 @@
     g_free (cmd);
 }
 
-static gboolean
-display_display_server_ready_cb (Display *display, Seat *seat)
-{
-    const gchar *script;
-
-    /* Run setup script */
-    script = seat_get_string_property (seat, "display-setup-script");
-    if (script && !run_script (seat, display, script, NULL))
-        return FALSE;
-
-    emit_upstart_signal ("login-session-start");
-
-    return TRUE;
-}
-
-static Session *
-display_create_session_cb (Display *display, Seat *seat)
-{
-    return SEAT_GET_CLASS (seat)->create_session (seat, display);
-}
-
-static gboolean
-display_start_greeter_cb (Display *display, Seat *seat)
-{
-    Session *session;
-    const gchar *script;
-
-    session = display_get_session (display);
-
-    script = seat_get_string_property (seat, "greeter-setup-script");
-    if (script)
-        return !run_script (seat, display, script, session_get_user (session));
-    else
-        return FALSE;
-}
-
-static gboolean
-display_start_session_cb (Display *display, Seat *seat)
-{
-    Session *session;
-    const gchar *script;
-
-    session = display_get_session (display);
-
-    script = seat_get_string_property (seat, "session-setup-script");
-    if (script)
-        return !run_script (seat, display, script, session_get_user (session));
-    else
-        return FALSE;
-}
-
-static void
-session_stopped_cb (Session *session, Seat *seat)
-{
-    Display *display = NULL;
-    GList *link;
-    const gchar *script;
-  
-    /* Work out what display this session is on, it's a bit hacky because we really should know already... */
-    for (link = seat->priv->displays; link; link = link->next)
-    {
-        Display *d = link->data;
-        if (display_get_session (d) == session)
-        {
-            display = d;
-            break;
-        }
-    }
-    g_return_if_fail (display != NULL);
-
-    /* Cleanup */
-    script = seat_get_string_property (seat, "session-cleanup-script");
-    if (script)
-        run_script (seat, display, script, session_get_user (session));
-
-    if (seat->priv->guest_username && strcmp (session_get_username (session), seat->priv->guest_username) == 0)
-    {
-        g_free (seat->priv->guest_username);
-        seat->priv->guest_username = NULL;
-    }
-}
-
-static gboolean
-display_session_started_cb (Display *display, Seat *seat)
-{
-    g_signal_connect (display_get_session (display), "stopped", G_CALLBACK (session_stopped_cb), seat);
-    emit_upstart_signal ("desktop-session-start");
-    return FALSE;
-}
-
-static void
-display_ready_cb (Display *display, Seat *seat)
-{
-    /* Switch to this new display */
-    g_debug ("New display ready, switching to it");
-    SEAT_GET_CLASS (seat)->set_active_display (seat, display);
-}
-
-static Display *
-display_create_display_cb (Display *display, Session *session, Seat *seat)
-{
-    Display *d;
-
-    d = create_display (seat, session_get_session_type (session));
-    g_signal_connect (d, "ready", G_CALLBACK (display_ready_cb), seat);
-    g_signal_emit (seat, signals[DISPLAY_ADDED], 0, d);
-
-    display_start_with_session (d, session);
-
-    return g_object_ref (d);
-}
-
 static void
 check_stopped (Seat *seat)
 {
     if (seat->priv->stopping &&
         !seat->priv->stopped &&
-        g_list_length (seat->priv->displays) == 0)
+        g_list_length (seat->priv->display_servers) == 0 &&
+        g_list_length (seat->priv->sessions) == 0)
     {
         seat->priv->stopped = TRUE;
         g_debug ("Seat stopped");
@@ -450,133 +301,800 @@
 }
 
 static void
-display_stopped_cb (Display *display, Seat *seat)
-{
-    gboolean is_active;
-
-    is_active = display == seat_get_active_display (seat);
-
-    g_signal_handlers_disconnect_matched (display, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, seat);
-    seat->priv->displays = g_list_remove (seat->priv->displays, display);
-
-    g_signal_emit (seat, signals[DISPLAY_REMOVED], 0, display);
-
-    /* If no more displays running either start a greeter or stop the seat */
-    if (!seat->priv->stopping)
-    {
-        if (g_list_length (seat->priv->displays) == 0)
-        {
-            /* If failed to start then stop this seat */
-            if (!display_get_is_ready (display))
-            {
-                g_debug ("Stopping seat, failed to start a display");
-                seat_stop (seat);
-            }
-            /* Attempt to start a greeter */
-            else if (!seat->priv->can_switch)
-            {
-                g_debug ("Stopping seat, display stopped");
-                seat_stop (seat);             
-            }
-            
-            else if (!seat_switch_to_greeter (seat))
-            {
-                g_debug ("Stopping seat, unable to start greeter");
-                seat_stop (seat);
-            }        
-        }
-        else if (is_active)
-        {
-            g_debug ("Active display stopped, switching to greeter");
-            if (!seat_switch_to_greeter (seat))
-            {
-                g_debug ("Stopping seat, unable to start greeter");
-                seat_stop (seat);              
-            }
-        }
-    }
-
-    g_object_unref (display);
-
-    check_stopped (seat);
-}
-
-static Display *
-create_display (Seat *seat, const gchar *session_type)
-{
-    Display *display;
-    DisplayServer *display_server;
-
-    display_server = SEAT_GET_CLASS (seat)->create_display_server (seat, session_type);
-    display = display_new (display_server);
+display_server_stopped_cb (DisplayServer *display_server, Seat *seat)
+{
+    GList *list, *link;
+    Session *active_session;
+
+    g_debug ("Display server stopped");
+
+    g_signal_handlers_disconnect_matched (display_server, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, seat);
+    seat->priv->display_servers = g_list_remove (seat->priv->display_servers, display_server);
+
+    if (seat->priv->stopping)
+    {
+        check_stopped (seat);
+        g_object_unref (display_server);
+        return;
+    }
+
+    /* Stop all sessions on this display server */
+    list = g_list_copy (seat->priv->sessions);
+    for (link = list; link; link = link->next)
+        g_object_ref (link->data);
+    for (link = list; link; link = link->next)
+    {
+        Session *session = link->data;
+
+        if (session_get_display_server (session) != display_server || session_get_is_stopping (session))
+            continue;
+
+        /* Stop seat if this is the only display server and it failed to start a greeter */
+        if (IS_GREETER (session) &&
+            !session_get_is_started (session) &&
+            g_list_length (seat->priv->display_servers) == 0)
+        {
+            g_debug ("Stopping seat, greeter display server failed to start");
+            seat_stop (seat);
+        }
+
+        g_debug ("Stopping session");
+        session_stop (session);
+    }
+    g_list_free_full (list, g_object_unref);
+
+    if (!seat->priv->stopping && display_server_get_start_local_sessions (display_server))
+    {
+        /* If we were the active session, switch to a greeter */
+        active_session = seat_get_active_session (seat);
+        if (!active_session || session_get_display_server (active_session) == display_server)
+        {
+            g_debug ("Active display server stopped, starting greeter");
+            seat_switch_to_greeter (seat);
+        }
+    }
+
     g_object_unref (display_server);
-
-    g_signal_connect (display, "display-server-ready", G_CALLBACK (display_display_server_ready_cb), seat);  
-    g_signal_connect (display, "switch-to-user", G_CALLBACK (display_switch_to_user_cb), seat);
-    g_signal_connect (display, "switch-to-guest", G_CALLBACK (display_switch_to_guest_cb), seat);
-    g_signal_connect (display, "get-guest-username", G_CALLBACK (display_get_guest_username_cb), seat);
-    g_signal_connect (display, "create-session", G_CALLBACK (display_create_session_cb), seat);
-    g_signal_connect (display, "start-greeter", G_CALLBACK (display_start_greeter_cb), seat);
-    g_signal_connect (display, "start-session", G_CALLBACK (display_start_session_cb), seat);
-    g_signal_connect_after (display, "start-session", G_CALLBACK (display_session_started_cb), seat);
-    g_signal_connect (display, "create-display", G_CALLBACK (display_create_display_cb), seat);
-    g_signal_connect (display, "stopped", G_CALLBACK (display_stopped_cb), seat);
-    display_set_greeter_session (display, seat_get_string_property (seat, "greeter-session"));
-    display_set_session_wrapper (display, seat_get_string_property (seat, "session-wrapper"));
-    display_set_greeter_wrapper (display, seat_get_string_property (seat, "greeter-wrapper"));
-    display_set_hide_users_hint (display, seat_get_boolean_property (seat, "greeter-hide-users"));
-    display_set_show_manual_login_hint (display, seat_get_boolean_property (seat, "greeter-show-manual-login"));
-    display_set_show_remote_login_hint (display, seat_get_boolean_property (seat, "greeter-show-remote-login"));
-    display_set_allow_guest (display, seat_get_allow_guest (seat));
-    display_set_greeter_allow_guest (display, seat_get_greeter_allow_guest (seat));
-    display_set_user_session (display, SESSION_TYPE_LOCAL, seat_get_string_property (seat, "user-session"));
-    display_set_share_display_server (display, seat->priv->share_display_server);
-
-    seat->priv->displays = g_list_append (seat->priv->displays, display);
-
-    return display;
+}
+
+static void
+switch_to_greeter_from_failed_session (Seat *seat, Session *session)
+{
+    Greeter *greeter_session;
+
+    greeter_session = create_greeter_session (seat);
+    if (session_get_is_guest (session))
+        greeter_set_hint (greeter_session, "select-guest", "true");
+    else
+        greeter_set_hint (greeter_session, "select-user", session_get_username (session));
+    if (seat->priv->session_to_activate)
+        g_object_unref (seat->priv->session_to_activate);
+    seat->priv->session_to_activate = g_object_ref (greeter_session);
+
+    if (seat->priv->share_display_server)
+        session_set_display_server (SESSION (greeter_session), session_get_display_server (session));
+    else
+    {
+        DisplayServer *display_server;
+
+        display_server = create_display_server (seat);
+        if (!display_server_start (display_server))
+        {
+            g_debug ("Failed to start display server for greeter");
+            seat_stop (seat);
+        }
+
+        session_set_display_server (session, display_server);
+    }
+
+    start_session (seat, SESSION (greeter_session));
+
+    /* Stop failed session */
+    session_stop (session);
+}
+
+static void
+start_session (Seat *seat, Session *session)
+{
+    if (session_start (session))
+        return;
+
+    if (IS_GREETER (session))
+    {
+        g_debug ("Failed to start greeter");
+        display_server_stop (session_get_display_server (session));
+        return;
+    }
+
+    g_debug ("Failed to start session, starting greeter");
+    switch_to_greeter_from_failed_session (seat, session);
+}
+
+static void
+run_session (Seat *seat, Session *session)
+{
+    const gchar *script;
+
+    if (IS_GREETER (session))
+        script = seat_get_string_property (seat, "greeter-setup-script");
+    else
+        script = seat_get_string_property (seat, "session-setup-script");
+    if (script && !run_script (seat, session_get_display_server (session), script, NULL))
+    {
+        g_debug ("Switching to greeter due to failed setup script");
+        switch_to_greeter_from_failed_session (seat, session);
+        return;
+    }
+
+    if (!IS_GREETER (session))
+        g_signal_emit (seat, signals[RUNNING_USER_SESSION], 0, session);
+
+    session_run (session);
+
+    // FIXME: Wait until the session is ready
+
+    if (session == seat->priv->session_to_activate)
+    {
+        seat_set_active_session (seat, session);
+        g_object_unref (seat->priv->session_to_activate);
+        seat->priv->session_to_activate = NULL;
+    }
+}
+
+static void
+session_authentication_complete_cb (Session *session, Seat *seat)
+{
+    if (session_get_is_authenticated (session))
+    {
+        g_debug ("Session authenticated, running command");
+        run_session (seat, session);
+    }
+    else if (!IS_GREETER (session))
+    {
+        g_debug ("Switching to greeter due to failed authentication");
+        switch_to_greeter_from_failed_session (seat, session);
+    }
+    else
+    {
+        g_debug ("Stopping session that failed authentication");
+        session_stop (session);
+    }
+}
+
+static void
+session_stopped_cb (Session *session, Seat *seat)
+{
+    DisplayServer *display_server;
+
+    g_debug ("Session stopped");
+
+    display_server = session_get_display_server (session);
+
+    /* Cleanup */
+    if (!IS_GREETER (session))
+    {
+        const gchar *script;
+        script = seat_get_string_property (seat, "session-cleanup-script");
+        if (script)
+            run_script (seat, display_server, script, session_get_user (session));
+    }
+
+    g_signal_handlers_disconnect_matched (session, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, seat);
+    seat->priv->sessions = g_list_remove (seat->priv->sessions, session);
+
+    /* We were waiting for this session, but it didn't start :( */
+    // FIXME: Start a greeter on this?
+    if (session == seat->priv->session_to_activate)
+    {
+        g_object_unref (seat->priv->session_to_activate);
+        seat->priv->session_to_activate = NULL;
+    }
+
+    if (seat->priv->stopping)
+    {
+        check_stopped (seat);
+        g_object_unref (session);
+        return;
+    }
+
+    /* If this is the greeter session then re-use this display server */
+    if (IS_GREETER (session) && seat->priv->share_display_server &&
+        greeter_get_start_session (GREETER (session)))
+    {
+        GList *link;
+
+        for (link = seat->priv->sessions; link; link = link->next)
+        {
+            Session *s = link->data;
+
+            /* Skip this session and sessions on other display servers */
+            if (s == session || session_get_display_server (s) != display_server || session_get_is_stopping (s))
+                continue;
+
+            if (session_get_is_authenticated (s))
+            {
+                g_debug ("Greeter stopped, running session");
+                run_session (seat, s);
+            }
+            else
+            {
+                g_debug ("Greeter stopped, starting session authentication");
+                start_session (seat, s);
+            }
+            break;
+        }
+    }
+    /* If this is the greeter and nothing else is running then stop the seat */
+    else if (IS_GREETER (session) &&
+        !greeter_get_start_session (GREETER (session)) &&
+        g_list_length (seat->priv->display_servers) == 1 &&
+        g_list_nth_data (seat->priv->display_servers, 0) == display_server)
+    {
+        g_debug ("Stopping seat, failed to start a greeter");
+        seat_stop (seat);
+    }
+    /* If we were the active session, switch to a greeter */
+    else if (!IS_GREETER (session) && session == seat_get_active_session (seat))
+    {
+        g_debug ("Active session stopped, starting greeter");
+        seat_switch_to_greeter (seat);
+    }
+
+    /* Stop the display server if no-longer required */
+    if (display_server && !display_server_get_is_stopping (display_server))
+    {
+        GList *link;
+        int n_sessions = 0;
+
+        for (link = seat->priv->sessions; link; link = link->next)
+        {
+            Session *s = link->data;
+            if (s == session)
+                continue;
+            if (session_get_display_server (s) == display_server)
+                n_sessions++;
+        }
+        if (n_sessions == 0)
+        {
+            g_debug ("Stopping display server, no sessions require it");
+            display_server_stop (display_server);
+        }
+    }
+
+    g_signal_emit (seat, signals[SESSION_REMOVED], 0, session);
+    g_object_unref (session);
+}
+
+static void
+set_session_env (Session *session)
+{
+    /* Connect using the session bus */
+    if (getuid () != 0)
+    {
+        if (g_getenv ("DBUS_SESSION_BUS_ADDRESS"))
+            session_set_env (session, "DBUS_SESSION_BUS_ADDRESS", g_getenv ("DBUS_SESSION_BUS_ADDRESS"));
+        session_set_env (session, "LDM_BUS", "SESSION");
+        if (g_getenv ("LD_PRELOAD"))
+            session_set_env (session, "LD_PRELOAD", g_getenv ("LD_PRELOAD"));
+        if (g_getenv ("LD_LIBRARY_PATH"))
+            session_set_env (session, "LD_LIBRARY_PATH", g_getenv ("LD_LIBRARY_PATH"));
+        if (g_getenv ("PATH"))
+            session_set_env (session, "PATH", g_getenv ("PATH"));
+    }
+
+    /* Variables required for regression tests */
+    if (g_getenv ("LIGHTDM_TEST_ROOT"))
+    {
+        session_set_env (session, "LIGHTDM_TEST_ROOT", g_getenv ("LIGHTDM_TEST_ROOT"));
+        session_set_env (session, "DBUS_SYSTEM_BUS_ADDRESS", g_getenv ("DBUS_SYSTEM_BUS_ADDRESS"));
+        session_set_env (session, "DBUS_SESSION_BUS_ADDRESS", g_getenv ("DBUS_SESSION_BUS_ADDRESS"));
+        session_set_env (session, "LD_PRELOAD", g_getenv ("LD_PRELOAD"));
+        session_set_env (session, "LD_LIBRARY_PATH", g_getenv ("LD_LIBRARY_PATH"));
+        session_set_env (session, "GI_TYPELIB_PATH", g_getenv ("GI_TYPELIB_PATH"));
+    }
+}
+
+static Session *
+create_session (Seat *seat, gboolean autostart)
+{
+    Session *session;
+
+    session = SEAT_GET_CLASS (seat)->create_session (seat);
+    seat->priv->sessions = g_list_append (seat->priv->sessions, session);
+    if (autostart)
+        g_signal_connect (session, "authentication-complete", G_CALLBACK (session_authentication_complete_cb), seat);
+    g_signal_connect (session, "stopped", G_CALLBACK (session_stopped_cb), seat);
+
+    set_session_env (session);
+
+    g_signal_emit (seat, signals[SESSION_ADDED], 0, session);
+
+    return session;
+}
+
+static gchar **
+get_session_argv_from_filename (const gchar *filename, const gchar *session_wrapper)
+{
+    GKeyFile *session_desktop_file;
+    gboolean result;
+    int argc;
+    gchar *command = NULL, **argv, *path;
+    GError *error = NULL;
+
+    /* Read the command from the .desktop file */
+    session_desktop_file = g_key_file_new ();
+    result = g_key_file_load_from_file (session_desktop_file, filename, G_KEY_FILE_NONE, &error);
+    if (error)
+        g_debug ("Failed to load session file %s: %s", filename, error->message);
+    g_clear_error (&error);
+    if (result)
+    {
+        command = g_key_file_get_string (session_desktop_file, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_EXEC, NULL);
+        if (!command)
+            g_debug ("No command in session file %s", filename);
+    }
+    g_key_file_free (session_desktop_file);
+
+    if (!command)
+        return NULL;
+
+    /* If configured, run sessions through a wrapper */
+    if (session_wrapper)
+    {
+        argv = g_malloc (sizeof (gchar *) * 3);
+        path = g_find_program_in_path (session_wrapper);
+        argv[0] = path ? path : g_strdup (session_wrapper);
+        argv[1] = command;
+        argv[2] = NULL;
+        return argv;
+    }
+
+    /* Split command into an array listing and make command absolute */
+    result = g_shell_parse_argv (command, &argc, &argv, &error);
+    if (error)
+        g_debug ("Invalid session command '%s': %s", command, error->message);
+    g_clear_error (&error);
+    g_free (command);
+    if (!result)
+        return NULL;
+    path = g_find_program_in_path (argv[0]);
+    if (path)
+    {
+        g_free (argv[0]);
+        argv[0] = path;
+    }
+  
+    return argv;
+}
+
+static gchar **
+get_session_argv (const gchar *sessions_dir, const gchar *session_name, const gchar *session_wrapper)
+{
+    gchar **dirs, **argv = NULL;
+    int i;
+
+    g_return_val_if_fail (sessions_dir != NULL, NULL);
+    g_return_val_if_fail (session_name != NULL, NULL);
+
+    dirs = g_strsplit (sessions_dir, ":", -1);
+    for (i = 0; dirs[i]; i++)
+    {
+        gchar *filename, *path;
+
+        filename = g_strdup_printf ("%s.desktop", session_name);
+        path = g_build_filename (dirs[i], filename, NULL);
+        g_free (filename);
+        argv = get_session_argv_from_filename (path, session_wrapper);
+        g_free (path);
+        if (argv)
+            break;
+    }
+    g_strfreev (dirs);
+
+    return argv;
+}
+
+static Session *
+create_user_session (Seat *seat, const gchar *username)
+{
+    User *user;
+    gchar *sessions_dir, **argv;
+    const gchar *session_name, *language;
+    Session *session = NULL;
+
+    /* Load user preferences */
+    user = accounts_get_user_by_name (username);
+    if (!user)
+    {
+        g_debug ("Can't login unknown user '%s'", username);
+        return NULL;
+    }
+    session_name = user_get_xsession (user);
+    language = user_get_language (user);
+
+    if (!session_name)
+        session_name = seat_get_string_property (seat, "user-session");
+    sessions_dir = config_get_string (config_get_instance (), "LightDM", "sessions-directory");
+    argv = get_session_argv (sessions_dir, session_name, seat_get_string_property (seat, "session-wrapper"));
+    g_free (sessions_dir);
+    if (argv)
+    {
+        session = create_session (seat, TRUE);
+        session_set_env (session, "DESKTOP_SESSION", session_name);
+        session_set_env (session, "GDMSESSION", session_name);
+        if (language && language[0] != '\0')
+        {
+            session_set_env (session, "LANG", language);
+            session_set_env (session, "GDM_LANG", language);
+        }
+        session_set_pam_service (session, AUTOLOGIN_SERVICE);
+        session_set_username (session, username);
+        session_set_do_authenticate (session, TRUE);
+        session_set_argv (session, argv);     
+    }
+    else
+        g_debug ("Can't find session '%s'", seat_get_string_property (seat, "user-session"));
+
+    g_object_unref (user);
+
+    return session;
+}
+
+static Session *
+create_guest_session (Seat *seat)
+{
+    gchar *sessions_dir, **argv;
+    Session *session;
+
+    sessions_dir = config_get_string (config_get_instance (), "LightDM", "sessions-directory");
+    argv = get_session_argv (sessions_dir,
+                             seat_get_string_property (seat, "user-session"),
+                             seat_get_string_property (seat, "session-wrapper"));
+    g_free (sessions_dir);
+    if (!argv)
+    {
+        g_debug ("Can't find session '%s'", seat_get_string_property (seat, "user-session"));
+        return NULL;
+    }
+
+    session = create_session (seat, TRUE);
+    session_set_do_authenticate (session, TRUE);
+    session_set_is_guest (session, TRUE);
+    session_set_argv (session, argv);
+  
+    return session;
+}
+
+static Session *
+greeter_create_session_cb (Greeter *greeter, Seat *seat)
+{
+    Session *session;
+
+    session = create_session (seat, FALSE);
+    session_set_display_server (session, session_get_display_server (SESSION (greeter)));
+
+    return g_object_ref (session);
+}
+
+static void
+prepend_argv (gchar ***argv, const gchar *value)
+{
+    gchar **old_argv, **new_argv;
+    gint i;
+
+    old_argv = *argv;
+    new_argv = g_malloc (sizeof (gchar *) * (g_strv_length (*argv) + 2));
+    new_argv[0] = g_strdup (value);
+    for (i = 0; old_argv[i]; i++)
+        new_argv[i + 1] = old_argv[i];
+    new_argv[i + 1] = NULL;
+
+    g_free (*argv);
+    *argv = new_argv;
+}
+
+static Session *
+find_user_session (Seat *seat, const gchar *username)
+{
+    GList *link;
+
+    if (!username)
+        return NULL;
+
+    for (link = seat->priv->sessions; link; link = link->next)
+    {
+        Session *session = link->data;
+
+        if (!session_get_is_stopping (session) && strcmp (session_get_username (session), username) == 0)
+            return session;
+    }
+
+    return NULL;
 }
 
 static gboolean
-start_display (Seat *seat, Display *display)
-{
-    g_signal_emit (seat, signals[DISPLAY_ADDED], 0, display);
-
-    /* Switch to this display if currently not looking at anything */
-    if (seat_get_active_display (seat) == NULL)
-        seat_set_active_display (seat, display);
-
-    return display_start (display);
+greeter_start_session_cb (Greeter *greeter, SessionType type, const gchar *session_name, Seat *seat)
+{
+    Session *session, *existing_session;
+    const gchar *username, *language = NULL;
+    User *user;
+    gchar *sessions_dir = NULL;
+    gchar **argv;
+
+    /* Get the session to use */
+    if (greeter_get_guest_authenticated (greeter))
+    {
+        session = create_guest_session (seat);
+        if (!session)
+            return FALSE;
+        session_set_pam_service (session, AUTOLOGIN_SERVICE);
+    }
+    else
+        session = greeter_get_authentication_session (greeter);
+
+    /* Switch to this session when it is ready */
+    if (seat->priv->session_to_activate)
+        g_object_unref (seat->priv->session_to_activate);
+    seat->priv->session_to_activate = g_object_ref (session);
+
+    /* Return to existing session if it is open */
+    username = session_get_username (session);
+    existing_session = find_user_session (seat, username);
+    if (existing_session && session != existing_session)
+    {
+        g_debug ("Returning to existing user session %s", username);
+        session_stop (session);
+        seat_set_active_session (seat, existing_session);
+        return TRUE;
+    }
+
+    /* Get session command to run */
+    switch (type)
+    {
+    case SESSION_TYPE_LOCAL:
+        sessions_dir = config_get_string (config_get_instance (), "LightDM", "sessions-directory");
+        break;
+    case SESSION_TYPE_REMOTE:
+        sessions_dir = config_get_string (config_get_instance (), "LightDM", "remote-sessions-directory");
+        break;
+    }
+
+    /* Load user preferences */
+    user = session_get_user (session);
+    if (user)
+    {
+        if (!session_name)
+            session_name = user_get_xsession (user);
+        language = user_get_language (user);
+    }
+
+    if (!session_name)
+        session_name = seat_get_string_property (seat, "user-session");
+    if (user)
+        user_set_xsession (session_get_user (session), session_name);
+
+    argv = get_session_argv (sessions_dir, session_name, seat_get_string_property (seat, "session-wrapper"));
+    g_free (sessions_dir);
+  
+    if (!argv)
+    {
+        g_debug ("Can't find session '%s'", seat_get_string_property (seat, "user-session"));
+        return FALSE;
+    }
+
+    session_set_argv (session, argv);
+    g_strfreev (argv);
+    session_set_env (session, "DESKTOP_SESSION", session_name);
+    session_set_env (session, "GDMSESSION", session_name);
+    if (language && language[0] != '\0')
+    {
+        session_set_env (session, "LANG", language);
+        session_set_env (session, "GDM_LANG", language);
+    }
+
+    /* If can re-use the display server, stop the greeter first */
+    if (seat->priv->share_display_server)
+    {
+        /* Run on the same display server after the greeter has stopped */
+        session_set_display_server (session, session_get_display_server (SESSION (greeter)));
+
+        g_debug ("Stopping greeter");
+        session_stop (SESSION (greeter));
+
+        return TRUE;
+    }
+    /* Otherwise start a new display server for this session */
+    else
+    {
+        DisplayServer *display_server;
+
+        display_server = create_display_server (seat);
+        if (!display_server_start (display_server))
+            return FALSE;
+
+        session_set_display_server (session, display_server);
+
+        return TRUE;
+    }
+}
+
+static Greeter *
+create_greeter_session (Seat *seat)
+{
+    gchar *sessions_dir, **argv;
+    Greeter *greeter_session;
+    gchar *greeter_user;
+    const gchar *greeter_wrapper;
+
+    sessions_dir = config_get_string (config_get_instance (), "LightDM", "greeters-directory");
+    argv = get_session_argv (sessions_dir,
+                             seat_get_string_property (seat, "greeter-session"),
+                             NULL);
+    g_free (sessions_dir);
+    if (!argv)
+        return NULL;
+
+    greeter_wrapper = seat_get_string_property (seat, "greeter-wrapper");
+    if (greeter_wrapper)
+    {
+        gchar *path;
+        path = g_find_program_in_path (greeter_wrapper);
+        prepend_argv (&argv, path ? path : greeter_wrapper);
+        g_free (path);
+    }
+
+    greeter_session = SEAT_GET_CLASS (seat)->create_greeter_session (seat);
+    seat->priv->sessions = g_list_append (seat->priv->sessions, SESSION (greeter_session));
+    g_signal_connect (greeter_session, "authentication-complete", G_CALLBACK (session_authentication_complete_cb), seat);
+    g_signal_connect (greeter_session, "stopped", G_CALLBACK (session_stopped_cb), seat);
+  
+    set_session_env (SESSION (greeter_session));
+
+    session_set_pam_service (SESSION (greeter_session), GREETER_SERVICE);
+    greeter_user = config_get_string (config_get_instance (), "LightDM", "greeter-user");
+    session_set_username (SESSION (greeter_session), greeter_user);
+    g_free (greeter_user);
+    session_set_argv (SESSION (greeter_session), argv);
+
+    greeter_set_pam_services (greeter_session, USER_SERVICE, AUTOLOGIN_SERVICE);
+    g_signal_connect (greeter_session, "create-session", G_CALLBACK (greeter_create_session_cb), seat);
+    g_signal_connect (greeter_session, "start-session", G_CALLBACK (greeter_start_session_cb), seat);
+
+    /* Set hints to greeter */
+    greeter_set_hint (greeter_session, "default-session", seat_get_string_property (seat, "user-session"));
+    greeter_set_allow_guest (greeter_session, seat_get_allow_guest (seat));
+    greeter_set_hint (greeter_session, "hide-users", seat_get_boolean_property (seat, "greeter-hide-users") ? "true" : "false");
+    greeter_set_hint (greeter_session, "show-manual-login", seat_get_boolean_property (seat, "greeter-show-manual-login") ? "true" : "false");
+    greeter_set_hint (greeter_session, "show-remote-login", seat_get_boolean_property (seat, "greeter-show-remote-login") ? "true" : "false");
+    greeter_set_hint (greeter_session, "has-guest-account", seat_get_allow_guest (seat) && seat_get_boolean_property (seat, "greeter-allow-guest") ? "true" : "false");
+
+    return greeter_session;
+}
+
+static Session *
+find_session_for_display_server (Seat *seat, DisplayServer *display_server)
+{
+    GList *link;
+
+    for (link = seat->priv->sessions; link; link = link->next)
+    {
+        Session *session = link->data;
+        if (session_get_display_server (session) == display_server && !session_get_is_stopping (session))
+            return session;
+    }
+
+    return NULL;
+}
+
+static void
+display_server_ready_cb (DisplayServer *display_server, Seat *seat)
+{
+    const gchar *script;
+    Session *session;
+
+    /* Run setup script */
+    script = seat_get_string_property (seat, "display-setup-script");
+    if (script && !run_script (seat, display_server, script, NULL))
+    {
+        g_debug ("Stopping display server due to failed setup script");
+        display_server_stop (display_server);
+        return;
+    }
+
+    /* Stop if don't need to run a session */
+    if (!display_server_get_start_local_sessions (display_server))
+        return;
+
+    emit_upstart_signal ("login-session-start");
+
+    /* Start the session waiting for this display server */
+    session = find_session_for_display_server (seat, display_server);
+    if (session)
+    {
+        if (session_get_is_authenticated (session))
+        {
+            g_debug ("Display server ready, running session");
+            run_session (seat, session);
+        }
+        else
+        {
+            g_debug ("Display server ready, starting session authentication");
+            start_session (seat, session);
+        }
+    }
+    else
+    {
+        g_debug ("Stopping not required display server");
+        display_server_stop (display_server);
+    }
+}
+
+static DisplayServer *
+create_display_server (Seat *seat)
+{
+    DisplayServer *display_server;
+
+    display_server = SEAT_GET_CLASS (seat)->create_display_server (seat, "");
+    seat->priv->display_servers = g_list_append (seat->priv->display_servers, display_server);
+    g_signal_connect (display_server, "ready", G_CALLBACK (display_server_ready_cb), seat);
+    g_signal_connect (display_server, "stopped", G_CALLBACK (display_server_stopped_cb), seat);
+
+    return display_server;
+}
+
+static Greeter *
+find_greeter_session (Seat *seat)
+{
+    GList *link;
+
+    for (link = seat->priv->sessions; link; link = link->next)
+    {
+        Session *session = link->data;
+        if (!session_get_is_stopping (session) && IS_GREETER (session))
+            return GREETER (session);
+    }
+
+    return NULL;
 }
 
 gboolean
 seat_switch_to_greeter (Seat *seat)
 {
-    Display *display;
+    Greeter *greeter_session;
+    DisplayServer *display_server;
 
     g_return_val_if_fail (seat != NULL, FALSE);
 
     if (!seat->priv->can_switch)
         return FALSE;
 
-    g_debug ("Switching to greeter");
-
     /* Switch to greeter if one open (shouldn't be though) */
-    if (switch_to_user (seat, NULL, FALSE))
+    greeter_session = find_greeter_session (seat);
+    if (greeter_session)
+    {
+        g_debug ("Switching to existing greeter");
+        seat_set_active_session (seat, SESSION (greeter_session));
         return TRUE;
-
-    g_debug ("Starting new display for greeter");
-
-    display = create_display (seat, "x" /*FIXME greeter_type */);
-    g_signal_connect (display, "ready", G_CALLBACK (display_ready_cb), seat);
-
-    return start_display (seat, display);
+    }
+
+    greeter_session = create_greeter_session (seat);
+    if (seat->priv->session_to_activate)
+        g_object_unref (seat->priv->session_to_activate);
+    seat->priv->session_to_activate = g_object_ref (greeter_session);
+
+    display_server = create_display_server (seat);
+    session_set_display_server (SESSION (greeter_session), display_server);
+    if (!display_server_start (display_server))
+        return FALSE;
+
+    return TRUE;
 }
 
 gboolean
 seat_switch_to_user (Seat *seat, const gchar *username, const gchar *session_name)
 {
-    Display *display;
+    Session *session;
+    DisplayServer *display_server;
 
     g_return_val_if_fail (seat != NULL, FALSE);
     g_return_val_if_fail (username != NULL, FALSE);
@@ -586,28 +1104,50 @@
 
     g_debug ("Switching to user %s", username);
 
-    /* Switch to session if one open */
-    if (switch_to_user (seat, username, FALSE))
+    session = find_user_session (seat, username);
+    if (session)
+    {
+        g_debug ("Switching to existing user session %s", username);
+        seat_set_active_session (seat, session);
         return TRUE;
-
-    if (username)
-        g_debug ("Starting new display for greeter with user %s selected", username);
-    else
-        g_debug ("Starting new display for greeter");
-
-    display = create_display (seat, "x" /* FIXME greeter_type */);
-    g_signal_connect (display, "ready", G_CALLBACK (display_ready_cb), seat);
-    display_set_select_user_hint (display, username, FALSE, TRUE);
-    if (session_name != NULL)
-        display_set_user_session (display, SESSION_TYPE_LOCAL, session_name);
-
-    return start_display (seat, display);
+    }
+
+    session = create_user_session (seat, username);
+    if (!session)
+        return FALSE;
+    if (seat->priv->session_to_activate)
+        g_object_unref (seat->priv->session_to_activate);
+    seat->priv->session_to_activate = g_object_ref (session);
+    session_set_pam_service (session, USER_SERVICE);
+
+    display_server = create_display_server (seat);
+    session_set_display_server (session, display_server);
+    if (!display_server_start (display_server))
+        return FALSE;
+
+    return FALSE;
+}
+
+static Session *
+find_guest_session (Seat *seat)
+{
+    GList *link;
+
+    for (link = seat->priv->sessions; link; link = link->next)
+    {
+        Session *session = link->data;
+        if (!session_get_is_stopping (session) && session_get_is_guest (session))
+            return session;
+    }
+
+    return NULL;
 }
 
 gboolean
 seat_switch_to_guest (Seat *seat, const gchar *session_name)
 {
-    Display *display;
+    Session *session;
+    DisplayServer *display_server;
 
     g_return_val_if_fail (seat != NULL, FALSE);
 
@@ -615,27 +1155,35 @@
         return FALSE;
 
     /* Switch to session if one open */
-    if (seat->priv->guest_username)
+    session = find_guest_session (seat);
+    if (session)
     {
-        g_debug ("Switching to existing guest account %s", seat->priv->guest_username);
-        return switch_to_user (seat, seat->priv->guest_username, FALSE);
+        g_debug ("Switching to existing guest account %s", session_get_username (session));
+        seat_set_active_session (seat, session);
+        return TRUE;
     }
 
-    g_debug ("Starting new display for automatic guest login");
-
-    display = create_display (seat, "x" /* FIXME guest_type */);
-    g_signal_connect (display, "ready", G_CALLBACK (display_ready_cb), seat);
-    display_set_autologin_user (display, NULL, TRUE, 0);
-    if (session_name != NULL)
-        display_set_user_session (display, SESSION_TYPE_LOCAL, session_name);
-
-    return start_display (seat, display);
+    display_server = create_display_server (seat);
+    if (!display_server_start (display_server))
+        return FALSE;
+
+    session = create_guest_session (seat);
+    if (!session)
+        return FALSE;
+    if (seat->priv->session_to_activate)
+        g_object_unref (seat->priv->session_to_activate);
+    seat->priv->session_to_activate = g_object_ref (session);
+    session_set_pam_service (session, AUTOLOGIN_SERVICE);
+    session_set_display_server (session, display_server);
+
+    return TRUE;
 }
 
 gboolean
 seat_lock (Seat *seat, const gchar *username)
 {
-    Display *display;
+    Greeter *greeter_session;
+    DisplayServer *display_server;
 
     g_return_val_if_fail (seat != NULL, FALSE);
 
@@ -645,17 +1193,28 @@
     g_debug ("Locking seat");
 
     /* Switch to greeter if one open (shouldn't be though) */
-    if (switch_to_user (seat, NULL, FALSE))
+    greeter_session = find_greeter_session (seat);
+    if (greeter_session)
+    {
+        g_debug ("Switching to existing greeter");
+        seat_set_active_session (seat, SESSION (greeter_session));
         return TRUE;
-
-    g_debug ("Starting new display for greeter (lock screen)");
-
-    display = create_display (seat, "x" /* FIXMEgreeter_type */);
-    g_signal_connect (display, "ready", G_CALLBACK (display_ready_cb), seat);
-    display_set_lock_hint (display, TRUE);
-    display_set_select_user_hint (display, username, FALSE, FALSE);
-
-    return start_display (seat, display);
+    }
+
+    display_server = create_display_server (seat);
+    if (!display_server_start (display_server))
+        return FALSE;
+
+    greeter_session = create_greeter_session (seat);
+    if (seat->priv->session_to_activate)
+        g_object_unref (seat->priv->session_to_activate);
+    seat->priv->session_to_activate = g_object_ref (greeter_session);
+    greeter_set_hint (greeter_session, "lock-screen", "true");
+    if (username)
+        greeter_set_hint (greeter_session, "select-user", username);
+    session_set_display_server (SESSION (greeter_session), display_server);
+
+    return TRUE;
 }
 
 void
@@ -683,44 +1242,24 @@
 {
 }
 
-static void
-autologin_greeter_ready_cb (Display *display, Seat *seat)
-{
-    const gchar *autologin_username;
-    gboolean autologin_guest;
-    Display *autologin_display;
-
-    g_debug ("Greeter ready, starting autologin session");
-
-    /* Get autologin settings */
-    autologin_username = seat_get_string_property (seat, "autologin-user");
-    if (g_strcmp0 (autologin_username, "") == 0)
-        autologin_username = NULL;
-    autologin_guest = seat_get_boolean_property (seat, "autologin-guest");
-
-    if (autologin_guest)
-        g_debug ("Starting new display for automatic guest login");
-    else if (autologin_username)
-        g_debug ("Starting new display for automatic login as user %s", autologin_username);
-
-    autologin_display = create_display (seat, "x" /* FIXMEsession_type */);
-    display_set_autologin_user (autologin_display, autologin_username, autologin_guest, 0);
-
-    start_display (seat, autologin_display);
-}
-
 static gboolean
 seat_real_start (Seat *seat)
 {
     const gchar *autologin_username;
     int autologin_timeout;
     gboolean autologin_guest;
-    gboolean do_autologin;
     gboolean autologin_in_background;
-    Display *display;
+    Session *session = NULL;
+    DisplayServer *display_server;
 
     g_debug ("Starting seat");
 
+    display_server = create_display_server (seat);
+
+    /* If this display server doesn't have a session running on it, just start it */
+    if (!display_server_get_start_local_sessions (display_server))
+        return display_server_start (display_server);
+
     /* Get autologin settings */
     autologin_username = seat_get_string_property (seat, "autologin-user");
     if (g_strcmp0 (autologin_username, "") == 0)
@@ -728,31 +1267,76 @@
     autologin_timeout = seat_get_integer_property (seat, "autologin-user-timeout");
     autologin_guest = seat_get_boolean_property (seat, "autologin-guest");
     autologin_in_background = seat_get_boolean_property (seat, "autologin-in-background");
-    do_autologin = autologin_username != NULL || autologin_guest;
-
-    /* Background automatic logins need the greeter showing first */
-    if (do_autologin && autologin_in_background && !switch_to_user (seat, NULL, FALSE)) 
-    {
-        g_debug ("Autologin in background, opening greeter first");
-        display = create_display (seat, "x" /* FIXMEgreeter_type */);
-        g_signal_connect (display, "ready", G_CALLBACK (autologin_greeter_ready_cb), seat);
-        if (autologin_timeout > 0)
-            display_set_autologin_user (display, autologin_username, autologin_guest, autologin_timeout);
-        return start_display (seat, display);
-    }
-
-    if (autologin_guest)
-        g_debug ("Starting new display for automatic guest login");
-    else if (autologin_username)
-        g_debug ("Starting new display for automatic login as user %s", autologin_username);
-    else
-        g_debug ("Starting new display for greeter");
-
-    display = create_display (seat, "x" /* FIXMEsession_type */);
-    g_signal_connect (display, "ready", G_CALLBACK (display_ready_cb), seat);
-    display_set_autologin_user (display, autologin_username, autologin_guest, autologin_timeout);
-
-    return start_display (seat, display);
+
+    /* Autologin if configured */
+    if (autologin_timeout == 0 || autologin_in_background)
+    {
+        if (autologin_guest)
+            session = create_guest_session (seat);
+        else if (autologin_username != NULL)
+            session = create_user_session (seat, autologin_username);
+      
+        if (session)
+        {
+            if (seat->priv->session_to_activate)
+                g_object_unref (seat->priv->session_to_activate);
+            seat->priv->session_to_activate = g_object_ref (session);
+            session_set_pam_service (session, AUTOLOGIN_SERVICE);
+        }
+
+        /* Load in background if required */
+        if (autologin_in_background && session)
+        {
+            DisplayServer *background_display_server;
+
+            background_display_server = create_display_server (seat);
+            session_set_display_server (session, background_display_server);
+            if (!display_server_start (background_display_server))
+                return FALSE;
+
+            /* Start a greeter as well */
+            session = NULL;
+        }
+    }
+
+    /* Fallback to a greeter */
+    if (!session)
+    {
+        Greeter *greeter_session;
+
+        greeter_session = create_greeter_session (seat);
+        if (seat->priv->session_to_activate)
+            g_object_unref (seat->priv->session_to_activate);
+        seat->priv->session_to_activate = g_object_ref (greeter_session);
+        session = SESSION (greeter_session);
+
+        if (autologin_timeout)
+        {
+            gchar *value;
+
+            value = g_strdup_printf ("%d", autologin_timeout);
+            greeter_set_hint (greeter_session, "autologin-timeout", value);
+            g_free (value);
+            if (autologin_username)
+                greeter_set_hint (greeter_session, "autologin-user", autologin_username);
+            if (autologin_guest)
+                greeter_set_hint (greeter_session, "autologin-guest", "true");
+        }
+    }
+
+    /* Fail if can't start a session */
+    if (!session)
+    {
+        seat_stop (seat);
+        return FALSE;
+    }
+
+    /* Start display server to show session on */
+    session_set_display_server (session, display_server);
+    if (!display_server_start (display_server))
+        return FALSE;
+
+    return TRUE;
 }
 
 static DisplayServer *
@@ -762,30 +1346,12 @@
 }
 
 static void
-seat_real_set_active_display (Seat *seat, Display *display)
+seat_real_set_active_session (Seat *seat, Session *session)
 {
-    GList *link;
-
-    for (link = seat->priv->displays; link; link = link->next)
-    {
-        Display *d = link->data;
-
-        if (d == display)
-            continue;
-
-        /* Stop any greeters and lock any other sessions */
-        if (!display_get_username (d))
-        {
-            g_debug ("Stopping background greeter");
-            display_stop (d);
-        }
-        else
-            display_lock (d);
-    }  
 }
 
-static Display *
-seat_real_get_active_display (Seat *seat)
+static Session *
+seat_real_get_active_session (Seat *seat)
 {
     return NULL;
 }
@@ -793,20 +1359,40 @@
 static void
 seat_real_stop (Seat *seat)
 {
-    GList *displays, *link;
+    GList *list, *link;
 
     check_stopped (seat);
     if (seat->priv->stopped)
         return;
 
-    /* Stop all the displays on the seat. Copy the list as it might be modified if a display stops during this loop */
-    displays = g_list_copy (seat->priv->displays);
-    for (link = displays; link; link = link->next)
-    {
-        Display *display = link->data;
-        display_stop (display);
-    }
-    g_list_free (displays);
+    /* Stop all the display servers and sessions on the seat. Copy the list as
+     * it might be modified if a display server / session stops during this loop */
+    list = g_list_copy (seat->priv->display_servers);
+    for (link = list; link; link = link->next)
+        g_object_ref (link->data);
+    for (link = list; link; link = link->next)
+    {
+        DisplayServer *display_server = link->data;
+        if (!display_server_get_is_stopping (display_server))
+        {
+            g_debug ("Stopping display server");
+            display_server_stop (display_server);
+        }
+    }
+    g_list_free_full (list, g_object_unref);
+    list = g_list_copy (seat->priv->sessions);
+    for (link = list; link; link = link->next)
+        g_object_ref (link->data);
+    for (link = list; link; link = link->next)
+    {
+        Session *session = link->data;
+        if (!session_get_is_stopping (session))
+        {
+            g_debug ("Stopping session");
+            session_stop (session);
+        }
+    }
+    g_list_free_full (list, g_object_unref);
 }
 
 static void
@@ -826,13 +1412,20 @@
     self = SEAT (object);
 
     g_hash_table_unref (self->priv->properties);
-    g_free (self->priv->guest_username);
-    for (link = self->priv->displays; link; link = link->next)
+    for (link = self->priv->display_servers; link; link = link->next)
     {
-        Display *display = link->data;
-        g_signal_handlers_disconnect_matched (display, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, self);
+        DisplayServer *display_server = link->data;
+        g_signal_handlers_disconnect_matched (display_server, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, self);
     }  
-    g_list_free_full (self->priv->displays, g_object_unref);
+    g_list_free_full (self->priv->display_servers, g_object_unref);
+    for (link = self->priv->sessions; link; link = link->next)
+    {
+        Session *session = link->data;
+        g_signal_handlers_disconnect_matched (session, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, self);
+    }
+    g_list_free_full (self->priv->sessions, g_object_unref);
+    if (self->priv->session_to_activate)
+        g_object_unref (self->priv->session_to_activate);
 
     G_OBJECT_CLASS (seat_parent_class)->finalize (object);
 }
@@ -845,8 +1438,8 @@
     klass->setup = seat_real_setup;
     klass->start = seat_real_start;
     klass->create_display_server = seat_real_create_display_server;
-    klass->set_active_display = seat_real_set_active_display;
-    klass->get_active_display = seat_real_get_active_display;
+    klass->set_active_session = seat_real_set_active_session;
+    klass->get_active_session = seat_real_get_active_session;
     klass->run_script = seat_real_run_script;
     klass->stop = seat_real_stop;
 
@@ -854,28 +1447,36 @@
 
     g_type_class_add_private (klass, sizeof (SeatPrivate));
 
-    signals[DISPLAY_ADDED] =
-        g_signal_new ("display-added",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (SeatClass, display_added),
-                      NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
-                      G_TYPE_NONE, 1, DISPLAY_TYPE);
-    signals[DISPLAY_REMOVED] =
-        g_signal_new ("display-removed",
-                      G_TYPE_FROM_CLASS (klass),
-                      G_SIGNAL_RUN_LAST,
-                      G_STRUCT_OFFSET (SeatClass, display_removed),
-                      NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
-                      G_TYPE_NONE, 1, DISPLAY_TYPE);
+    signals[SESSION_ADDED] =
+        g_signal_new ("session-added",
+                      G_TYPE_FROM_CLASS (klass),
+                      G_SIGNAL_RUN_LAST,
+                      G_STRUCT_OFFSET (SeatClass, session_added),
+                      NULL, NULL,
+                      NULL,
+                      G_TYPE_NONE, 1, SESSION_TYPE);
+    signals[RUNNING_USER_SESSION] =
+        g_signal_new ("running-user-session",
+                      G_TYPE_FROM_CLASS (klass),
+                      G_SIGNAL_RUN_LAST,
+                      G_STRUCT_OFFSET (SeatClass, running_user_session),
+                      NULL, NULL,
+                      NULL,
+                      G_TYPE_NONE, 1, SESSION_TYPE);
+    signals[SESSION_REMOVED] =
+        g_signal_new ("session-removed",
+                      G_TYPE_FROM_CLASS (klass),
+                      G_SIGNAL_RUN_LAST,
+                      G_STRUCT_OFFSET (SeatClass, session_removed),
+                      NULL, NULL,
+                      NULL,
+                      G_TYPE_NONE, 1, SESSION_TYPE);
     signals[STOPPED] =
         g_signal_new ("stopped",
                       G_TYPE_FROM_CLASS (klass),
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (SeatClass, stopped),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 }

=== modified file 'src/seat.h'
--- src/seat.h	2013-07-23 02:10:40 +0000
+++ src/seat.h	2013-07-23 02:24:45 +0000
@@ -13,7 +13,9 @@
 #define SEAT_H_
 
 #include <glib-object.h>
-#include "display.h"
+#include "display-server.h"
+#include "greeter.h"
+#include "session.h"
 #include "process.h"
 
 G_BEGIN_DECLS
@@ -35,17 +37,19 @@
 {
     GObjectClass parent_class;
 
-    void (*setup)(Seat *seat);    
+    void (*setup)(Seat *seat);
     gboolean (*start)(Seat *seat);
     DisplayServer *(*create_display_server) (Seat *seat, const gchar *session_type);
-    Session *(*create_session) (Seat *seat, Display *display);
-    void (*set_active_display)(Seat *seat, Display *display);
-    Display *(*get_active_display)(Seat *seat);
-    void (*run_script)(Seat *seat, Display *display, Process *script);
+    Greeter *(*create_greeter_session) (Seat *seat);
+    Session *(*create_session) (Seat *seat);
+    void (*set_active_session)(Seat *seat, Session *session);
+    Session *(*get_active_session)(Seat *seat);
+    void (*run_script)(Seat *seat, DisplayServer *display_server, Process *script);
     void (*stop)(Seat *seat);
 
-    void (*display_added)(Seat *seat, Display *display);
-    void (*display_removed)(Seat *seat, Display *display);
+    void (*session_added)(Seat *seat, Session *session);
+    void (*running_user_session)(Seat *seat, Session *session);
+    void (*session_removed)(Seat *seat, Session *session);
     void (*stopped)(Seat *seat);
 } SeatClass;
 
@@ -57,8 +61,6 @@
 
 void seat_set_property (Seat *seat, const gchar *name, const gchar *value);
 
-gboolean seat_has_property (Seat *seat, const gchar *name);
-
 const gchar *seat_get_string_property (Seat *seat, const gchar *name);
 
 gboolean seat_get_boolean_property (Seat *seat, const gchar *name);
@@ -71,11 +73,11 @@
 
 gboolean seat_start (Seat *seat);
 
-GList *seat_get_displays (Seat *seat);
-
-void seat_set_active_display (Seat *seat, Display *display);
-
-Display *seat_get_active_display (Seat *seat);
+GList *seat_get_sessions (Seat *seat);
+
+void seat_set_active_session (Seat *seat, Session *session);
+
+Session *seat_get_active_session (Seat *seat);
 
 gboolean seat_get_can_switch (Seat *seat);
 

=== modified file 'src/session.c'
--- src/session.c	2013-07-23 02:10:40 +0000
+++ src/session.c	2013-07-23 02:24:45 +0000
@@ -59,6 +59,15 @@
     /* User object that matches the current username */
     User *user;
 
+    /* PAM service to use */
+    gchar *pam_service;
+
+    /* TRUE if should run PAM authentication phase */
+    gboolean do_authenticate;
+
+    /* TRUE if can handle PAM prompts */
+    gboolean is_interactive;
+
     /* Messages being requested by PAM */
     int messages_length;
     struct pam_message *messages;
@@ -94,6 +103,15 @@
 
     /* Environment to set in child */
     GList *env;
+
+    /* Command to run in child */
+    gchar **argv;
+
+    /* True if have run command */
+    gboolean command_run;
+
+    /* TRUE if stopping this session */
+    gboolean stopping;
 };
 
 /* Maximum length of a string to pass between daemon and session */
@@ -109,6 +127,50 @@
 }
 
 void
+session_set_pam_service (Session *session, const gchar *pam_service)
+{
+    g_return_if_fail (session != NULL);
+    g_free (session->priv->pam_service);
+    session->priv->pam_service = g_strdup (pam_service);
+}
+
+void
+session_set_username (Session *session, const gchar *username)
+{
+    g_return_if_fail (session != NULL);
+    g_free (session->priv->username);
+    session->priv->username = g_strdup (username);
+}
+
+void
+session_set_do_authenticate (Session *session, gboolean do_authenticate)
+{
+    g_return_if_fail (session != NULL);
+    session->priv->do_authenticate = do_authenticate;
+}
+
+void
+session_set_is_interactive (Session *session, gboolean is_interactive)
+{
+    g_return_if_fail (session != NULL);
+    session->priv->is_interactive = is_interactive;
+}
+
+void
+session_set_is_guest (Session *session, gboolean is_guest)
+{
+    g_return_if_fail (session != NULL);
+    session->priv->is_guest = is_guest;
+}
+
+gboolean
+session_get_is_guest (Session *session)
+{
+    g_return_val_if_fail (session != NULL, FALSE);
+    return session->priv->is_guest;
+}
+
+void
 session_set_log_file (Session *session, const gchar *filename)
 {
     g_return_if_fail (session != NULL);
@@ -124,20 +186,21 @@
     session->priv->class = g_strdup (class);
 }
 
-static void
-session_real_set_display_server (Session *session, DisplayServer *display_server)
+void
+session_set_display_server (Session *session, DisplayServer *display_server)
 {
+    g_return_if_fail (session != NULL);
+    g_return_if_fail (display_server != NULL);
     if (session->priv->display_server)
         g_object_unref (session->priv->display_server);
     session->priv->display_server = g_object_ref (display_server);
 }
 
-void
-session_set_display_server (Session *session, DisplayServer *display_server)
+DisplayServer *
+session_get_display_server (Session *session)
 {
-    g_return_if_fail (session != NULL);
-    g_return_if_fail (display_server != NULL);
-    SESSION_GET_CLASS (session)->set_display_server (session, display_server);
+    g_return_val_if_fail (session != NULL, NULL);
+    return session->priv->display_server;
 }
 
 void
@@ -161,8 +224,12 @@
 {
     g_return_if_fail (session != NULL);
     if (session->priv->xauthority)
+    {
         g_object_unref (session->priv->xauthority);
-    session->priv->xauthority = g_object_ref (authority);
+        session->priv->xauthority = NULL;
+    }
+    if (authority)
+        session->priv->xauthority = g_object_ref (authority);
     session->priv->xauth_use_system_location = use_system_location;
 }
 
@@ -181,6 +248,13 @@
     session->priv->env = g_list_append (session->priv->env, g_strdup_printf ("%s=%s", name, value));
 }
 
+void
+session_set_argv (Session *session, gchar **argv)
+{
+    g_return_if_fail (session != NULL);
+    session->priv->argv = g_strdupv (argv);
+}
+
 User *
 session_get_user (Session *session)
 {
@@ -380,14 +454,26 @@
 }
 
 gboolean
-session_start (Session *session, const gchar *service, const gchar *username, gboolean do_authenticate, gboolean is_interactive, gboolean is_guest)
+session_start (Session *session)
+{
+    g_return_val_if_fail (session != NULL, FALSE);
+    g_return_val_if_fail (session->priv->display_server != NULL, FALSE);
+    return SESSION_GET_CLASS (session)->start (session);
+}
+
+gboolean
+session_get_is_started (Session *session)
+{
+    return session->priv->pid != 0;
+}
+
+static gboolean
+session_real_start (Session *session)
 {
     int version;
     int to_child_pipe[2], from_child_pipe[2];
     int to_child_output, from_child_input;
 
-    g_return_val_if_fail (session != NULL, FALSE);
-    g_return_val_if_fail (service != NULL, FALSE);
     g_return_val_if_fail (session->priv->pid == 0, FALSE);
 
     /* Create pipes to talk to the child */
@@ -408,12 +494,12 @@
     fcntl (session->priv->from_child_output, F_SETFD, FD_CLOEXEC);
 
     /* Create the guest account if it is one */
-    session->priv->is_guest = is_guest;
-    if (is_guest && username == NULL)
-        username = guest_account_setup ();
-
-    /* Remember what username we started with - it will be updated by PAM during authentication */
-    session->priv->username = g_strdup (username);
+    if (session->priv->is_guest && session->priv->username == NULL)
+    {
+        session->priv->username = guest_account_setup ();
+        if (!session->priv->username)
+            return FALSE;
+    }
 
     /* Run the child */
     session->priv->pid = fork ();
@@ -453,17 +539,17 @@
     write_data (session, &version, sizeof (version));
 
     /* Send configuration */
-    write_string (session, service);
-    write_string (session, username);
-    write_data (session, &do_authenticate, sizeof (do_authenticate));
-    write_data (session, &is_interactive, sizeof (is_interactive));
+    write_string (session, session->priv->pam_service);
+    write_string (session, session->priv->username);
+    write_data (session, &session->priv->do_authenticate, sizeof (session->priv->do_authenticate));
+    write_data (session, &session->priv->is_interactive, sizeof (session->priv->is_interactive));
     write_string (session, session->priv->class);
     write_string (session, session->priv->tty);
     write_string (session, session->priv->remote_host_name);
     write_string (session, session->priv->xdisplay);
     write_xauth (session, session->priv->xauthority);
 
-    g_debug ("Started session %d with service '%s', username '%s'", session->priv->pid, service, username);
+    g_debug ("Started session %d with service '%s', username '%s'", session->priv->pid, session->priv->pam_service, session->priv->username);
 
     return TRUE;
 }
@@ -550,16 +636,28 @@
 }
 
 void
-session_run (Session *session, gchar **argv)
+session_run (Session *session)
+{
+    g_return_if_fail (session->priv->display_server != NULL);
+    return SESSION_GET_CLASS (session)->run (session);
+}
+
+static void
+session_real_run (Session *session)
 {
     gsize i, argc;
     gchar *command, *xauth_filename;
     GList *link;
 
     g_return_if_fail (session != NULL);
+    g_return_if_fail (!session->priv->command_run);
     g_return_if_fail (session_get_is_authenticated (session));
-
-    command = g_strjoinv (" ", argv);
+    g_return_if_fail (session->priv->argv != NULL);
+    g_return_if_fail (session->priv->pid != 0);
+
+    session->priv->command_run = TRUE;
+
+    command = g_strjoinv (" ", session->priv->argv);
     g_debug ("Session %d running command %s", session->priv->pid, command);
     g_free (command);
 
@@ -596,15 +694,15 @@
     write_data (session, &argc, sizeof (argc));
     for (link = session->priv->env; link; link = link->next)
         write_string (session, (gchar *) link->data);
-    argc = g_strv_length (argv);
+    argc = g_strv_length (session->priv->argv);
     write_data (session, &argc, sizeof (argc));
     for (i = 0; i < argc; i++)
-        write_string (session, argv[i]);
+        write_string (session, session->priv->argv[i]);
 
     if (login1_is_running ())
-      session->priv->login1_session = read_string_from_child (session);
+        session->priv->login1_session = read_string_from_child (session);
     if (!session->priv->login1_session)
-      session->priv->console_kit_cookie = read_string_from_child (session);
+        session->priv->console_kit_cookie = read_string_from_child (session);
 }
 
 void
@@ -638,19 +736,33 @@
 {
     g_return_if_fail (session != NULL);
 
+    if (session->priv->stopping)
+        return;
+    session->priv->stopping = TRUE;
+
+    return SESSION_GET_CLASS (session)->stop (session);
+}
+
+static void
+session_real_stop (Session *session)
+{
+    g_return_if_fail (session != NULL);
+
     if (session->priv->pid > 0)
     {
         g_debug ("Session %d: Sending SIGTERM", session->priv->pid);
         kill (session->priv->pid, SIGTERM);
         // FIXME: Handle timeout
     }
+    else
+        g_signal_emit (G_OBJECT (session), signals[STOPPED], 0);
 }
 
 gboolean
-session_get_is_stopped (Session *session)
+session_get_is_stopping (Session *session)
 {
-    g_return_val_if_fail (session != NULL, TRUE);
-    return session->priv->pid == 0;
+    g_return_val_if_fail (session != NULL, FALSE);
+    return session->priv->stopping;
 }
 
 static void
@@ -678,6 +790,7 @@
     g_free (self->priv->username);
     if (self->priv->user)
         g_object_unref (self->priv->user);
+    g_free (self->priv->pam_service);
     for (i = 0; i < self->priv->messages_length; i++)
         g_free ((char *) self->priv->messages[i].msg);
     g_free (self->priv->messages);
@@ -692,6 +805,7 @@
     g_free (self->priv->login1_session);
     g_free (self->priv->console_kit_cookie);
     g_list_free_full (self->priv->env, g_free);
+    g_strfreev (self->priv->argv);
 
     G_OBJECT_CLASS (session_parent_class)->finalize (object);
 }
@@ -701,7 +815,9 @@
 {
     GObjectClass *object_class = G_OBJECT_CLASS (klass);
 
-    klass->set_display_server = session_real_set_display_server;
+    klass->start = session_real_start;
+    klass->run = session_real_run;
+    klass->stop = session_real_stop;
     object_class->finalize = session_finalize;
 
     g_type_class_add_private (klass, sizeof (SessionPrivate));
@@ -712,7 +828,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (SessionClass, got_messages),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 
     signals[AUTHENTICATION_COMPLETE] =
@@ -721,7 +837,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (SessionClass, authentication_complete),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 
     signals[STOPPED] =
@@ -730,6 +846,6 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (SessionClass, stopped),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 }

=== modified file 'src/session.h'
--- src/session.h	2013-07-23 02:10:40 +0000
+++ src/session.h	2013-07-23 02:24:45 +0000
@@ -39,10 +39,13 @@
 {
     GObjectClass parent_class;
 
+    gboolean (*start)(Session *session);
+    void (*run)(Session *session);
+    void (*stop)(Session *session);
+
     void (*got_messages)(Session *session);
     void (*authentication_complete)(Session *session);
     void (*stopped)(Session *session);
-    void (*set_display_server)(Session *session, DisplayServer *display_server);
 } SessionClass;
 
 typedef enum
@@ -59,12 +62,26 @@
 
 const gchar *session_get_session_type (Session *session);
 
+void session_set_pam_service (Session *session, const gchar *pam_service);
+
+void session_set_username (Session *session, const gchar *username);
+
+void session_set_do_authenticate (Session *session, gboolean do_authenticate);
+
+void session_set_is_interactive (Session *session, gboolean is_interactive);
+
+void session_set_is_guest (Session *session, gboolean is_guest);
+
+gboolean session_get_is_guest (Session *session);
+
 void session_set_log_file (Session *session, const gchar *filename);
 
 void session_set_class (Session *session, const gchar *class);
 
 void session_set_display_server (Session *session, DisplayServer *display_server);
 
+DisplayServer *session_get_display_server (Session *session);
+
 void session_set_tty (Session *session, const gchar *tty);
 
 void session_set_xdisplay (Session *session, const gchar *xdisplay);
@@ -75,10 +92,14 @@
 
 void session_set_env (Session *session, const gchar *name, const gchar *value);
 
+void session_set_argv (Session *session, gchar **argv);
+
 // FIXME: Remove
 User *session_get_user (Session *session);
 
-gboolean session_start (Session *session, const gchar *service, const gchar *username, gboolean do_authenticate, gboolean is_interactive, gboolean is_guest);
+gboolean session_start (Session *session);
+
+gboolean session_get_is_started (Session *session);
 
 const gchar *session_get_username (Session *session);
 
@@ -98,7 +119,7 @@
 
 const gchar *session_get_authentication_result_string (Session *session);
 
-void session_run (Session *session, gchar **argv);
+void session_run (Session *session);
 
 void session_lock (Session *session);
 
@@ -106,7 +127,7 @@
 
 void session_stop (Session *session);
 
-gboolean session_get_is_stopped (Session *session);
+gboolean session_get_is_stopping (Session *session);
 
 G_END_DECLS
 

=== modified file 'src/vnc-server.c'
--- src/vnc-server.c	2011-09-11 05:45:10 +0000
+++ src/vnc-server.c	2013-07-20 08:49:28 +0000
@@ -173,6 +173,6 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (VNCServerClass, new_connection),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
+                      NULL,
                       G_TYPE_NONE, 1, G_TYPE_SOCKET);
 }

=== modified file 'src/xauthority.c'
--- src/xauthority.c	2013-06-11 00:10:58 +0000
+++ src/xauthority.c	2013-07-22 22:12:10 +0000
@@ -236,7 +236,7 @@
 xauth_write (XAuthority *auth, XAuthWriteMode mode, const gchar *filename, GError **error)
 {
     gchar *input;
-    gsize input_length = 0, input_offset = 0, offset;
+    gsize input_length = 0, input_offset = 0;
     GList *link, *records = NULL;
     XAuthority *a;
     gboolean result;

=== modified file 'src/xdmcp-server.c'
--- src/xdmcp-server.c	2013-06-17 23:14:43 +0000
+++ src/xdmcp-server.c	2013-07-20 08:49:28 +0000
@@ -15,7 +15,6 @@
 #define HASXDMAUTH
 #include <X11/Xdmcp.h>
 #include <gio/gio.h>
-#include "ldm-marshal.h"
 
 #include "xdmcp-server.h"
 #include "xdmcp-protocol.h"
@@ -707,6 +706,6 @@
                       G_STRUCT_OFFSET (XDMCPServerClass, new_session),
                       g_signal_accumulator_true_handled,
                       NULL,
-                      ldm_marshal_BOOLEAN__OBJECT,
+                      NULL,
                       G_TYPE_BOOLEAN, 1, XDMCP_SESSION_TYPE);
 }

=== added file 'src/xgreeter.c'
--- src/xgreeter.c	1970-01-01 00:00:00 +0000
+++ src/xgreeter.c	2013-07-17 01:50:43 +0000
@@ -0,0 +1,86 @@
+/*
+ * Copyright (C) 2013 Robert Ancell.
+ * Author: Robert Ancell <robert.ancell@canonical.com>
+ * 
+ * This program is free software: you can redistribute it and/or modify it under
+ * the terms of the GNU General Public License as published by the Free Software
+ * Foundation, either version 3 of the License, or (at your option) any later
+ * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
+ * license.
+ */
+
+#include <errno.h>
+#include <string.h>
+#include <fcntl.h>
+#include <sys/stat.h>
+
+#include "xgreeter.h"
+#include "xserver.h"
+#include "configuration.h"
+
+G_DEFINE_TYPE (XGreeter, xgreeter, GREETER_TYPE);
+
+XGreeter *
+xgreeter_new (void)
+{
+    return g_object_new (XGREETER_TYPE, NULL);
+}
+
+static void
+setup_env (XGreeter *xgreeter)
+{
+    DisplayServer *display_server;
+    gint vt;
+
+    display_server = session_get_display_server (SESSION (xgreeter));
+
+    vt = display_server_get_vt (display_server);
+    if (vt > 0)
+    {
+        gchar *t;
+
+        t = g_strdup_printf ("/dev/tty%d", vt);
+        session_set_tty (SESSION (xgreeter), t);
+        g_free (t);
+
+        t = g_strdup_printf ("%d", vt);
+        session_set_env (SESSION (xgreeter), "XDG_VTNR", t);
+        g_free (t);
+    }
+
+    session_set_env (SESSION (xgreeter), "DISPLAY", xserver_get_address (XSERVER (display_server)));
+    session_set_tty (SESSION (xgreeter), xserver_get_address (XSERVER (display_server)));
+    session_set_xdisplay (SESSION (xgreeter), xserver_get_address (XSERVER (display_server)));
+    session_set_remote_host_name (SESSION (xgreeter), xserver_get_hostname (XSERVER (display_server)));
+    session_set_xauthority (SESSION (xgreeter),
+                            xserver_get_authority (XSERVER (display_server)),
+                            config_get_boolean (config_get_instance (), "LightDM", "user-authority-in-system-dir"));
+}
+
+static gboolean
+xgreeter_start (Session *session)
+{
+    setup_env (XGREETER (session));
+    return SESSION_CLASS (xgreeter_parent_class)->start (session);
+}
+
+static void
+xgreeter_run (Session *session)
+{
+    setup_env (XGREETER (session));
+    SESSION_CLASS (xgreeter_parent_class)->run (session);
+}
+
+static void
+xgreeter_init (XGreeter *session)
+{
+}
+
+static void
+xgreeter_class_init (XGreeterClass *klass)
+{
+    SessionClass *session_class = SESSION_CLASS (klass);
+
+    session_class->start = xgreeter_start;
+    session_class->run = xgreeter_run;
+}

=== added file 'src/xgreeter.h'
--- src/xgreeter.h	1970-01-01 00:00:00 +0000
+++ src/xgreeter.h	2013-07-16 04:49:18 +0000
@@ -0,0 +1,41 @@
+/*
+ * Copyright (C) 2013 Robert Ancell.
+ * Author: Robert Ancell <robert.ancell@canonical.com>
+ * 
+ * This program is free software: you can redistribute it and/or modify it under
+ * the terms of the GNU General Public License as published by the Free Software
+ * Foundation, either version 3 of the License, or (at your option) any later
+ * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
+ * license.
+ */
+
+#ifndef XGREETER_H_
+#define XGREETER_H_
+
+#include "greeter.h"
+
+G_BEGIN_DECLS
+
+#define XGREETER_TYPE (xgreeter_get_type())
+#define XGREETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XGREETER_TYPE, XGreeter))
+
+typedef struct XGreeterPrivate XGreeterPrivate;
+
+typedef struct
+{
+    Greeter          parent_instance;
+    XGreeterPrivate *priv;
+} XGreeter;
+
+typedef struct
+{
+    GreeterClass parent_class;
+} XGreeterClass;
+
+GType xgreeter_get_type (void);
+
+XGreeter *xgreeter_new (void);
+
+G_END_DECLS
+
+#endif /* XGREETER_H_ */

=== modified file 'src/xserver-local.c'
--- src/xserver-local.c	2013-07-09 04:07:14 +0000
+++ src/xserver-local.c	2013-07-22 22:12:10 +0000
@@ -85,7 +85,6 @@
     GList *link;
     gchar *path;
     gboolean exists;
-    gboolean stale = TRUE;
     gchar *data;
 
     /* See if we know we are managing a server with that number */
@@ -153,10 +152,15 @@
 xserver_local_new (void)
 {
     XServerLocal *self = g_object_new (XSERVER_LOCAL_TYPE, NULL);
-    gchar *name;
+    gchar hostname[1024], *number, *name;
 
     xserver_set_display_number (XSERVER (self), xserver_local_get_unused_display_number ());
 
+    gethostname (hostname, 1024);
+    number = g_strdup_printf ("%d", xserver_get_display_number (XSERVER (self)));
+    xserver_set_authority (XSERVER (self), xauth_new_cookie (XAUTH_FAMILY_LOCAL, (guint8*) hostname, strlen (hostname), number));
+    g_free (number);
+
     name = g_strdup_printf ("x-%d", xserver_get_display_number (XSERVER (self)));
     display_server_set_name (DISPLAY_SERVER (self), name);
     g_free (name);
@@ -253,6 +257,7 @@
     g_return_if_fail (server != NULL);
     g_free (server->priv->xdmcp_key);
     server->priv->xdmcp_key = g_strdup (key);
+    xserver_set_authority (XSERVER (server), NULL);
 }
 
 void
@@ -284,11 +289,11 @@
     server->priv->mir_socket = g_strdup (socket);
 }
 
-gint
-xserver_local_get_vt (XServerLocal *server)
+static gint
+xserver_local_get_vt (DisplayServer *server)
 {
     g_return_val_if_fail (server != NULL, 0);
-    return server->priv->vt;
+    return XSERVER_LOCAL (server)->priv->vt;
 }
 
 const gchar *
@@ -443,7 +448,6 @@
     XServerLocal *server = XSERVER_LOCAL (display_server);
     gboolean result;
     gchar *filename, *dir, *absolute_command;
-    gchar hostname[1024], *number;
     GString *command;
 
     g_return_val_if_fail (server->priv->xserver_process == NULL, FALSE);
@@ -454,7 +458,7 @@
 
     server->priv->xserver_process = process_new ();
     process_set_clear_environment (server->priv->xserver_process, TRUE);
-    g_signal_connect (server->priv->xserver_process, "run", G_CALLBACK (run_cb), server);  
+    g_signal_connect (server->priv->xserver_process, "run", G_CALLBACK (run_cb), server);
     g_signal_connect (server->priv->xserver_process, "got-signal", G_CALLBACK (got_signal_cb), server);
     g_signal_connect (server->priv->xserver_process, "stopped", G_CALLBACK (stopped_cb), server);
 
@@ -484,11 +488,6 @@
     if (server->priv->layout)
         g_string_append_printf (command, " -layout %s", server->priv->layout);
 
-    gethostname (hostname, 1024);
-    number = g_strdup_printf ("%d", xserver_get_display_number (XSERVER (server)));
-    if (!server->priv->xdmcp_key)
-        xserver_set_authority (XSERVER (server), xauth_new_cookie (XAUTH_FAMILY_LOCAL, (guint8*) hostname, strlen (hostname), number));
-    g_free (number);
     write_authority_file (server);
     if (server->priv->authority_file)
         g_string_append_printf (command, " -auth %s", server->priv->authority_file);
@@ -603,6 +602,7 @@
     GObjectClass *object_class = G_OBJECT_CLASS (klass);
     DisplayServerClass *display_server_class = DISPLAY_SERVER_CLASS (klass);
 
+    display_server_class->get_vt = xserver_local_get_vt;
     display_server_class->start = xserver_local_start;
     display_server_class->stop = xserver_local_stop;
     object_class->finalize = xserver_local_finalize;

=== modified file 'src/xserver-local.h'
--- src/xserver-local.h	2013-04-30 18:18:16 +0000
+++ src/xserver-local.h	2013-07-14 23:02:13 +0000
@@ -67,8 +67,6 @@
 
 void xserver_local_set_mir_socket (XServerLocal *server, const gchar *socket);
 
-gint xserver_local_get_vt (XServerLocal *server);
-
 const gchar *xserver_local_get_authority_file_path (XServerLocal *server);
 
 G_END_DECLS

=== modified file 'src/xsession.c'
--- src/xsession.c	2013-07-09 05:17:25 +0000
+++ src/xsession.c	2013-07-23 02:24:45 +0000
@@ -32,21 +32,48 @@
 }
 
 static void
-xsession_set_display_server (Session *session, DisplayServer *display_server)
-{
-    XServer *xserver;
-    XAuthority *authority;
-
-    xserver = XSERVER (display_server);
-
-    session_set_env (session, "DISPLAY", xserver_get_address (xserver));
-    session_set_tty (session, xserver_get_address (xserver));
-    session_set_xdisplay (session, xserver_get_address (xserver));
-    authority = xserver_get_authority (xserver);
-    if (authority)
-        session_set_xauthority (session, authority, config_get_boolean (config_get_instance (), "LightDM", "user-authority-in-system-dir"));
-
-    SESSION_CLASS (xsession_parent_class)->set_display_server (session, display_server);
+setup_env (XSession *xsession)
+{
+    DisplayServer *display_server;
+    gint vt;
+
+    display_server = session_get_display_server (SESSION (xsession));
+
+    vt = display_server_get_vt (display_server);
+    if (vt > 0)
+    {
+        gchar *t;
+
+        t = g_strdup_printf ("/dev/tty%d", vt);
+        session_set_tty (SESSION (xsession), t);
+        g_free (t);
+
+        t = g_strdup_printf ("%d", vt);
+        session_set_env (SESSION (xsession), "XDG_VTNR", t);
+        g_free (t);
+    }
+
+    session_set_env (SESSION (xsession), "DISPLAY", xserver_get_address (XSERVER (display_server)));
+    session_set_tty (SESSION (xsession), xserver_get_address (XSERVER (display_server)));
+    session_set_xdisplay (SESSION (xsession), xserver_get_address (XSERVER (display_server)));
+    session_set_remote_host_name (SESSION (xsession), xserver_get_hostname (XSERVER (display_server)));
+    session_set_xauthority (SESSION (xsession),
+                            xserver_get_authority (XSERVER (display_server)),
+                            config_get_boolean (config_get_instance (), "LightDM", "user-authority-in-system-dir"));
+}
+
+static gboolean
+xsession_start (Session *session)
+{
+    setup_env (XSESSION (session));
+    return SESSION_CLASS (xsession_parent_class)->start (session);
+}
+
+static void
+xsession_run (Session *session)
+{
+    setup_env (XSESSION (session));
+    SESSION_CLASS (xsession_parent_class)->run (session);
 }
 
 static void
@@ -59,5 +86,6 @@
 {
     SessionClass *session_class = SESSION_CLASS (klass);
 
-    session_class->set_display_server = xsession_set_display_server;
+    session_class->start = xsession_start;
+    session_class->run = xsession_run;
 }

=== modified file 'tests/Makefile.am'
--- tests/Makefile.am	2013-07-09 05:17:25 +0000
+++ tests/Makefile.am	2013-07-23 02:24:45 +0000
@@ -6,6 +6,11 @@
 	test-greeter-not-installed \
 	test-greeter-xserver-crash \
 	test-greeter-wrapper \
+	test-greeter-default-session \
+	test-greeter-allow-guest \
+	test-greeter-hide-users \
+	test-greeter-show-manual-login \
+	test-greeter-show-remote-login \
 	test-no-config \
 	test-additional-config \
 	test-headless \
@@ -42,6 +47,8 @@
 	test-autologin-guest-fail-setup-script \
 	test-autologin-guest-logout \
 	test-group-membership \
+	test-session-env \
+	test-language-env \
 	test-util-path \
 	test-session-stdout \
 	test-session-stderr \
@@ -71,6 +78,7 @@
 	test-login-gobject-multi-info-prompt \
 	test-login-gobject-multi-prompt \
 	test-login-gobject-pick-session \
+	test-login-gobject-remember-session \
 	test-login-gobject-previous-session \
 	test-login-gobject-wrong-password \
 	test-login-gobject-invalid-user \
@@ -98,6 +106,7 @@
 	test-login-python-invalid-session \
 	test-login-python-logout \
 	test-login-python-pick-session \
+	test-login-python-remember-session \
 	test-login-python-guest \
 	test-login-python-guest-disabled \
 	test-login-python-guest-no-setup-script \
@@ -116,6 +125,7 @@
 	test-script-hook-fail-display-setup \
 	test-script-hook-fail-greeter-setup \
 	test-script-hook-fail-session-setup \
+	test-dbus \
 	test-lock-seat \
 	test-lock-seat-return-session \
 	test-lock-session \
@@ -137,7 +147,8 @@
 	test-vnc-command \
 	test-vnc-dimensions \
 	test-vnc-open-file-descriptors \
-	test-xdmcp-login \
+	test-xdmcp-client \
+	test-xdmcp-server-login \
 	test-no-accounts-service \
 	test-console-kit \
 	test-no-console-kit \
@@ -153,13 +164,14 @@
 	test-python-power-no-login1 \
 	test-python-power-no-services \
 	test-open-file-descriptors \
-	test-xdmcp-open-file-descriptors \
+	test-xdmcp-server-open-file-descriptors \
 	test-unity-compositor-command \
 	test-unity-compositor-fail-start \
 	test-unity-compositor-fail-ready \
 	test-unity-autologin \
 	test-unity-login \
 	test-unity-switch \
+	test-unity-plymouth \
 	test-unity-mir-login
 
 #	test-session-exit-error
@@ -189,6 +201,7 @@
 	test-login-qt4-invalid-session \
 	test-login-qt4-logout \
 	test-login-qt4-pick-session \
+	test-login-qt4-remember-session \
 	test-login-qt4-guest \
 	test-login-qt4-guest-disabled \
 	test-login-qt4-guest-no-setup-script \
@@ -223,6 +236,7 @@
 	test-login-qt5-invalid-session \
 	test-login-qt5-logout \
 	test-login-qt5-pick-session \
+	test-login-qt5-remember-session \
 	test-login-qt5-guest \
 	test-login-qt5-guest-disabled \
 	test-login-qt5-guest-no-setup-script \
@@ -241,12 +255,12 @@
 	data/remote-sessions/test-remote.desktop \
 	data/system.conf \
 	data/session.conf \
-	data/xgreeters/test-gobject-greeter.desktop \
-	data/xgreeters/test-python-greeter.desktop \
-	data/xgreeters/test-qt4-greeter.desktop \
-	data/xgreeters/test-qt5-greeter.desktop \
-	data/xsessions/alternative.desktop \
-	data/xsessions/default.desktop \
+	data/greeters/test-gobject-greeter.desktop \
+	data/greeters/test-python-greeter.desktop \
+	data/greeters/test-qt4-greeter.desktop \
+	data/greeters/test-qt5-greeter.desktop \
+	data/sessions/alternative.desktop \
+	data/sessions/default.desktop \
 	scripts/0-additional.conf \
 	scripts/1-additional.conf \
 	scripts/additional-config.conf \
@@ -275,10 +289,16 @@
 	scripts/cred-error.conf \
 	scripts/cred-expired.conf \
 	scripts/cred-unavail.conf \
+	scripts/dbus.conf \    
 	scripts/denied.conf \
 	scripts/expired.conf \
+	scripts/greeter-allow-guest.conf \
+	scripts/greeter-default-session.conf \
 	scripts/greeter-fail-start.conf \
+	scripts/greeter-hide-users.conf \
 	scripts/greeter-not-installed.conf \
+	scripts/greeter-show-manual-login.conf \
+	scripts/greeter-show-remote-login.conf \
 	scripts/greeter-wrapper.conf \
 	scripts/greeter-xserver-crash.conf \
 	scripts/group-membership.conf \
@@ -287,6 +307,7 @@
 	scripts/home-dir-on-session.conf \
 	scripts/keyboard-layout.conf \
 	scripts/language.conf \
+	scripts/language-env.conf \
 	scripts/language-no-accounts-service.conf \
 	scripts/lock-seat.conf \
 	scripts/lock-seat-return-session.conf \
@@ -316,6 +337,7 @@
 	scripts/login-pam.conf \
 	scripts/login-pick-session.conf \
 	scripts/login-previous-session.conf \
+	scripts/login-remember-session.conf \
 	scripts/login-remote-session.conf \
 	scripts/login-session-crash.conf \
 	scripts/login-two-factor.conf \
@@ -342,6 +364,7 @@
 	scripts/script-hook-fail-display-setup.conf \
 	scripts/script-hook-fail-greeter-setup.conf \
 	scripts/script-hook-fail-session-setup.conf \
+	scripts/session-env.conf \
 	scripts/session-stdout.conf \
 	scripts/session-stderr.conf \
 	scripts/session-stderr-multi-write.conf \
@@ -365,6 +388,7 @@
 	scripts/unity-compositor-fail-start.conf \
 	scripts/unity-login.conf \
 	scripts/unity-mir-login.conf \
+	scripts/unity-plymouth.conf \
 	scripts/unity-switch.conf \
 	scripts/users.conf \
 	scripts/util-path.conf \
@@ -375,7 +399,8 @@
 	scripts/vnc-login.conf \
 	scripts/vnc-open-file-descriptors.conf \
 	scripts/xauthority.conf \
-	scripts/xdmcp-login.conf \
-	scripts/xdmcp-open-file-descriptors.conf \
+	scripts/xdmcp-client.conf \
+	scripts/xdmcp-server-login.conf \
+	scripts/xdmcp-server-open-file-descriptors.conf \
 	scripts/xserver-fail-start.conf \
 	scripts/xserver-no-share.conf

=== renamed directory 'tests/data/xgreeters' => 'tests/data/greeters'
=== renamed directory 'tests/data/xsessions' => 'tests/data/sessions'
=== modified file 'tests/scripts/additional-config.conf'
--- tests/scripts/additional-config.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/additional-config.conf	2013-07-20 09:49:48 +0000
@@ -12,9 +12,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/autologin-guest-fail-setup-script.conf'
--- tests/scripts/autologin-guest-fail-setup-script.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-guest-fail-setup-script.conf	2013-07-21 08:38:43 +0000
@@ -7,14 +7,16 @@
 
 [SeatDefaults]
 autologin-guest=true
+user-session=default
 
 #?RUNNER DAEMON-START
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (guest account attempts to start and fails)
@@ -25,6 +27,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SELECT-GUEST-HINT
 
 # Cleanup
 #?*STOP-DAEMON

=== modified file 'tests/scripts/autologin-guest-in-background.conf'
--- tests/scripts/autologin-guest-in-background.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-guest-in-background.conf	2013-07-20 09:49:48 +0000
@@ -14,6 +14,7 @@
 
 # Greeter starts
 #?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 #?GREETER-X-0 START
@@ -24,6 +25,7 @@
 
 # Guest session starts
 #?XSERVER-1 START VT=8
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
 #?XSERVER-1 ACCEPT-CONNECT
 #?GUEST-ACCOUNT ADD USERNAME=guest-.*

=== modified file 'tests/scripts/autologin-guest-logout.conf'
--- tests/scripts/autologin-guest-logout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-guest-logout.conf	2013-07-20 09:49:48 +0000
@@ -13,9 +13,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Guest account created
@@ -37,9 +38,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/autologin-guest-timeout.conf'
--- tests/scripts/autologin-guest-timeout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-guest-timeout.conf	2013-07-20 09:49:48 +0000
@@ -14,9 +14,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/autologin-guest.conf'
--- tests/scripts/autologin-guest.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-guest.conf	2013-07-20 09:49:48 +0000
@@ -13,9 +13,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Guest account created

=== modified file 'tests/scripts/autologin-in-background.conf'
--- tests/scripts/autologin-in-background.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-in-background.conf	2013-07-20 09:49:48 +0000
@@ -11,6 +11,7 @@
 
 # Greeter starts
 #?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 #?GREETER-X-0 START
@@ -21,6 +22,7 @@
 
 # Autologin session starts
 #?XSERVER-1 START VT=8
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
 #?XSERVER-1 ACCEPT-CONNECT
 #?SESSION-X-1 START USER=have-password1

=== modified file 'tests/scripts/autologin-invalid-session.conf'
--- tests/scripts/autologin-invalid-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-invalid-session.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (session fails to start)

=== modified file 'tests/scripts/autologin-invalid-user.conf'
--- tests/scripts/autologin-invalid-user.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-invalid-user.conf	2013-07-20 23:39:11 +0000
@@ -7,15 +7,16 @@
 
 #?RUNNER DAEMON-START
 
+# (fails to start session for invalid user)
+
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
-# (fails to start session for invalid user)
-
 # Greeter starts
 #?GREETER-X-0 START
 #?XSERVER-0 ACCEPT-CONNECT

=== modified file 'tests/scripts/autologin-logout.conf'
--- tests/scripts/autologin-logout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-logout.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Autologin session starts
@@ -28,9 +29,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/autologin-new-authtok.conf'
--- tests/scripts/autologin-new-authtok.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-new-authtok.conf	2013-07-21 08:38:43 +0000
@@ -4,14 +4,16 @@
 
 [SeatDefaults]
 autologin-user=new-authtok
+user-session=default
 
 #?RUNNER DAEMON-START
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (Session fails)
@@ -22,6 +24,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SELECT-USER-HINT USERNAME=new-authtok
 
 # Cleanup
 #?*STOP-DAEMON

=== modified file 'tests/scripts/autologin-password.conf'
--- tests/scripts/autologin-password.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-password.conf	2013-07-21 08:38:43 +0000
@@ -4,14 +4,16 @@
 
 [SeatDefaults]
 autologin-user=always-password
+user-session=default
 
 #?RUNNER DAEMON-START
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (Session fails)
@@ -22,6 +24,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SELECT-USER-HINT USERNAME=always-password
 
 # Cleanup
 #?*STOP-DAEMON

=== modified file 'tests/scripts/autologin-previous-session.conf'
--- tests/scripts/autologin-previous-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-previous-session.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/autologin-session-crash.conf'
--- tests/scripts/autologin-session-crash.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-session-crash.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -28,9 +29,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/autologin-session-error.conf'
--- tests/scripts/autologin-session-error.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-session-error.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (Session fails)
@@ -22,9 +23,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/autologin-timeout-in-background.conf'
--- tests/scripts/autologin-timeout-in-background.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-timeout-in-background.conf	2013-07-20 09:49:48 +0000
@@ -12,6 +12,7 @@
 
 # Greeter starts
 #?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 #?GREETER-X-0 START
@@ -22,6 +23,7 @@
 
 # Autologin session starts
 #?XSERVER-1 START VT=8
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
 #?XSERVER-1 ACCEPT-CONNECT
 #?SESSION-X-1 START USER=have-password1

=== modified file 'tests/scripts/autologin-timeout.conf'
--- tests/scripts/autologin-timeout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-timeout.conf	2013-07-20 09:49:48 +0000
@@ -11,9 +11,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/autologin-xserver-crash.conf'
--- tests/scripts/autologin-xserver-crash.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin-xserver-crash.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # XServer starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -28,6 +29,7 @@
 
 # X server restarts
 #?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 

=== modified file 'tests/scripts/autologin.conf'
--- tests/scripts/autologin.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/autologin.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/cancel-authentication.conf'
--- tests/scripts/cancel-authentication.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/cancel-authentication.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/change-authentication.conf'
--- tests/scripts/change-authentication.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/change-authentication.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/console-kit.conf'
--- tests/scripts/console-kit.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/console-kit.conf	2013-07-20 09:49:48 +0000
@@ -13,9 +13,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/crash-authenticate.conf'
--- tests/scripts/crash-authenticate.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/crash-authenticate.conf	2013-07-21 08:38:43 +0000
@@ -4,14 +4,16 @@
 
 [SeatDefaults]
 autologin-user=crash-authenticate
+user-session=default
 
 #?RUNNER DAEMON-START
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (authentication crashes)
@@ -22,6 +24,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SELECT-USER-HINT USERNAME=crash-authenticate
 
 # Cleanup
 #?*STOP-DAEMON

=== modified file 'tests/scripts/cred-error.conf'
--- tests/scripts/cred-error.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/cred-error.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (Session fails)
@@ -22,9 +23,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/cred-expired.conf'
--- tests/scripts/cred-expired.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/cred-expired.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (Session fails)
@@ -22,9 +23,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/cred-unavail.conf'
--- tests/scripts/cred-unavail.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/cred-unavail.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (Session fails)
@@ -22,9 +23,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== added file 'tests/scripts/dbus.conf'
--- tests/scripts/dbus.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/dbus.conf	2013-07-20 09:49:48 +0000
@@ -0,0 +1,52 @@
+#
+# Check can login
+#
+
+[SeatDefaults]
+user-session=default
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Greeter starts
+#?GREETER-X-0 START
+#?XSERVER-0 ACCEPT-CONNECT
+#?GREETER-X-0 CONNECT-XSERVER
+#?GREETER-X-0 CONNECT-TO-DAEMON
+#?GREETER-X-0 CONNECTED-TO-DAEMON
+
+#?*LIST-SEATS
+#?RUNNER LIST-SEATS SEATS=/org/freedesktop/DisplayManager/Seat0
+#?*LIST-SESSIONS
+#?RUNNER LIST-SESSIONS SESSIONS=
+
+# Log into account with a password
+#?*GREETER-X-0 AUTHENTICATE USERNAME=have-password1
+#?GREETER-X-0 SHOW-PROMPT TEXT="Password:"
+#?*GREETER-X-0 RESPOND TEXT="password"
+#?GREETER-X-0 AUTHENTICATION-COMPLETE USERNAME=have-password1 AUTHENTICATED=TRUE
+#?*GREETER-X-0 START-SESSION
+#?GREETER-X-0 TERMINATE SIGNAL=15
+
+# Session starts
+#?SESSION-X-0 START USER=have-password1
+#?XSERVER-0 ACCEPT-CONNECT
+#?SESSION-X-0 CONNECT-XSERVER
+
+#?*LIST-SEATS
+#?RUNNER LIST-SEATS SEATS=/org/freedesktop/DisplayManager/Seat0
+#?*LIST-SESSIONS
+#?RUNNER LIST-SESSIONS SESSIONS=/org/freedesktop/DisplayManager/Session0
+
+# Cleanup
+#?*STOP-DAEMON
+#?SESSION-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== modified file 'tests/scripts/denied.conf'
--- tests/scripts/denied.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/denied.conf	2013-07-21 08:38:43 +0000
@@ -4,14 +4,16 @@
 
 [SeatDefaults]
 autologin-user=denied
+user-session=default
 
 #?RUNNER DAEMON-START
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (Session fails)
@@ -22,6 +24,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SELECT-USER-HINT USERNAME=denied    
 
 # Cleanup
 #?*STOP-DAEMON

=== modified file 'tests/scripts/expired.conf'
--- tests/scripts/expired.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/expired.conf	2013-07-21 08:38:43 +0000
@@ -4,14 +4,16 @@
 
 [SeatDefaults]
 autologin-user=expired
+user-session=default
 
 #?RUNNER DAEMON-START
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (Session fails)
@@ -22,6 +24,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SELECT-USER-HINT USERNAME=expired
 
 # Cleanup
 #?*STOP-DAEMON

=== added file 'tests/scripts/greeter-allow-guest.conf'
--- tests/scripts/greeter-allow-guest.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/greeter-allow-guest.conf	2013-07-22 03:13:13 +0000
@@ -0,0 +1,32 @@
+#
+# Check greeter is informed if manual login should be showed (it defaults to show)
+#
+
+[SeatDefaults]
+greeter-allow-guest=false
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Greeter starts
+#?GREETER-X-0 START
+#?XSERVER-0 ACCEPT-CONNECT
+#?GREETER-X-0 CONNECT-XSERVER
+#?GREETER-X-0 CONNECT-TO-DAEMON
+#?GREETER-X-0 CONNECTED-TO-DAEMON
+
+# Check has correct hint to allow guest
+#?GREETER-X-0 HAS-GUEST-ACCOUNT-HINT=FALSE
+
+# Cleanup
+#?*STOP-DAEMON
+#?GREETER-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== added file 'tests/scripts/greeter-default-session.conf'
--- tests/scripts/greeter-default-session.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/greeter-default-session.conf	2013-07-22 02:58:17 +0000
@@ -0,0 +1,33 @@
+#
+# Check greeter is informed of the default user session
+#
+
+[SeatDefaults]
+user-session=alternative
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Greeter starts
+#?GREETER-X-0 START
+#?XSERVER-0 ACCEPT-CONNECT
+#?GREETER-X-0 CONNECT-XSERVER
+#?GREETER-X-0 CONNECT-TO-DAEMON
+#?GREETER-X-0 CONNECTED-TO-DAEMON
+
+# Check has correct user session
+#?*GREETER-X-0 LOG-DEFAULT-SESSION
+#?GREETER-X-0 LOG-DEFAULT-SESSION SESSION=alternative
+
+# Cleanup
+#?*STOP-DAEMON
+#?GREETER-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== modified file 'tests/scripts/greeter-fail-start.conf'
--- tests/scripts/greeter-fail-start.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/greeter-fail-start.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter fails to start

=== added file 'tests/scripts/greeter-hide-users.conf'
--- tests/scripts/greeter-hide-users.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/greeter-hide-users.conf	2013-07-22 03:01:26 +0000
@@ -0,0 +1,32 @@
+#
+# Check greeter is informed if user list should be hidden
+#
+
+[SeatDefaults]
+greeter-hide-users=true
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Greeter starts
+#?GREETER-X-0 START
+#?XSERVER-0 ACCEPT-CONNECT
+#?GREETER-X-0 CONNECT-XSERVER
+#?GREETER-X-0 CONNECT-TO-DAEMON
+#?GREETER-X-0 CONNECTED-TO-DAEMON
+
+# Check has correct hint to hide users
+#?GREETER-X-0 HIDE-USERS-HINT
+
+# Cleanup
+#?*STOP-DAEMON
+#?GREETER-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== modified file 'tests/scripts/greeter-not-installed.conf'
--- tests/scripts/greeter-not-installed.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/greeter-not-installed.conf	2013-07-20 23:39:11 +0000
@@ -7,17 +7,7 @@
 
 #?RUNNER DAEMON-START
 
-# X server starts
-#?XSERVER-0 START VT=7
-#?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
-#?XSERVER-0 ACCEPT-CONNECT
-
 # Invalid greeter attempted, fails to start
 
-# X server stopped
-#?XSERVER-0 TERMINATE SIGNAL=15
-
 # Daemon stops with error
 #?RUNNER DAEMON-EXIT STATUS=1

=== added file 'tests/scripts/greeter-show-manual-login.conf'
--- tests/scripts/greeter-show-manual-login.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/greeter-show-manual-login.conf	2013-07-22 03:05:10 +0000
@@ -0,0 +1,32 @@
+#
+# Check greeter is informed if manual login should be showed
+#
+
+[SeatDefaults]
+greeter-show-manual-login=true
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Greeter starts
+#?GREETER-X-0 START
+#?XSERVER-0 ACCEPT-CONNECT
+#?GREETER-X-0 CONNECT-XSERVER
+#?GREETER-X-0 CONNECT-TO-DAEMON
+#?GREETER-X-0 CONNECTED-TO-DAEMON
+
+# Check has correct hint to show manual login
+#?GREETER-X-0 SHOW-MANUAL-LOGIN-HINT
+
+# Cleanup
+#?*STOP-DAEMON
+#?GREETER-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== added file 'tests/scripts/greeter-show-remote-login.conf'
--- tests/scripts/greeter-show-remote-login.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/greeter-show-remote-login.conf	2013-07-22 03:07:36 +0000
@@ -0,0 +1,32 @@
+#
+# Check greeter is informed if remote login should be showed (it defaults to show)
+#
+
+[SeatDefaults]
+greeter-show-remote-login=false
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Greeter starts
+#?GREETER-X-0 START
+#?XSERVER-0 ACCEPT-CONNECT
+#?GREETER-X-0 CONNECT-XSERVER
+#?GREETER-X-0 CONNECT-TO-DAEMON
+#?GREETER-X-0 CONNECTED-TO-DAEMON
+
+# Check has correct hint to show remote login
+#?GREETER-X-0 SHOW-REMOTE-LOGIN-HINT=FALSE
+
+# Cleanup
+#?*STOP-DAEMON
+#?GREETER-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== modified file 'tests/scripts/greeter-wrapper.conf'
--- tests/scripts/greeter-wrapper.conf	2013-06-28 08:16:11 +0000
+++ tests/scripts/greeter-wrapper.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter wrapper starts

=== modified file 'tests/scripts/greeter-xserver-crash.conf'
--- tests/scripts/greeter-xserver-crash.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/greeter-xserver-crash.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -26,9 +27,10 @@
 
 # X server restarts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/group-membership.conf'
--- tests/scripts/group-membership.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/group-membership.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/home-dir-on-authenticate.conf'
--- tests/scripts/home-dir-on-authenticate.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/home-dir-on-authenticate.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/home-dir-on-session.conf'
--- tests/scripts/home-dir-on-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/home-dir-on-session.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/keyboard-layout.conf'
--- tests/scripts/keyboard-layout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/keyboard-layout.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== added file 'tests/scripts/language-env.conf'
--- tests/scripts/language-env.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/language-env.conf	2013-07-21 07:47:05 +0000
@@ -0,0 +1,34 @@
+#
+# Check language variables are set in session
+#
+
+[SeatDefaults]
+autologin-user=have-language
+user-session=default
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Session starts
+#?SESSION-X-0 START USER=have-language
+#?XSERVER-0 ACCEPT-CONNECT
+#?SESSION-X-0 CONNECT-XSERVER
+
+# Check environment variables
+#?*SESSION-X-0 READ-ENV NAME=LANG
+#?SESSION-X-0 READ-ENV NAME=LANG VALUE=en_AU
+#?*SESSION-X-0 READ-ENV NAME=GDM_LANG
+#?SESSION-X-0 READ-ENV NAME=GDM_LANG VALUE=en_AU
+
+# Cleanup
+#?*STOP-DAEMON
+#?SESSION-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== modified file 'tests/scripts/language-no-accounts-service.conf'
--- tests/scripts/language-no-accounts-service.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/language-no-accounts-service.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/language.conf'
--- tests/scripts/language.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/language.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/lock-seat-return-session.conf'
--- tests/scripts/lock-seat-return-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/lock-seat-return-session.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -26,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/lock-seat.conf'
--- tests/scripts/lock-seat.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/lock-seat.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -26,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/lock-session-no-password.conf'
--- tests/scripts/lock-session-no-password.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/lock-session-no-password.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -26,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts with session user selected

=== modified file 'tests/scripts/lock-session-return-session.conf'
--- tests/scripts/lock-session-return-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/lock-session-return-session.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -26,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts with session user selected

=== modified file 'tests/scripts/lock-session.conf'
--- tests/scripts/lock-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/lock-session.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -26,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts with session user selected

=== modified file 'tests/scripts/login-crash-authenticate.conf'
--- tests/scripts/login-crash-authenticate.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-crash-authenticate.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-guest-disabled.conf'
--- tests/scripts/login-guest-disabled.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-guest-disabled.conf	2013-07-22 03:17:31 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -20,6 +21,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 HAS-GUEST-ACCOUNT-HINT=FALSE    
 
 # Login as guest
 #?*GREETER-X-0 AUTHENTICATE-GUEST

=== modified file 'tests/scripts/login-guest-fail-setup-script.conf'
--- tests/scripts/login-guest-fail-setup-script.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-guest-fail-setup-script.conf	2013-07-21 08:38:43 +0000
@@ -5,13 +5,17 @@
 [LightDM]
 guest-account-script=false
 
+[SeatDefaults]
+user-session=default
+
 #?RUNNER DAEMON-START
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -29,22 +33,13 @@
 
 # (guest account attempts to start and fails)
 
-# X server stops
-#?XSERVER-0 TERMINATE SIGNAL=15
-
-# X server starts
-#?XSERVER-0 START VT=7
-#?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
-#?XSERVER-0 ACCEPT-CONNECT
-
 # Greeter starts
 #?GREETER-X-0 START
 #?XSERVER-0 ACCEPT-CONNECT
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SELECT-GUEST-HINT
 
 # Cleanup
 #?*STOP-DAEMON

=== modified file 'tests/scripts/login-guest-logout.conf'
--- tests/scripts/login-guest-logout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-guest-logout.conf	2013-07-20 09:49:48 +0000
@@ -12,9 +12,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -49,9 +50,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-guest-no-setup-script.conf'
--- tests/scripts/login-guest-no-setup-script.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-guest-no-setup-script.conf	2013-07-22 03:17:31 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -20,6 +21,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 HAS-GUEST-ACCOUNT-HINT=FALSE
 
 # Login as guest
 #?*GREETER-X-0 AUTHENTICATE-GUEST

=== modified file 'tests/scripts/login-guest.conf'
--- tests/scripts/login-guest.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-guest.conf	2013-07-20 09:49:48 +0000
@@ -12,9 +12,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-info-prompt.conf'
--- tests/scripts/login-info-prompt.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-info-prompt.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-invalid-session.conf'
--- tests/scripts/login-invalid-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-invalid-session.conf	2013-07-20 23:39:11 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -23,25 +24,10 @@
 #?GREETER-X-0 SHOW-PROMPT TEXT="Password:"
 #?*GREETER-X-0 RESPOND TEXT="password"
 #?GREETER-X-0 AUTHENTICATION-COMPLETE USERNAME=have-password1 AUTHENTICATED=TRUE
+
+# Attempt to start the session, it will fail
 #?*GREETER-X-0 START-SESSION SESSION=invalid
-#?GREETER-X-0 TERMINATE SIGNAL=15
-
-# X server stops, the session is invalid
-#?XSERVER-0 TERMINATE SIGNAL=15
-
-# X server restarts
-#?XSERVER-0 START VT=7
-#?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
-#?XSERVER-0 ACCEPT-CONNECT
-
-# Greeter starts
-#?GREETER-X-0 START
-#?XSERVER-0 ACCEPT-CONNECT
-#?GREETER-X-0 CONNECT-XSERVER
-#?GREETER-X-0 CONNECT-TO-DAEMON
-#?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SESSION-FAILED
 
 # Cleanup
 #?*STOP-DAEMON

=== modified file 'tests/scripts/login-invalid-user.conf'
--- tests/scripts/login-invalid-user.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-invalid-user.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-logout.conf'
--- tests/scripts/login-logout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-logout.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -42,9 +43,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-long-password.conf'
--- tests/scripts/login-long-password.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-long-password.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-long-username.conf'
--- tests/scripts/login-long-username.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-long-username.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-manual-previous-session.conf'
--- tests/scripts/login-manual-previous-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-manual-previous-session.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-manual.conf'
--- tests/scripts/login-manual.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-manual.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-multi-info-prompt.conf'
--- tests/scripts/login-multi-info-prompt.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-multi-info-prompt.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-multi-prompt.conf'
--- tests/scripts/login-multi-prompt.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-multi-prompt.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-new-authtok.conf'
--- tests/scripts/login-new-authtok.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-new-authtok.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-no-password.conf'
--- tests/scripts/login-no-password.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-no-password.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-pam.conf'
--- tests/scripts/login-pam.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-pam.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-pick-session.conf'
--- tests/scripts/login-pick-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-pick-session.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -18,16 +19,14 @@
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
 
-# Login as have-password1
-#?*GREETER-X-0 AUTHENTICATE USERNAME=have-password1
-#?GREETER-X-0 SHOW-PROMPT TEXT="Password:"
-#?*GREETER-X-0 RESPOND TEXT="password"
-#?GREETER-X-0 AUTHENTICATION-COMPLETE USERNAME=have-password1 AUTHENTICATED=TRUE
+# Login and pick a session
+#?*GREETER-X-0 AUTHENTICATE USERNAME=no-password1
+#?GREETER-X-0 AUTHENTICATION-COMPLETE USERNAME=no-password1 AUTHENTICATED=TRUE
 #?*GREETER-X-0 START-SESSION SESSION=alternative
 #?GREETER-X-0 TERMINATE SIGNAL=15
 
 # Session starts
-#?SESSION-X-0 START NAME=alternative USER=have-password1
+#?SESSION-X-0 START NAME=alternative USER=no-password1
 #?XSERVER-0 ACCEPT-CONNECT
 #?SESSION-X-0 CONNECT-XSERVER
 

=== modified file 'tests/scripts/login-previous-session.conf'
--- tests/scripts/login-previous-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-previous-session.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== added file 'tests/scripts/login-remember-session.conf'
--- tests/scripts/login-remember-session.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/login-remember-session.conf	2013-07-20 09:49:48 +0000
@@ -0,0 +1,69 @@
+#
+# Check when logging in the session logged in as is remembered the second time a login occurs
+#
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Greeter starts
+#?GREETER-X-0 START
+#?XSERVER-0 ACCEPT-CONNECT
+#?GREETER-X-0 CONNECT-XSERVER
+#?GREETER-X-0 CONNECT-TO-DAEMON
+#?GREETER-X-0 CONNECTED-TO-DAEMON
+
+# Login and pick a session
+#?*GREETER-X-0 AUTHENTICATE USERNAME=no-password1
+#?GREETER-X-0 AUTHENTICATION-COMPLETE USERNAME=no-password1 AUTHENTICATED=TRUE
+#?*GREETER-X-0 START-SESSION SESSION=alternative
+#?GREETER-X-0 TERMINATE SIGNAL=15
+
+# Session starts
+#?SESSION-X-0 START NAME=alternative USER=no-password1
+#?XSERVER-0 ACCEPT-CONNECT
+#?SESSION-X-0 CONNECT-XSERVER
+
+# Logout session
+#?*SESSION-X-0 LOGOUT
+
+# X server stops
+#?XSERVER-0 TERMINATE SIGNAL=15
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Greeter starts
+#?GREETER-X-0 START
+#?XSERVER-0 ACCEPT-CONNECT
+#?GREETER-X-0 CONNECT-XSERVER
+#?GREETER-X-0 CONNECT-TO-DAEMON
+#?GREETER-X-0 CONNECTED-TO-DAEMON
+
+# Log into account without specifying a session
+#?*GREETER-X-0 AUTHENTICATE USERNAME=no-password1
+#?GREETER-X-0 AUTHENTICATION-COMPLETE USERNAME=no-password1 AUTHENTICATED=TRUE
+#?*GREETER-X-0 START-SESSION
+#?GREETER-X-0 TERMINATE SIGNAL=15
+
+# Session starts
+#?SESSION-X-0 START NAME=alternative USER=no-password1
+#?XSERVER-0 ACCEPT-CONNECT
+#?SESSION-X-0 CONNECT-XSERVER
+
+# Cleanup
+#?*STOP-DAEMON
+#?SESSION-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== modified file 'tests/scripts/login-remote-session.conf'
--- tests/scripts/login-remote-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-remote-session.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-session-crash.conf'
--- tests/scripts/login-session-crash.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-session-crash.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -42,9 +43,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-two-factor.conf'
--- tests/scripts/login-two-factor.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-two-factor.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-wrong-password.conf'
--- tests/scripts/login-wrong-password.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-wrong-password.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login-xserver-crash.conf'
--- tests/scripts/login-xserver-crash.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login-xserver-crash.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # XServer starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts
@@ -42,6 +43,7 @@
 
 # X server restarts
 #?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 

=== modified file 'tests/scripts/login.conf'
--- tests/scripts/login.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/login.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/login1.conf'
--- tests/scripts/login1.conf	2013-06-25 04:02:23 +0000
+++ tests/scripts/login1.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/no-accounts-service.conf'
--- tests/scripts/no-accounts-service.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/no-accounts-service.conf	2013-07-20 09:49:48 +0000
@@ -13,9 +13,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/no-config.conf'
--- tests/scripts/no-config.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/no-config.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # One X server should start by default
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/no-console-kit-or-login1.conf'
--- tests/scripts/no-console-kit-or-login1.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/no-console-kit-or-login1.conf	2013-07-20 09:49:48 +0000
@@ -14,9 +14,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/no-console-kit.conf'
--- tests/scripts/no-console-kit.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/no-console-kit.conf	2013-07-20 09:49:48 +0000
@@ -13,9 +13,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/no-keyboard-layout.conf'
--- tests/scripts/no-keyboard-layout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/no-keyboard-layout.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/no-language.conf'
--- tests/scripts/no-language.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/no-language.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/no-login1.conf'
--- tests/scripts/no-login1.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/no-login1.conf	2013-07-20 09:49:48 +0000
@@ -13,9 +13,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/open-file-descriptors.conf'
--- tests/scripts/open-file-descriptors.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/open-file-descriptors.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/pam.conf'
--- tests/scripts/pam.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/pam.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/plymouth-active-vt.conf'
--- tests/scripts/plymouth-active-vt.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/plymouth-active-vt.conf	2013-07-20 09:49:48 +0000
@@ -16,14 +16,15 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
 
 # Plymouth quits but keeps image in framebuffer
 #?PLYMOUTH QUIT RETAIN-SPLASH=TRUE
 
-# LightDM connects to X server
-#?XSERVER-0 ACCEPT-CONNECT
-
 # Greeter starts
 #?GREETER-X-0 START
 #?XSERVER-0 ACCEPT-CONNECT

=== modified file 'tests/scripts/plymouth-inactive-vt.conf'
--- tests/scripts/plymouth-inactive-vt.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/plymouth-inactive-vt.conf	2013-07-20 09:49:48 +0000
@@ -13,9 +13,10 @@
 #?PLYMOUTH HAS-ACTIVE-VT=FALSE
 #?PLYMOUTH QUIT RETAIN-SPLASH=FALSE
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/power-no-console-kit.conf'
--- tests/scripts/power-no-console-kit.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/power-no-console-kit.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/power-no-login1.conf'
--- tests/scripts/power-no-login1.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/power-no-login1.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/power-no-services.conf'
--- tests/scripts/power-no-services.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/power-no-services.conf	2013-07-20 09:49:48 +0000
@@ -11,9 +11,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/power.conf'
--- tests/scripts/power.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/power.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/restart-authentication.conf'
--- tests/scripts/restart-authentication.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/restart-authentication.conf	2013-07-20 09:49:48 +0000
@@ -6,9 +6,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/script-hook-fail-display-setup.conf'
--- tests/scripts/script-hook-fail-display-setup.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/script-hook-fail-display-setup.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # One X server should start by default
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Setup script fails

=== modified file 'tests/scripts/script-hook-fail-greeter-setup.conf'
--- tests/scripts/script-hook-fail-greeter-setup.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/script-hook-fail-greeter-setup.conf	2013-07-20 09:49:48 +0000
@@ -9,9 +9,10 @@
 
 # One X server should start by default
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Setup script fails

=== modified file 'tests/scripts/script-hook-fail-session-setup.conf'
--- tests/scripts/script-hook-fail-session-setup.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/script-hook-fail-session-setup.conf	2013-07-21 08:38:43 +0000
@@ -5,14 +5,16 @@
 [SeatDefaults]
 session-setup-script=test-script-hook SESSION-SETUP 1
 autologin-user=have-password1
+user-session=default
 
 #?RUNNER DAEMON-START
 
 # One X server should start by default
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Setup script fails
@@ -24,6 +26,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SELECT-USER-HINT USERNAME=have-password1
 
 # Cleanup
 #?*STOP-DAEMON

=== modified file 'tests/scripts/script-hooks.conf'
--- tests/scripts/script-hooks.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/script-hooks.conf	2013-07-20 09:49:48 +0000
@@ -14,9 +14,10 @@
 
 # One X server should start by default
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Script hooks run
@@ -39,9 +40,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Script hooks run

=== added file 'tests/scripts/session-env.conf'
--- tests/scripts/session-env.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/session-env.conf	2013-07-20 09:49:48 +0000
@@ -0,0 +1,34 @@
+#
+# Check logind variables are set in session
+#
+
+[SeatDefaults]
+autologin-user=have-password1
+user-session=default
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Session starts
+#?SESSION-X-0 START USER=have-password1
+#?XSERVER-0 ACCEPT-CONNECT
+#?SESSION-X-0 CONNECT-XSERVER
+
+# Check environment variables
+#?*SESSION-X-0 READ-ENV NAME=DESKTOP_SESSION
+#?SESSION-X-0 READ-ENV NAME=DESKTOP_SESSION VALUE=default
+#?*SESSION-X-0 READ-ENV NAME=GDMSESSION
+#?SESSION-X-0 READ-ENV NAME=GDMSESSION VALUE=default
+
+# Cleanup
+#?*STOP-DAEMON
+#?SESSION-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== modified file 'tests/scripts/session-stderr-backup.conf'
--- tests/scripts/session-stderr-backup.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/session-stderr-backup.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -29,6 +30,7 @@
 #?*SESSION-X-0 LOGOUT
 #?XSERVER-0 TERMINATE SIGNAL=15
 #?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 #?GREETER-X-0 START
@@ -57,6 +59,7 @@
 #?*SESSION-X-0 LOGOUT
 #?XSERVER-0 TERMINATE SIGNAL=15
 #?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 #?GREETER-X-0 START

=== modified file 'tests/scripts/session-stderr-multi-write.conf'
--- tests/scripts/session-stderr-multi-write.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/session-stderr-multi-write.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/session-stderr.conf'
--- tests/scripts/session-stderr.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/session-stderr.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/session-stdout.conf'
--- tests/scripts/session-stdout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/session-stdout.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/switch-to-greeter-new-session-logout-new.conf'
--- tests/scripts/switch-to-greeter-new-session-logout-new.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-greeter-new-session-logout-new.conf	2013-07-20 09:49:48 +0000
@@ -10,6 +10,9 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 
@@ -24,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts
@@ -55,6 +59,7 @@
 
 # X server starts
 #?XSERVER-1 START VT=8
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
 #?XSERVER-1 ACCEPT-CONNECT
 

=== modified file 'tests/scripts/switch-to-greeter-new-session-logout-old.conf'
--- tests/scripts/switch-to-greeter-new-session-logout-old.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-greeter-new-session-logout-old.conf	2013-07-20 09:49:48 +0000
@@ -10,6 +10,9 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 
@@ -24,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts
@@ -59,6 +63,7 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 

=== modified file 'tests/scripts/switch-to-greeter-new-session.conf'
--- tests/scripts/switch-to-greeter-new-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-greeter-new-session.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -26,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/switch-to-greeter-return-session-logout.conf'
--- tests/scripts/switch-to-greeter-return-session-logout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-greeter-return-session-logout.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -26,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts
@@ -55,6 +57,7 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 

=== modified file 'tests/scripts/switch-to-greeter-return-session.conf'
--- tests/scripts/switch-to-greeter-return-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-greeter-return-session.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -26,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/switch-to-greeter.conf'
--- tests/scripts/switch-to-greeter.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-greeter.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -26,9 +27,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/switch-to-guest.conf'
--- tests/scripts/switch-to-guest.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-guest.conf	2013-07-20 09:49:48 +0000
@@ -14,9 +14,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Default session starts
@@ -30,9 +31,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Guest account created

=== modified file 'tests/scripts/switch-to-user-existing-session.conf'
--- tests/scripts/switch-to-user-existing-session.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-user-existing-session.conf	2013-07-20 09:49:48 +0000
@@ -11,9 +11,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/switch-to-user-logout.conf'
--- tests/scripts/switch-to-user-logout.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-user-logout.conf	2013-07-20 09:49:48 +0000
@@ -11,9 +11,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -27,9 +28,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # New session starts
@@ -45,9 +47,10 @@
 
 # X server starts for greeter
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/switch-to-user-no-password.conf'
--- tests/scripts/switch-to-user-no-password.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-user-no-password.conf	2013-07-20 09:49:48 +0000
@@ -11,9 +11,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -27,9 +28,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # New session starts

=== modified file 'tests/scripts/switch-to-user.conf'
--- tests/scripts/switch-to-user.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-user.conf	2013-07-20 09:49:48 +0000
@@ -11,9 +11,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -27,9 +28,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/switch-to-users.conf'
--- tests/scripts/switch-to-users.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/switch-to-users.conf	2013-07-20 09:49:48 +0000
@@ -11,9 +11,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -27,9 +28,10 @@
 
 # New X server starts
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # New session starts
@@ -43,9 +45,10 @@
 
 # New X server starts
 #?XSERVER-2 START VT=9
+
+# Daemon connects when X server is ready
+#?*XSERVER-2 INDICATE-READY
 #?XSERVER-2 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-2 ACCEPT-CONNECT
 
 # New session starts

=== modified file 'tests/scripts/system-xauthority.conf'
--- tests/scripts/system-xauthority.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/system-xauthority.conf	2013-07-20 09:49:48 +0000
@@ -13,9 +13,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/unity-autologin.conf'
--- tests/scripts/unity-autologin.conf	2013-06-19 02:31:11 +0000
+++ tests/scripts/unity-autologin.conf	2013-07-20 09:49:48 +0000
@@ -10,14 +10,15 @@
 #?RUNNER DAEMON-START
 
 # System compositor starts
-#?UNITY-SYSTEM-COMPOSITOR START
+#?UNITY-SYSTEM-COMPOSITOR START VT=7
 #?*UNITY-SYSTEM-COMPOSITOR READY
 
 # X server starts
 #?XSERVER-0 START MIR-ID=0
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-   
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/unity-compositor-command.conf'
--- tests/scripts/unity-compositor-command.conf	2013-06-21 03:42:40 +0000
+++ tests/scripts/unity-compositor-command.conf	2013-07-20 09:49:48 +0000
@@ -10,14 +10,15 @@
 #?RUNNER DAEMON-START
 
 # System compositor starts
-#?UNITY-SYSTEM-COMPOSITOR START TEST
+#?UNITY-SYSTEM-COMPOSITOR START VT=7 TEST=TRUE
 #?*UNITY-SYSTEM-COMPOSITOR READY
 
 # X server starts
 #?XSERVER-0 START MIR-ID=0
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/unity-compositor-fail-ready.conf'
--- tests/scripts/unity-compositor-fail-ready.conf	2013-06-26 02:36:43 +0000
+++ tests/scripts/unity-compositor-fail-ready.conf	2013-07-20 09:49:48 +0000
@@ -9,16 +9,17 @@
 #?RUNNER DAEMON-START
 
 # System compositor starts but doesn't indicate it is ready
-#?UNITY-SYSTEM-COMPOSITOR START
+#?UNITY-SYSTEM-COMPOSITOR START VT=7
 
 # Timeout and compositor is stopped
 #?UNITY-SYSTEM-COMPOSITOR TERMINATE SIGNAL=15
 
 # X server starts in VT mode
-#?XSERVER-0 START VT=8
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/unity-compositor-fail-start.conf'
--- tests/scripts/unity-compositor-fail-start.conf	2013-06-26 02:36:43 +0000
+++ tests/scripts/unity-compositor-fail-start.conf	2013-07-20 09:49:48 +0000
@@ -11,14 +11,15 @@
 #?RUNNER DAEMON-START
 
 # System compositor fails to start
-#?UNITY-SYSTEM-COMPOSITOR START
+#?UNITY-SYSTEM-COMPOSITOR START VT=7
 #?UNITY-SYSTEM-COMPOSITOR EXIT CODE=1
 
 # X server starts in VT mode
-#?XSERVER-0 START VT=8
+#?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/unity-login.conf'
--- tests/scripts/unity-login.conf	2013-06-19 02:31:11 +0000
+++ tests/scripts/unity-login.conf	2013-07-20 09:49:48 +0000
@@ -9,14 +9,15 @@
 #?RUNNER DAEMON-START
 
 # System compositor starts
-#?UNITY-SYSTEM-COMPOSITOR START
+#?UNITY-SYSTEM-COMPOSITOR START VT=7
 #?*UNITY-SYSTEM-COMPOSITOR READY
 
 # X server starts
 #?XSERVER-0 START MIR-ID=0
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== added file 'tests/scripts/unity-plymouth.conf'
--- tests/scripts/unity-plymouth.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/unity-plymouth.conf	2013-07-20 09:49:48 +0000
@@ -0,0 +1,50 @@
+#
+# Check Plymouth quits when Unity System compositor server is started.  Plymouth is on an active VT so it handshakes with u-s-c.
+#
+
+[SeatDefaults]
+type=unity
+autologin-user=have-password1
+user-session=default
+
+[test-plymouth-config]
+enabled=true
+has-active-vt=true
+active=true
+
+#?RUNNER DAEMON-START
+
+# Check if Plymouth is running
+#?PLYMOUTH PING ACTIVE=TRUE
+#?PLYMOUTH HAS-ACTIVE-VT=TRUE
+#?PLYMOUTH DEACTIVATE
+
+# System compositor starts
+#?UNITY-SYSTEM-COMPOSITOR START VT=7
+#?*UNITY-SYSTEM-COMPOSITOR READY
+
+# Plymouth quits but keeps image in framebuffer
+#?PLYMOUTH QUIT RETAIN-SPLASH=TRUE
+
+# X server starts
+#?XSERVER-0 START MIR-ID=0
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Session starts
+#?SESSION-X-0 START USER=have-password1
+#?XSERVER-0 ACCEPT-CONNECT
+#?SESSION-X-0 CONNECT-XSERVER
+
+# System compositor switches to session
+#?UNITY-SYSTEM-COMPOSITOR SET-ACTIVE-SESSION ID=0
+
+# Cleanup
+#?*STOP-DAEMON
+#?SESSION-X-0 TERMINATE SIGNAL=15
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?UNITY-SYSTEM-COMPOSITOR TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== modified file 'tests/scripts/unity-switch.conf'
--- tests/scripts/unity-switch.conf	2013-06-19 02:31:11 +0000
+++ tests/scripts/unity-switch.conf	2013-07-20 23:39:11 +0000
@@ -10,14 +10,15 @@
 #?RUNNER DAEMON-START
 
 # System compositor starts
-#?UNITY-SYSTEM-COMPOSITOR START
+#?UNITY-SYSTEM-COMPOSITOR START VT=7
 #?*UNITY-SYSTEM-COMPOSITOR READY
 
 # X server starts
 #?XSERVER-0 START MIR-ID=0
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts
@@ -34,9 +35,10 @@
 
 # New X server starts
 #?XSERVER-1 START MIR-ID=1
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-1 ACCEPT-CONNECT
 
 # Greeter starts
@@ -67,16 +69,17 @@
 #?XSERVER-1 TERMINATE SIGNAL=15
 
 # X server starts
-#?XSERVER-1 START MIR-ID=2
-#?XSERVER-1 INDICATE-READY
-#?XSERVER-1 ACCEPT-CONNECT
+#?XSERVER-2 START MIR-ID=2
+#?*XSERVER-2 INDICATE-READY
+#?XSERVER-2 INDICATE-READY
+#?XSERVER-2 ACCEPT-CONNECT
 
 # Greeter starts
-#?GREETER-X-1 START
-#?XSERVER-1 ACCEPT-CONNECT
-#?GREETER-X-1 CONNECT-XSERVER
-#?GREETER-X-1 CONNECT-TO-DAEMON
-#?GREETER-X-1 CONNECTED-TO-DAEMON
+#?GREETER-X-2 START
+#?XSERVER-2 ACCEPT-CONNECT
+#?GREETER-X-2 CONNECT-XSERVER
+#?GREETER-X-2 CONNECT-TO-DAEMON
+#?GREETER-X-2 CONNECTED-TO-DAEMON
 
 # System compositor switches to greeter
 #?UNITY-SYSTEM-COMPOSITOR SET-ACTIVE-SESSION ID=2
@@ -85,7 +88,7 @@
 #?*STOP-DAEMON
 #?SESSION-X-0 TERMINATE SIGNAL=15
 #?XSERVER-0 TERMINATE SIGNAL=15
-#?GREETER-X-1 TERMINATE SIGNAL=15
-#?XSERVER-1 TERMINATE SIGNAL=15
+#?GREETER-X-2 TERMINATE SIGNAL=15
+#?XSERVER-2 TERMINATE SIGNAL=15
 #?UNITY-SYSTEM-COMPOSITOR TERMINATE SIGNAL=15
 #?RUNNER DAEMON-EXIT STATUS=0

=== modified file 'tests/scripts/user-renamed-invalid.conf'
--- tests/scripts/user-renamed-invalid.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/user-renamed-invalid.conf	2013-07-21 08:38:43 +0000
@@ -4,14 +4,16 @@
 
 [SeatDefaults]
 autologin-user=change-user-invalid
+user-session=default
 
 #?RUNNER DAEMON-START
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # (fails to start session for invalid user)
@@ -22,6 +24,7 @@
 #?GREETER-X-0 CONNECT-XSERVER
 #?GREETER-X-0 CONNECT-TO-DAEMON
 #?GREETER-X-0 CONNECTED-TO-DAEMON
+#?GREETER-X-0 SELECT-USER-HINT USERNAME=invalid-user
 
 # Cleanup
 #?*STOP-DAEMON

=== modified file 'tests/scripts/user-renamed.conf'
--- tests/scripts/user-renamed.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/user-renamed.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/users.conf'
--- tests/scripts/users.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/users.conf	2013-07-20 09:49:48 +0000
@@ -12,9 +12,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts

=== modified file 'tests/scripts/util-path.conf'
--- tests/scripts/util-path.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/util-path.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== modified file 'tests/scripts/vnc-command.conf'
--- tests/scripts/vnc-command.conf	2013-06-06 04:06:53 +0000
+++ tests/scripts/vnc-command.conf	2013-07-20 09:49:48 +0000
@@ -21,11 +21,15 @@
 # Xvnc server starts
 #?XSERVER-0 START GEOMETRY=1024x768 DEPTH=8 OPTION=TRUE
 
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
 # Negotiate with Xvnc
+#?*XSERVER-0 START-VNC
 #?VNC-CLIENT CONNECTED VERSION="RFB 003.007"
-#?XSERVER-0 INDICATE-READY
 #?XSERVER-0 VNC-CLIENT-CONNECT VERSION="RFB 003.003"
-#?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts and connects to remote X server
 #?GREETER-X-0 START

=== modified file 'tests/scripts/vnc-dimensions.conf'
--- tests/scripts/vnc-dimensions.conf	2013-06-06 04:06:53 +0000
+++ tests/scripts/vnc-dimensions.conf	2013-07-20 09:49:48 +0000
@@ -23,11 +23,15 @@
 # Xvnc server starts
 #?XSERVER-0 START GEOMETRY=1440x900 DEPTH=16 OPTION=FALSE
 
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
 # Negotiate with Xvnc
+#?*XSERVER-0 START-VNC
 #?VNC-CLIENT CONNECTED VERSION="RFB 003.007"
-#?XSERVER-0 INDICATE-READY
 #?XSERVER-0 VNC-CLIENT-CONNECT VERSION="RFB 003.003"
-#?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts and connects to remote X server
 #?GREETER-X-0 START

=== modified file 'tests/scripts/vnc-login.conf'
--- tests/scripts/vnc-login.conf	2013-06-07 01:09:05 +0000
+++ tests/scripts/vnc-login.conf	2013-07-20 09:49:48 +0000
@@ -23,14 +23,17 @@
 # Xvnc server starts
 #?XSERVER-0 START GEOMETRY=1024x768 DEPTH=8 OPTION=FALSE
 
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
 # Negotiate with Xvnc
+#?*XSERVER-0 START-VNC
 #?VNC-CLIENT CONNECTED VERSION="RFB 003.007"
 
-#?XSERVER-0 INDICATE-READY
-
-# LightDM and vnc-client connect to X server
+# VNC client connects to X server
 #?XSERVER-0 VNC-CLIENT-CONNECT VERSION="RFB 003.003"
-#?XSERVER-0 ACCEPT-CONNECT
 
 # Greeter starts and connects to remote X server
 #?GREETER-X-0 START

=== modified file 'tests/scripts/vnc-open-file-descriptors.conf'
--- tests/scripts/vnc-open-file-descriptors.conf	2013-06-07 01:09:05 +0000
+++ tests/scripts/vnc-open-file-descriptors.conf	2013-07-20 09:49:48 +0000
@@ -23,16 +23,17 @@
 # Xvnc server starts
 #?XSERVER-0 START GEOMETRY=1024x768 DEPTH=8 OPTION=FALSE
 
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
 # Negotiate with Xvnc
+#?*XSERVER-0 START-VNC
 #?VNC-CLIENT CONNECTED VERSION="RFB 003.007"
 
-#?XSERVER-0 INDICATE-READY
-
 #?XSERVER-0 VNC-CLIENT-CONNECT VERSION="RFB 003.003"
 
-# LightDM connects to X server
-#?XSERVER-0 ACCEPT-CONNECT
-
 # Greeter starts and connects to remote X server
 #?GREETER-X-0 START
 #?XSERVER-0 ACCEPT-CONNECT

=== modified file 'tests/scripts/xauthority.conf'
--- tests/scripts/xauthority.conf	2013-06-24 23:45:21 +0000
+++ tests/scripts/xauthority.conf	2013-07-20 09:49:48 +0000
@@ -10,9 +10,10 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
-
-# LightDM connects to X server
 #?XSERVER-0 ACCEPT-CONNECT
 
 # Session starts

=== added file 'tests/scripts/xdmcp-client.conf'
--- tests/scripts/xdmcp-client.conf	1970-01-01 00:00:00 +0000
+++ tests/scripts/xdmcp-client.conf	2013-07-21 09:46:43 +0000
@@ -0,0 +1,27 @@
+#
+# Check can run a local XDMCP client
+#
+
+[SeatDefaults]
+xdmcp-manager=localhost
+xdmcp-port=9999
+
+#?RUNNER DAEMON-START
+
+# X server starts
+#?XSERVER-0 START VT=7
+#?*XSERVER-0 INDICATE-READY
+#?XSERVER-0 INDICATE-READY
+#?XSERVER-0 ACCEPT-CONNECT
+
+# Starts sending XDMCP queries
+#?*XSERVER-0 START-XDMCP
+#?XSERVER-0 SEND-QUERY
+
+# Wait to check a greeter is not started
+#?*WAIT
+
+# Cleanup
+#?*STOP-DAEMON
+#?XSERVER-0 TERMINATE SIGNAL=15
+#?RUNNER DAEMON-EXIT STATUS=0

=== renamed file 'tests/scripts/xdmcp-login.conf' => 'tests/scripts/xdmcp-server-login.conf'
--- tests/scripts/xdmcp-login.conf	2013-06-07 01:09:05 +0000
+++ tests/scripts/xdmcp-server-login.conf	2013-07-20 10:02:55 +0000
@@ -18,6 +18,9 @@
 # Start a remote X server to log in with XDMCP
 #?*START-XSERVER ARGS=":98 -query localhost -port 9999 -nolisten unix"
 #?XSERVER-98 START
+
+# Start sending XDMCP queries
+#?*XSERVER-98 START-XDMCP
 #?XSERVER-98 SEND-QUERY
 
 # Negotiate with daemon

=== renamed file 'tests/scripts/xdmcp-open-file-descriptors.conf' => 'tests/scripts/xdmcp-server-open-file-descriptors.conf'
--- tests/scripts/xdmcp-open-file-descriptors.conf	2013-06-07 01:09:05 +0000
+++ tests/scripts/xdmcp-server-open-file-descriptors.conf	2013-07-20 10:02:55 +0000
@@ -18,6 +18,9 @@
 # Start a remote X server to log in with XDMCP
 #?*START-XSERVER ARGS=":98 -query localhost -port 9999 -nolisten unix"
 #?XSERVER-98 START
+
+# Start sending XDMCP queries
+#?*XSERVER-98 START-XDMCP
 #?XSERVER-98 SEND-QUERY
 
 # Negotiate with daemon

=== modified file 'tests/scripts/xserver-no-share.conf'
--- tests/scripts/xserver-no-share.conf	2013-06-30 10:39:56 +0000
+++ tests/scripts/xserver-no-share.conf	2013-07-20 09:49:48 +0000
@@ -10,6 +10,9 @@
 
 # X server starts
 #?XSERVER-0 START VT=7
+
+# Daemon connects when X server is ready
+#?*XSERVER-0 INDICATE-READY
 #?XSERVER-0 INDICATE-READY
 #?XSERVER-0 ACCEPT-CONNECT
 
@@ -29,6 +32,9 @@
 
 # New X server starts for session
 #?XSERVER-1 START VT=8
+
+# Daemon connects when X server is ready
+#?*XSERVER-1 INDICATE-READY
 #?XSERVER-1 INDICATE-READY
 #?XSERVER-1 ACCEPT-CONNECT
 

=== modified file 'tests/src/Makefile.am'
--- tests/src/Makefile.am	2013-07-09 03:33:51 +0000
+++ tests/src/Makefile.am	2013-07-23 02:24:45 +0000
@@ -24,6 +24,7 @@
 	-DBUILDDIR=\"$(abs_top_builddir)\" \
 	-DSYSCONFDIR=\"$(sysconfdir)\" \
 	-DLOCALSTATEDIR=\"$(localstatedir)\" \
+	-DDATADIR=\"$(datadir)\" \
 	-DCONFIG_DIR=\"$(sysconfdir)/lightdm\"
 libsystem_la_LIBADD = -ldl $(GLIB_LIBS) $(GIO_UNIX_LIBS)
 
@@ -46,6 +47,7 @@
 dbus_env_LDADD = \
 	$(GLIB_LIBS)
 
+test_runner_SOURCES = test-runner.c
 test_runner_CFLAGS = \
 	$(WARN_CFLAGS) \
 	$(GLIB_CFLAGS) \

=== modified file 'tests/src/X.c'
--- tests/src/X.c	2013-06-26 02:36:43 +0000
+++ tests/src/X.c	2013-07-22 22:21:02 +0000
@@ -3,10 +3,10 @@
 #include <string.h>
 #include <sys/types.h>
 #include <unistd.h>
-#include <signal.h>
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <errno.h>
+#include <glib-unix.h>
 
 #include "status.h"
 #include "x-server.h"
@@ -58,32 +58,27 @@
     g_main_loop_quit (loop);
 }
 
-static void
-indicate_ready (void)
-{
-    void *handler;  
-    handler = signal (SIGUSR1, SIG_IGN);
-    if (handler == SIG_IGN)
-    {
-        status_notify ("XSERVER-%d INDICATE-READY", display_number);
-        kill (getppid (), SIGUSR1);
-    }
-    signal (SIGUSR1, handler);
-}
-
-static void
-signal_cb (int signum)
-{
-    if (signum == SIGHUP)
-    {
-        status_notify ("XSERVER-%d DISCONNECT-CLIENTS", display_number);
-        indicate_ready ();
-    }
-    else
-    {
-        status_notify ("XSERVER-%d TERMINATE SIGNAL=%d", display_number, signum);
-        quit (EXIT_SUCCESS);
-    }
+static gboolean
+sighup_cb (gpointer user_data)
+{
+    status_notify ("XSERVER-%d DISCONNECT-CLIENTS", display_number);
+    return TRUE;
+}
+
+static gboolean
+sigint_cb (gpointer user_data)
+{
+    status_notify ("XSERVER-%d TERMINATE SIGNAL=%d", display_number, SIGINT);
+    quit (EXIT_SUCCESS);
+    return TRUE;
+}
+
+static gboolean
+sigterm_cb (gpointer user_data)
+{
+    status_notify ("XSERVER-%d TERMINATE SIGNAL=%d", display_number, SIGTERM);
+    quit (EXIT_SUCCESS);
+    return TRUE;
 }
 
 static void
@@ -166,8 +161,6 @@
 client_disconnected_cb (XServer *server, XClient *client)
 {  
     g_signal_handlers_disconnect_matched (client, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, NULL);  
-    if (x_server_get_n_clients (server) == 0)
-        indicate_ready ();
 }
 
 static void
@@ -188,6 +181,27 @@
         kill (getpid (), SIGSEGV);
     }
     g_free (r);
+    r = g_strdup_printf ("XSERVER-%d INDICATE-READY", display_number);
+    if (strcmp (request, r) == 0)
+    {
+        void *handler;
+
+        handler = signal (SIGUSR1, SIG_IGN);
+        if (handler == SIG_IGN)
+        {
+            status_notify ("XSERVER-%d INDICATE-READY", display_number);
+            kill (getppid (), SIGUSR1);
+        }
+        signal (SIGUSR1, handler);
+    }
+    g_free (r);
+    r = g_strdup_printf ("XSERVER-%d START-XDMCP", display_number);
+    if (strcmp (request, r) == 0)
+    {
+        if (!xdmcp_client_start (xdmcp_client))
+            quit (EXIT_FAILURE);
+    }
+    g_free (r);
 }
 
 int
@@ -203,16 +217,16 @@
     int lock_file;
     GString *status_text;
 
-    signal (SIGINT, signal_cb);
-    signal (SIGTERM, signal_cb);
-    signal (SIGHUP, signal_cb);
-
 #if !defined(GLIB_VERSION_2_36)
     g_type_init ();
 #endif
 
     loop = g_main_loop_new (NULL, FALSE);
 
+    g_unix_signal_add (SIGINT, sigint_cb, NULL);
+    g_unix_signal_add (SIGTERM, sigterm_cb, NULL);
+    g_unix_signal_add (SIGHUP, sighup_cb, NULL);
+
     status_connect (request_cb);
 
     for (i = 1; i < argc; i++)
@@ -397,14 +411,8 @@
         g_signal_connect (xdmcp_client, "accept", G_CALLBACK (xdmcp_accept_cb), NULL);
         g_signal_connect (xdmcp_client, "decline", G_CALLBACK (xdmcp_decline_cb), NULL);
         g_signal_connect (xdmcp_client, "failed", G_CALLBACK (xdmcp_failed_cb), NULL);
-
-        if (!xdmcp_client_start (xdmcp_client))
-            quit (EXIT_FAILURE);
     }
 
-    /* Indicate ready if parent process has requested it */
-    indicate_ready ();
-
     g_main_loop_run (loop);
 
     cleanup ();

=== modified file 'tests/src/Xvnc.c'
--- tests/src/Xvnc.c	2013-06-17 23:14:43 +0000
+++ tests/src/Xvnc.c	2013-07-22 22:21:02 +0000
@@ -3,10 +3,10 @@
 #include <string.h>
 #include <sys/types.h>
 #include <unistd.h>
-#include <signal.h>
 #include <fcntl.h>
 #include <errno.h>
 #include <gio/gio.h>
+#include <glib-unix.h>
 
 #include "status.h"
 #include "x-server.h"
@@ -29,19 +29,6 @@
 static XServer *xserver = NULL;
 
 static void
-indicate_ready (void)
-{
-    void *handler;  
-    handler = signal (SIGUSR1, SIG_IGN);
-    if (handler == SIG_IGN)
-    {
-        status_notify ("XSERVER-%d INDICATE-READY", display_number);
-        kill (getppid (), SIGUSR1);
-    }
-    signal (SIGUSR1, handler);
-}
-
-static void
 cleanup (void)
 {
     if (lock_path)
@@ -57,19 +44,27 @@
     exit (status);
 }
 
-static void
-signal_cb (int signum)
-{
-    if (signum == SIGHUP)
-    {
-        status_notify ("XSERVER-%d DISCONNECT-CLIENTS", display_number);
-        indicate_ready ();
-    }
-    else
-    {
-        status_notify ("XSERVER-%d TERMINATE SIGNAL=%d", display_number, signum);
-        quit (EXIT_SUCCESS);
-    }
+static gboolean
+sighup_cb (gpointer user_data)
+{
+    status_notify ("XSERVER-%d DISCONNECT-CLIENTS", display_number);
+    return TRUE;
+}
+
+static gboolean
+sigint_cb (gpointer user_data)
+{
+    status_notify ("XSERVER-%d TERMINATE SIGNAL=%d", display_number, SIGINT);
+    quit (EXIT_SUCCESS);
+    return TRUE;
+}
+
+static gboolean
+sigterm_cb (gpointer user_data)
+{
+    status_notify ("XSERVER-%d TERMINATE SIGNAL=%d", display_number, SIGTERM);
+    quit (EXIT_SUCCESS);
+    return TRUE;
 }
 
 static void
@@ -90,8 +85,6 @@
 client_disconnected_cb (XServer *server, XClient *client)
 {  
     g_signal_handlers_disconnect_matched (client, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, NULL);  
-    if (x_server_get_n_clients (server) == 0)
-        indicate_ready ();
 }
 
 static gboolean
@@ -121,11 +114,35 @@
 static void
 request_cb (const gchar *request)
 {
+    gchar *r;
+
     if (!request)
     {
         g_main_loop_quit (loop);
         return;
     }
+
+    r = g_strdup_printf ("XSERVER-%d INDICATE-READY", display_number);
+    if (strcmp (request, r) == 0)
+    {
+        void *handler;
+
+        handler = signal (SIGUSR1, SIG_IGN);
+        if (handler == SIG_IGN)
+        {
+            status_notify ("XSERVER-%d INDICATE-READY", display_number);
+            kill (getppid (), SIGUSR1);
+        }
+        signal (SIGUSR1, handler);
+    }
+    g_free (r);
+    r = g_strdup_printf ("XSERVER-%d START-VNC", display_number);
+    if (strcmp (request, r) == 0)
+    {
+        /* Send server protocol version to client */
+        g_print ("RFB 003.007\n");
+    }
+    g_free (r);
 }
 
 int
@@ -140,16 +157,16 @@
     int lock_file;
     int i;
 
-    signal (SIGINT, signal_cb);
-    signal (SIGTERM, signal_cb);
-    signal (SIGHUP, signal_cb);
-
 #if !defined(GLIB_VERSION_2_36)
     g_type_init ();
 #endif
 
     loop = g_main_loop_new (NULL, FALSE);
 
+    g_unix_signal_add (SIGINT, sigint_cb, NULL);
+    g_unix_signal_add (SIGTERM, sigterm_cb, NULL);
+    g_unix_signal_add (SIGHUP, sighup_cb, NULL);
+
     status_connect (request_cb);
 
     for (i = 1; i < argc; i++)
@@ -218,9 +235,6 @@
   
     if (use_inetd)
     {
-        /* Send server protocol version to client */
-        g_print ("RFB 003.007\n");
-
         if (!g_io_add_watch (g_io_channel_unix_new (STDIN_FILENO), G_IO_IN, vnc_data_cb, NULL))
             return EXIT_FAILURE;
     }
@@ -256,9 +270,6 @@
     if (!x_server_start (xserver))
         quit (EXIT_FAILURE);
 
-    /* Indicate ready if parent process has requested it */
-    indicate_ready ();
-
     g_main_loop_run (loop);
 
     cleanup ();

=== modified file 'tests/src/libsystem.c'
--- tests/src/libsystem.c	2013-06-25 04:02:23 +0000
+++ tests/src/libsystem.c	2013-07-11 02:20:58 +0000
@@ -165,6 +165,9 @@
     if (g_str_has_prefix (path, LOCALSTATEDIR))
         return g_build_filename (g_getenv ("LIGHTDM_TEST_ROOT"), "var", path + strlen (LOCALSTATEDIR), NULL);
 
+    if (g_str_has_prefix (path, DATADIR))
+        return g_build_filename (g_getenv ("LIGHTDM_TEST_ROOT"), "usr", "share", path + strlen (DATADIR), NULL);
+
     // Don't redirect if inside the build directory
     if (g_str_has_prefix (path, BUILDDIR))
         return g_strdup (path);

=== modified file 'tests/src/test-gobject-greeter.c'
--- tests/src/test-gobject-greeter.c	2013-06-06 04:03:33 +0000
+++ tests/src/test-gobject-greeter.c	2013-07-22 22:12:10 +0000
@@ -5,6 +5,7 @@
 #include <string.h>
 #include <xcb/xcb.h>
 #include <lightdm.h>
+#include <glib-unix.h>
 
 #include "status.h"
 
@@ -46,11 +47,20 @@
     status_notify ("%s AUTOLOGIN-TIMER-EXPIRED", greeter_id);
 }
 
-static void
-signal_cb (int signum)
-{
-    status_notify ("%s TERMINATE SIGNAL=%d", greeter_id, signum);
-    exit (EXIT_SUCCESS);
+static gboolean
+sigint_cb (gpointer user_data)
+{
+    status_notify ("%s TERMINATE SIGNAL=%d", greeter_id, SIGINT);
+    g_main_loop_quit (loop);
+    return TRUE;
+}
+
+static gboolean
+sigterm_cb (gpointer user_data)
+{
+    status_notify ("%s TERMINATE SIGNAL=%d", greeter_id, SIGTERM);
+    g_main_loop_quit (loop);
+    return TRUE;
 }
 
 static void
@@ -120,6 +130,11 @@
     }
     g_free (r);
 
+    r = g_strdup_printf ("%s LOG-DEFAULT-SESSION", greeter_id);
+    if (strcmp (request, r) == 0)
+        status_notify ("%s LOG-DEFAULT-SESSION SESSION=%s", greeter_id, lightdm_greeter_get_default_session_hint (greeter));
+    g_free (r);
+
     r = g_strdup_printf ("%s LOG-USER-LIST-LENGTH", greeter_id);
     if (strcmp (request, r) == 0)
         status_notify ("%s LOG-USER-LIST-LENGTH N=%d", greeter_id, lightdm_user_list_get_length (lightdm_user_list_get_instance ()));
@@ -286,9 +301,6 @@
 {
     gchar *display;
 
-    signal (SIGINT, signal_cb);
-    signal (SIGTERM, signal_cb);
-
 #if !defined(GLIB_VERSION_2_36)
     g_type_init ();
 #endif
@@ -303,6 +315,9 @@
 
     loop = g_main_loop_new (NULL, FALSE);
 
+    g_unix_signal_add (SIGINT, sigint_cb, NULL);
+    g_unix_signal_add (SIGTERM, sigterm_cb, NULL);
+
     status_connect (request_cb);
 
     status_notify ("%s START", greeter_id);
@@ -354,6 +369,14 @@
         status_notify ("%s SELECT-GUEST-HINT", greeter_id);
     if (lightdm_greeter_get_lock_hint (greeter))
         status_notify ("%s LOCK-HINT", greeter_id);
+    if (!lightdm_greeter_get_has_guest_account_hint (greeter))
+        status_notify ("%s HAS-GUEST-ACCOUNT-HINT=FALSE", greeter_id);
+    if (lightdm_greeter_get_hide_users_hint (greeter))
+        status_notify ("%s HIDE-USERS-HINT", greeter_id);
+    if (lightdm_greeter_get_show_manual_login_hint (greeter))
+        status_notify ("%s SHOW-MANUAL-LOGIN-HINT", greeter_id);
+    if (!lightdm_greeter_get_show_remote_login_hint (greeter))
+        status_notify ("%s SHOW-REMOTE-LOGIN-HINT=FALSE", greeter_id);
 
     g_main_loop_run (loop);
 

=== modified file 'tests/src/test-greeter-wrapper.c'
--- tests/src/test-greeter-wrapper.c	2013-06-28 08:16:11 +0000
+++ tests/src/test-greeter-wrapper.c	2013-07-22 22:21:02 +0000
@@ -1,4 +1,5 @@
 #include <stdlib.h>
+#include <unistd.h>
 
 #include "status.h"
 

=== modified file 'tests/src/test-python-greeter'
--- tests/src/test-python-greeter	2013-06-14 02:22:34 +0000
+++ tests/src/test-python-greeter	2013-07-22 03:56:17 +0000
@@ -248,7 +248,17 @@
 
 if greeter.get_select_user_hint () is not None:
     status_notify ('%s SELECT-USER-HINT USERNAME=%s' % (greeter_id, greeter.get_select_user_hint ()))
+if greeter.get_select_guest_hint ():
+    status_notify ('%s SELECT-GUEST-HINT' % greeter_id)
 if greeter.get_lock_hint ():
-    status_notify ('%s LOCK-HINT' % greeter_id);
+    status_notify ('%s LOCK-HINT' % greeter_id)
+if not greeter.get_has_guest_account_hint ():
+    status_notify ('%s HAS-GUEST-ACCOUNT-HINT=FALSE' % greeter_id)
+if greeter.get_hide_users_hint ():
+    status_notify ('%s HIDE-USERS-HINT' % greeter_id)
+if greeter.get_show_manual_login_hint ():
+    status_notify ('%s SHOW-MANUAL-LOGIN-HINT' % greeter_id)
+if not greeter.get_show_remote_login_hint ():
+    status_notify ('%s SHOW-REMOTE-LOGIN-HINT=FALSE' % greeter_id)
 
 loop.run ()

=== modified file 'tests/src/test-qt-greeter.cpp'
--- tests/src/test-qt-greeter.cpp	2013-06-06 04:03:33 +0000
+++ tests/src/test-qt-greeter.cpp	2013-07-22 03:56:17 +0000
@@ -300,8 +300,18 @@
 
     if (greeter->selectUserHint() != "")
         status_notify ("%s SELECT-USER-HINT USERNAME=%s", greeter_id, greeter->selectUserHint ().toAscii ().constData ());
+    if (greeter->selectGuestHint())
+        status_notify ("%s SELECT-GUEST-HINT", greeter_id);
     if (greeter->lockHint())
         status_notify ("%s LOCK-HINT", greeter_id);
+    if (!greeter->hasGuestAccountHint ())
+        status_notify ("%s HAS-GUEST-ACCOUNT-HINT=FALSE", greeter_id);
+    if (greeter->hideUsersHint ())
+        status_notify ("%s HIDE-USERS-HINT", greeter_id);
+    if (greeter->showManualLoginHint ())
+        status_notify ("%s SHOW-MANUAL-LOGIN-HINT", greeter_id);
+    if (!greeter->showRemoteLoginHint ())
+        status_notify ("%s SHOW-REMOTE-LOGIN-HINT=FALSE", greeter_id);
 
     return app->exec();
 }

=== modified file 'tests/src/test-runner.c'
--- tests/src/test-runner.c	2013-07-01 00:22:11 +0000
+++ tests/src/test-runner.c	2013-07-22 22:21:02 +0000
@@ -395,6 +395,78 @@
     {
         sleep (1);
     }
+    else if (strcmp (name, "LIST-SEATS") == 0)
+    {
+        GVariant *result, *value;
+        GString *status;
+        GVariantIter *iter;
+        const gchar *path;
+        int i = 0;
+
+        result = g_dbus_connection_call_sync (g_bus_get_sync (G_BUS_TYPE_SYSTEM, NULL, NULL),
+                                              "org.freedesktop.DisplayManager",
+                                              "/org/freedesktop/DisplayManager",
+                                              "org.freedesktop.DBus.Properties",
+                                              "Get",
+                                              g_variant_new ("(ss)", "org.freedesktop.DisplayManager", "Seats"),
+                                              G_VARIANT_TYPE ("(v)"),
+                                              G_DBUS_CALL_FLAGS_NONE,
+                                              1000,
+                                              NULL,
+                                              NULL);
+
+        status = g_string_new ("RUNNER LIST-SEATS SEATS=");
+        g_variant_get (result, "(v)", &value);
+        g_variant_get (value, "ao", &iter);
+        while (g_variant_iter_loop (iter, "&o", &path))
+        {
+            if (i != 0)
+                g_string_append (status, ",");
+            g_string_append (status, path);
+            i++;
+        }
+        g_variant_unref (value);
+        g_variant_unref (result);
+
+        check_status (status->str);
+        g_string_free (status, TRUE);
+    }
+    else if (strcmp (name, "LIST-SESSIONS") == 0)
+    {
+        GVariant *result, *value;
+        GString *status;
+        GVariantIter *iter;
+        const gchar *path;
+        int i = 0;
+
+        result = g_dbus_connection_call_sync (g_bus_get_sync (G_BUS_TYPE_SYSTEM, NULL, NULL),
+                                              "org.freedesktop.DisplayManager",
+                                              "/org/freedesktop/DisplayManager",
+                                              "org.freedesktop.DBus.Properties",
+                                              "Get",
+                                              g_variant_new ("(ss)", "org.freedesktop.DisplayManager", "Sessions"),
+                                              G_VARIANT_TYPE ("(v)"),
+                                              G_DBUS_CALL_FLAGS_NONE,
+                                              1000,
+                                              NULL,
+                                              NULL);
+
+        status = g_string_new ("RUNNER LIST-SESSIONS SESSIONS=");
+        g_variant_get (result, "(v)", &value);
+        g_variant_get (value, "ao", &iter);
+        while (g_variant_iter_loop (iter, "&o", &path))
+        {
+            if (i != 0)
+                g_string_append (status, ",");
+            g_string_append (status, path);
+            i++;
+        }
+        g_variant_unref (value);
+        g_variant_unref (result);
+
+        check_status (status->str);
+        g_string_free (status, TRUE);
+    }
     else if (strcmp (name, "SWITCH-TO-GREETER") == 0)
     {
         g_dbus_connection_call_sync (g_bus_get_sync (G_BUS_TYPE_SYSTEM, NULL, NULL),
@@ -544,9 +616,8 @@
             GError *error = NULL;
 
             length = strlen (command);
-            g_socket_send (client->socket, (gchar *) &length, sizeof (length), NULL, &error);
-            g_socket_send (client->socket, command, strlen (command), NULL, &error);
-            if (error)
+            if (g_socket_send (client->socket, (gchar *) &length, sizeof (length), NULL, &error) < 0 ||
+                g_socket_send (client->socket, command, strlen (command), NULL, &error) < 0)
                 g_printerr ("Failed to write to client socket: %s\n", error->message);
             g_clear_error (&error);
         }
@@ -808,7 +879,7 @@
 }
 
 static void
-start_upower_daemon ()
+start_upower_daemon (void)
 {
     service_count++;
     g_bus_own_name (G_BUS_TYPE_SYSTEM,
@@ -1082,7 +1153,7 @@
                    error->message);
     g_clear_error (&error);
     if (!login1_session_info)
-        return;
+        return NULL;
 
     g_dbus_connection_register_object (connection,
                                        session->path,
@@ -1259,7 +1330,7 @@
 }
 
 static void
-start_login1_daemon ()
+start_login1_daemon (void)
 {
     service_count++;
     g_bus_own_name (G_BUS_TYPE_SYSTEM,
@@ -1378,9 +1449,7 @@
         gchar **fields;
         guint uid;
         gchar *user_name, *real_name;
-        GList *link;
         AccountsUser *user = NULL;
-        GError *error = NULL;
 
         fields = g_strsplit (lines[i], ":", -1);
         if (fields == NULL || g_strv_length (fields) < 7)
@@ -1474,7 +1543,6 @@
     }
     else if (strcmp (method_name, "FindUserByName") == 0)
     {
-        GList *link;
         AccountsUser *user = NULL;
         gchar *user_name;
 
@@ -1660,9 +1728,6 @@
     if (getenv ("DEBUG"))
         g_string_append (command_line, " --debug");
     g_string_append_printf (command_line, " --cache-dir %s/cache", temp_dir);
-    g_string_append_printf (command_line, " --xsessions-dir=%s/usr/share/xsessions", temp_dir);
-    g_string_append_printf (command_line, " --remote-sessions-dir=%s/usr/share/remote-sessions", temp_dir);
-    g_string_append_printf (command_line, " --xgreeters-dir=%s/usr/share/xgreeters", temp_dir);
 
     test_runner_command = g_strdup_printf ("PATH=%s LD_PRELOAD=%s LD_LIBRARY_PATH=%s LIGHTDM_TEST_ROOT=%s DBUS_SESSION_BUS_ADDRESS=%s %s\n",
                                            g_getenv ("PATH"), g_getenv ("LD_PRELOAD"), g_getenv ("LD_LIBRARY_PATH"), g_getenv ("LIGHTDM_TEST_ROOT"), g_getenv ("DBUS_SESSION_BUS_ADDRESS"),
@@ -1820,9 +1885,9 @@
     /* Set up a skeleton file system */
     g_mkdir_with_parents (g_strdup_printf ("%s/etc", temp_dir), 0755);
     g_mkdir_with_parents (g_strdup_printf ("%s/usr/share", temp_dir), 0755);
-    g_mkdir_with_parents (g_strdup_printf ("%s/usr/share/xsessions", temp_dir), 0755);
-    g_mkdir_with_parents (g_strdup_printf ("%s/usr/share/remote-sessions", temp_dir), 0755);
-    g_mkdir_with_parents (g_strdup_printf ("%s/usr/share/xgreeters", temp_dir), 0755);
+    g_mkdir_with_parents (g_strdup_printf ("%s/usr/share/lightdm/sessions", temp_dir), 0755);
+    g_mkdir_with_parents (g_strdup_printf ("%s/usr/share/lightdm/remote-sessions", temp_dir), 0755);
+    g_mkdir_with_parents (g_strdup_printf ("%s/usr/share/lightdm/greeters", temp_dir), 0755);
     g_mkdir_with_parents (g_strdup_printf ("%s/tmp", temp_dir), 0755);
     g_mkdir_with_parents (g_strdup_printf ("%s/var/run", temp_dir), 0755);
     g_mkdir_with_parents (g_strdup_printf ("%s/var/log", temp_dir), 0755);
@@ -1852,15 +1917,15 @@
         perror ("Failed to copy configuration");
 
     /* Copy over the greeter files */
-    if (system (g_strdup_printf ("cp %s/xsessions/* %s/usr/share/xsessions", DATADIR, temp_dir)))
-        perror ("Failed to copy xsessions");
-    if (system (g_strdup_printf ("cp %s/remote-sessions/* %s/usr/share/remote-sessions", DATADIR, temp_dir)))
+    if (system (g_strdup_printf ("cp %s/sessions/* %s/usr/share/lightdm/sessions", DATADIR, temp_dir)))
+        perror ("Failed to copy sessions");
+    if (system (g_strdup_printf ("cp %s/remote-sessions/* %s/usr/share/lightdm/remote-sessions", DATADIR, temp_dir)))
         perror ("Failed to copy remote sessions");
-    if (system (g_strdup_printf ("cp %s/xgreeters/* %s/usr/share/xgreeters", DATADIR, temp_dir)))
-        perror ("Failed to copy xgreeters");
+    if (system (g_strdup_printf ("cp %s/greeters/* %s/usr/share/lightdm/greeters", DATADIR, temp_dir)))
+        perror ("Failed to copy greeters");
 
     /* Set up the default greeter */
-    path = g_build_filename (temp_dir, "usr", "share", "xgreeters", "default.desktop", NULL);
+    path = g_build_filename (temp_dir, "usr", "share", "lightdm", "greeters", "default.desktop", NULL);
     greeter = g_strdup_printf ("%s.desktop", argv[2]);
     if (symlink (greeter, path) < 0)
     {

=== modified file 'tests/src/test-session.c'
--- tests/src/test-session.c	2013-07-09 03:15:42 +0000
+++ tests/src/test-session.c	2013-07-23 02:24:45 +0000
@@ -1,7 +1,6 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
-#include <signal.h>
 #include <sys/types.h>
 #include <unistd.h>
 #include <fcntl.h>
@@ -10,6 +9,7 @@
 #include <glib.h>
 #include <glib-object.h>
 #include <gio/gio.h>
+#include <glib-unix.h>
 
 #include "status.h"
 
@@ -23,11 +23,20 @@
 
 static xcb_connection_t *connection;
 
-static void
-quit_cb (int signum)
-{
-    status_notify ("%s TERMINATE SIGNAL=%d", session_id, signum);
-    exit (EXIT_SUCCESS);
+static gboolean
+sigint_cb (gpointer user_data)
+{
+    status_notify ("%s TERMINATE SIGNAL=%d", session_id, SIGINT);
+    g_main_loop_quit (loop);
+    return TRUE;
+}
+
+static gboolean
+sigterm_cb (gpointer user_data)
+{
+    status_notify ("%s TERMINATE SIGNAL=%d", session_id, SIGTERM);
+    g_main_loop_quit (loop);
+    return TRUE;
 }
 
 static void
@@ -179,15 +188,15 @@
     if (g_str_has_suffix (open_fds->str, ","))
         open_fds->str[strlen (open_fds->str) - 1] = '\0';
 
-    signal (SIGINT, quit_cb);
-    signal (SIGTERM, quit_cb);
-
 #if !defined(GLIB_VERSION_2_36)
     g_type_init ();
 #endif
 
     loop = g_main_loop_new (NULL, FALSE);
 
+    g_unix_signal_add (SIGINT, sigint_cb, NULL);
+    g_unix_signal_add (SIGTERM, sigterm_cb, NULL);
+
     status_connect (request_cb);
 
     if (argc > 1)

=== modified file 'tests/src/unity-system-compositor.c'
--- tests/src/unity-system-compositor.c	2013-06-24 00:14:28 +0000
+++ tests/src/unity-system-compositor.c	2013-07-22 22:21:02 +0000
@@ -2,6 +2,8 @@
 #include <stdio.h>
 #include <string.h>
 #include <errno.h>
+#include <unistd.h>
+#include <glib-unix.h>
 
 #include "status.h"
 
@@ -18,11 +20,20 @@
     g_main_loop_quit (loop);
 }
 
-static void
-signal_cb (int signum)
-{
-    status_notify ("UNITY-SYSTEM-COMPOSITOR TERMINATE SIGNAL=%d", signum);
-    quit (EXIT_SUCCESS);
+static gboolean
+sigint_cb (gpointer user_data)
+{
+    status_notify ("UNITY-SYSTEM-COMPOSITOR TERMINATE SIGNAL=%d", SIGINT);
+    quit (EXIT_SUCCESS);
+    return TRUE;
+}
+
+static gboolean
+sigterm_cb (gpointer user_data)
+{
+    status_notify ("UNITY-SYSTEM-COMPOSITOR TERMINATE SIGNAL=%d", SIGTERM);
+    quit (EXIT_SUCCESS);
+    return TRUE;
 }
 
 typedef enum
@@ -67,7 +78,7 @@
     }
     if (n_read != 4)
     {
-        g_printerr ("Short read for header, %d instead of expected 4\n", n_read);
+        g_printerr ("Short read for header, %zi instead of expected 4\n", n_read);
         return FALSE;
     }
     id = header[0] << 8 | header[1];
@@ -80,7 +91,7 @@
     }
     if (n_read != payload_length)
     {
-        g_printerr ("Short read for payload, %d instead of expected %d\n", n_read, payload_length);
+        g_printerr ("Short read for payload, %zi instead of expected %d\n", n_read, payload_length);
         return FALSE;      
     }
 
@@ -123,11 +134,9 @@
 main (int argc, char **argv)
 {
     int i;
+    GString *status_text;
     gboolean test = FALSE;
-
-    signal (SIGINT, signal_cb);
-    signal (SIGTERM, signal_cb);
-    signal (SIGHUP, signal_cb);
+    int vt_number = -1;
 
 #if !defined(GLIB_VERSION_2_36)
     g_type_init ();
@@ -135,6 +144,9 @@
 
     loop = g_main_loop_new (NULL, FALSE);
 
+    g_unix_signal_add (SIGINT, sigint_cb, NULL);
+    g_unix_signal_add (SIGTERM, sigterm_cb, NULL);
+
     status_connect (request_cb);
 
     for (i = 1; i < argc; i++)
@@ -153,7 +165,7 @@
         }
         else if (strcmp (arg, "--vt") == 0)
         {
-            //vt_number = atoi (argv[i+1]);
+            vt_number = atoi (argv[i+1]);
             i++;
         }
         else if (strcmp (arg, "--test") == 0)
@@ -164,10 +176,13 @@
 
     g_io_add_watch (g_io_channel_unix_new (from_dm_fd), G_IO_IN, read_message_cb, NULL);
 
+    status_text = g_string_new ("UNITY-SYSTEM-COMPOSITOR START");
+    if (vt_number >= 0)
+        g_string_append_printf (status_text, " VT=%d", vt_number);
     if (test)
-        status_notify ("UNITY-SYSTEM-COMPOSITOR START TEST");
-    else
-        status_notify ("UNITY-SYSTEM-COMPOSITOR START");
+        g_string_append (status_text, " TEST=TRUE");
+    status_notify (status_text->str);
+    g_string_free (status_text, TRUE);
 
     config = g_key_file_new ();
     g_key_file_load_from_file (config, g_build_filename (g_getenv ("LIGHTDM_TEST_ROOT"), "script", NULL), G_KEY_FILE_NONE, NULL);

=== modified file 'tests/src/x-server.c'
--- tests/src/x-server.c	2013-06-12 05:45:30 +0000
+++ tests/src/x-server.c	2013-07-20 08:49:28 +0000
@@ -91,7 +91,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (XClientClass, disconnected),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
 }
 
@@ -196,7 +196,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (XServerClass, client_connected),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
+                      NULL,
                       G_TYPE_NONE, 1, x_client_get_type ());
     x_server_signals[X_SERVER_CLIENT_DISCONNECTED] =
         g_signal_new ("client-disconnected",
@@ -204,6 +204,6 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (XServerClass, client_disconnected),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__OBJECT,
+                      NULL,
                       G_TYPE_NONE, 1, x_client_get_type ());
 }

=== modified file 'tests/src/xdmcp-client.c'
--- tests/src/xdmcp-client.c	2013-06-17 00:12:49 +0000
+++ tests/src/xdmcp-client.c	2013-07-20 08:49:28 +0000
@@ -443,7 +443,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (XDMCPClientClass, query),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__VOID,
+                      NULL,
                       G_TYPE_NONE, 0);
     xdmcp_client_signals[XDMCP_CLIENT_WILLING] =
         g_signal_new ("willing",
@@ -451,7 +451,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (XDMCPClientClass, willing),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__POINTER,
+                      NULL,
                       G_TYPE_NONE, 1, G_TYPE_POINTER);
     xdmcp_client_signals[XDMCP_CLIENT_ACCEPT] =
         g_signal_new ("accept",
@@ -459,7 +459,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (XDMCPClientClass, accept),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__POINTER,
+                      NULL,
                       G_TYPE_NONE, 1, G_TYPE_POINTER);
     xdmcp_client_signals[XDMCP_CLIENT_DECLINE] =
         g_signal_new ("decline",
@@ -467,7 +467,7 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (XDMCPClientClass, decline),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__POINTER,
+                      NULL,
                       G_TYPE_NONE, 1, G_TYPE_POINTER);
     xdmcp_client_signals[XDMCP_CLIENT_FAILED] =
         g_signal_new ("failed",
@@ -475,6 +475,6 @@
                       G_SIGNAL_RUN_LAST,
                       G_STRUCT_OFFSET (XDMCPClientClass, failed),
                       NULL, NULL,
-                      g_cclosure_marshal_VOID__POINTER,
+                      NULL,
                       G_TYPE_NONE, 1, G_TYPE_POINTER);
 }

=== added file 'tests/test-dbus'
--- tests/test-dbus	1970-01-01 00:00:00 +0000
+++ tests/test-dbus	2013-07-19 08:47:37 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner dbus test-gobject-greeter

=== added file 'tests/test-greeter-allow-guest'
--- tests/test-greeter-allow-guest	1970-01-01 00:00:00 +0000
+++ tests/test-greeter-allow-guest	2013-07-22 03:13:13 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner greeter-allow-guest test-gobject-greeter

=== added file 'tests/test-greeter-default-session'
--- tests/test-greeter-default-session	1970-01-01 00:00:00 +0000
+++ tests/test-greeter-default-session	2013-07-22 02:52:22 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner greeter-default-session test-gobject-greeter

=== added file 'tests/test-greeter-hide-users'
--- tests/test-greeter-hide-users	1970-01-01 00:00:00 +0000
+++ tests/test-greeter-hide-users	2013-07-22 03:01:26 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner greeter-hide-users test-gobject-greeter

=== added file 'tests/test-greeter-show-manual-login'
--- tests/test-greeter-show-manual-login	1970-01-01 00:00:00 +0000
+++ tests/test-greeter-show-manual-login	2013-07-22 03:05:10 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner greeter-show-manual-login test-gobject-greeter

=== added file 'tests/test-greeter-show-remote-login'
--- tests/test-greeter-show-remote-login	1970-01-01 00:00:00 +0000
+++ tests/test-greeter-show-remote-login	2013-07-22 03:07:36 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner greeter-show-remote-login test-gobject-greeter

=== added file 'tests/test-language-env'
--- tests/test-language-env	1970-01-01 00:00:00 +0000
+++ tests/test-language-env	2013-07-21 07:47:05 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner language-env test-gobject-greeter

=== added file 'tests/test-login-gobject-remember-session'
--- tests/test-login-gobject-remember-session	1970-01-01 00:00:00 +0000
+++ tests/test-login-gobject-remember-session	2013-07-17 21:20:32 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner login-remember-session test-gobject-greeter

=== added file 'tests/test-login-python-remember-session'
--- tests/test-login-python-remember-session	1970-01-01 00:00:00 +0000
+++ tests/test-login-python-remember-session	2013-07-17 21:20:32 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner login-remember-session test-python-greeter

=== added file 'tests/test-login-qt4-remember-session'
--- tests/test-login-qt4-remember-session	1970-01-01 00:00:00 +0000
+++ tests/test-login-qt4-remember-session	2013-07-17 21:20:32 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner login-remember-session test-qt4-greeter

=== added file 'tests/test-login-qt5-remember-session'
--- tests/test-login-qt5-remember-session	1970-01-01 00:00:00 +0000
+++ tests/test-login-qt5-remember-session	2013-07-17 21:20:32 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner login-remember-session test-qt5-greeter

=== added file 'tests/test-session-env'
--- tests/test-session-env	1970-01-01 00:00:00 +0000
+++ tests/test-session-env	2013-07-19 09:44:06 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner session-env test-gobject-greeter

=== added file 'tests/test-unity-plymouth'
--- tests/test-unity-plymouth	1970-01-01 00:00:00 +0000
+++ tests/test-unity-plymouth	2013-07-19 11:03:29 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner unity-plymouth test-gobject-greeter

=== added file 'tests/test-xdmcp-client'
--- tests/test-xdmcp-client	1970-01-01 00:00:00 +0000
+++ tests/test-xdmcp-client	2013-07-20 08:52:11 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner xdmcp-client test-gobject-greeter

=== renamed file 'tests/test-xdmcp-login' => 'tests/test-xdmcp-server-login'
--- tests/test-xdmcp-login	2012-01-13 13:05:33 +0000
+++ tests/test-xdmcp-server-login	2013-07-20 08:52:11 +0000
@@ -1,2 +1,2 @@
 #!/bin/sh
-./src/dbus-env ./src/test-runner xdmcp-login test-gobject-greeter
+./src/dbus-env ./src/test-runner xdmcp-server-login test-gobject-greeter

=== renamed file 'tests/test-xdmcp-open-file-descriptors' => 'tests/test-xdmcp-server-open-file-descriptors'
--- tests/test-xdmcp-open-file-descriptors	2012-03-05 00:23:32 +0000
+++ tests/test-xdmcp-server-open-file-descriptors	2013-07-20 08:52:11 +0000
@@ -1,2 +1,2 @@
 #!/bin/sh
-./src/dbus-env ./src/test-runner xdmcp-open-file-descriptors test-gobject-greeter
+./src/dbus-env ./src/test-runner xdmcp-server-open-file-descriptors test-gobject-greeter

